			SWI-Prolog ChangeLog
			====================

					--------------------------------------
					NOTE: Bug #<N> refers to bugs reported
					to the SWI-Prolog Bugzilla system at
					http://gollem.science.uva.nl/bugzilla/
					--------------------------------------

==============================
VERSION 5.6.14 (June 13, 2006)
==============================

  * FIXED: Bugs in new url.pl.  Jiri Moninec.

==============================
VERSION 5.6.13 (June 07, 2006)
==============================

  * FIXED: Multi-threaded problem in dynamic predicate reindexing. 
    Thanks to test program by Sergey Tikhonov.

  * FIXED: Atom-GC crash related to dynamic predicates.  Thanks to test
    program by Sergey Tikhonov.

  * FIXED: Bug#168: library(url), www_form_encode/2 to perform
    UTF-8 based Unicode encoding and decoding.  Library now based on current
    RFC3986.

  * ADDED: library(utf8): provide encoding and decoding of UTF-8 strings.

  * FIXED: handling errors from the handler of call_cleanup/3.  Bart
    Demoen and Marek Winkler.

  * FIXED: wrong error and possible crash if format/3 finds an illegal ~
    sequence.   Pierpaolo Bernardi.

===============================
VERSION 5.6.12 (April 18, 2006)
===============================

  * FIXED: Possible crash in call-back from C due to wrong timing of stack
    allocation.  Very old bug.  Affects all versions and all programs,
    though XPCE applications are extra vulnerable due to frequent call-backs.
    Jochem Liem.

===============================
VERSION 5.6.11 (April 11, 2006)
===============================

  * FIXED/MODIFIED: function truncate/1 to return an integer instead of
    a float.  Graham Thwaites.

  * MODIFIED: portray_clause/1,2 and write_canonical/1,2 print singleton
    variables as _ and write_canonical/1,2 prints its variables as A, B, ...
    Paulo Moura.

  * ADDED: Option 'singletons(true)' to numbervars/4 to bind singleton
    variables to '$VAR'('_').

  * FIXED: Bug#163: make XREF aware of format_predicate directives.  Holger
    Kanwischer.

===============================
VERSION 5.6.10 (April 06, 2006)
===============================

  * FIXED: mutex_destroy/1.  Lukas Degener.

  * FIXED: online help without XPCE.  Also some cleanup of the online
    help module.  Sergey Tikhonov.

  * FIXED: XREF: avoid showing XPCE internal predicates.  Fixed import
    into module files doing M:G calls.

  * DOC: Many typos fixed in the documentation by Paulo Moura.  Thanks!

  * FIXED/MODIFIED: thread_send_message/2, thread_get_message/2,
    thread_peek_message/2 and message_queue_size/2 now raise an exception
    if the queue doesn't exist instead of creating a queue.  Paulo
    Moura.

  * ADDED: Library ugraphs.pl.  Unweigthed graph library.  Copied from
    YAP.  Integrated into SWI-Prolog library and documentation.

  * FIXED: Bug#160: Track called as result of auto-import from module
    user.  Holger Kanwischer.

  * FIXED: Bug#158: XREF handling of arithmetic_function directive with
    module qualifier.  Holger Kanwischer.

  * CLEANUP: Removed win32s support (windows 3.1 extender).

  * MODIFIED: use goal_expansion/2 on directives.

  * ADDED/MODIFIED: library-independent unicode support for parsing text.
    This modified atom/variable syntax for sourcecode holding characters
    above 255.  Also made changes to singleton variable handling.  See
    manual for details (section "Unicode Prolog source").

  * FIXED: possible crash after abort.

  * FIXED/ENHANCED: Cross-referencer: fixed two runtime errors.  Added support
    for M:P calls (bug#154).  Allow dropping directories from file-tree to
    dependency view.  Give the user something to see during the analysis.


==============================
VERSION 5.6.9 (March 26, 2006)
==============================

  * ADDED: library(prolog_xref): Cross-referencer core.  Documented cross
    referencer interfaces

  * FIXED: exception hook clears debugmode.

  * PORT: Some Windows path problems and cleanup issues.  Patch by
    Marc-Antoine Ruel.

  * FIXED: Behaviour of term_variables/2,3 in the tracer.  Leslie de
    Koninck.

==============================
VERSION 5.6.8 (March 12, 2006)
==============================

  * FIXED: Kill xterms associated with threads on halt.

  * PORT: port open_xterm/4 to MacOS X.

  * ADDED: Moved thread-debugging utilities from SeRQL library to main
    library and documented them.  gdebug, tdebug, tnodebug, tspy, tprofile.
    See chapter on threads for details.  Avoid attaching a console on debug
    mode when using the graphical debugger.

  * FIXED: Handle exceptions from arithmetic functions defined in Prolog.
    Mauro Di Nuzzo.

==============================
VERSION 5.6.7 (March 08, 2006)
==============================

  * FIXED: format ~w: report errors of write/1. Matt Lilley.

  * FIXED: Memory leak in format ~f using rational numbers as arguments.
    Mike Elston.

  * PORT: Float issues on Alpha.  Roberto Bagnara.  Also found a bug in
    GCC 4.0.2 on Alpha/Linux.  Reported to GCC bugzilla. Turned out to
    be a bug in the kernel headers.  Uncomment HAVE_GETTID in config.h
    on systems with 2.4 kernels.

  * ADDED: allow `repairing' undefined global variables.  After discussion
    on mailinglist.

=================================
VERSION 5.6.6 (February 24, 2006)
=================================

  * FIXED: Bug in prolog_exception_hook/4 if handler failed.

  * FIXED: Bug#147: Unicode support in win_registry_get_value/3.  Dmitry.

  * FIXED: removed call to xrealloc().  Roberto Bagnara.

  * FIXED: handling of default argument stack limits.  Used for dealing
    with cyclic terms.

=================================
VERSION 5.6.5 (February 16, 2006)
=================================

  * MODIFIED: various internals in library(prolog_stack).  Code relying on
    the Prolog structure for representing the stack must be updated.

  * FIXED: incompatibility in DCG handling introduced by recent changes.

  * ADDED: prolog_exception_hook/4: add context to exceptions.  After
    discussion on the mailinglist.

  * ENHANCED: Use call_cleanup in findall/3 and friends to enhance error
    recovery.  Added more test cases.

  * FIXED: GC issue in PL_discard_foreign_frame().  Notably shows up in
    embeded C++ applications, but affect a wider class of programs.
    The bug often shows up as a GC internal error of the form
    After down phase: relocation_cells = X; relocated_cells = Y,
    but other problems can be caused by it as well.  Alan Baljeu.  

  * PORT/CLEANUP: Various issues around setenv/2 and unsetenv/1.  Richard
    O'Keefe.

  * FIXED: proper error signalling in rdiv/2 on division-by-zero.  Mike
    Elston.

  * MODIFIED: new AVL implementation of library(assoc) from work by various
    authors, merged and documented by Markus Triska.  The argument order of
    gen_assoc/3 has been modified from the original DEC10 library 
    for compatibility woth Quintus and SICStus.

  * ENHANCED: Try to be more clever finding a browser. Jochem Liem.

  * FIXED: arg/3 documentation.  Markus Triska.

=================================
VERSION 5.6.4 (February 12, 2006)
=================================

  * FIXED: copy_term_nat/2 deleted attributes from term being copied.
    Leslie de Koninck.

  * MODIFIED: Added byte-position to stream-position terms.  This means
    that code relying on $stream_position(Char,Line,LinePos) breaks. The
    new version provides stream_position_data/3 (compatible to SICStus)
    for extracting the field in a portable manner.

  * PORT: Pass main compiler CFLAGS using plld.  Richard O'Keefe.

  * PORT: Fixed paths when using install-sh.  Richard O'Keefe.

  * ENHANCED: translation of t --> [a,b], ....  Richard O'Keefe.

  * FIXED: Bug#140: Various DESTDIR issues when installing the PDF
    documentation. Keri Harris.

  * ADDED: \uXXXX and \UXXXXXXXX syntax support and various enhancements
    in read and write as well as the documentation of escape sequences.
    Richard O'Keefe.

  * Make test suite skip Unicode filename and character classification
    tests in non-unicode environments. 

  * FIXED: Allow for ISO :- dynamic([a/1, b/2]).   Roger Scowen.

  * ENHANCED: Better error messages if locale cannot represent filenames.
    Richard O'Keefe.

  * PORT: Better check for GMP support, better message if GMP is not found
    and cleanup of test-suite to skip all GMP dependent tests if GMP is
    not present.

  * MODIFIED: Renamed library(netscape) into library(www_browser).  Extended
    and modernised browser detection.  Now also works on MacOSX.

  * ADDED: Allow calling PL_new_functor() before PL_initialise().


================================
VERSION 5.6.3 (January 19, 2006)
================================

  * FIXED: unify_with_occurs_check/2 fails to to occurs-check with
    attributed variables.  Tom Schrijvers.

  * FIXED: Thread resource exception handling in Linux 2.6.  Keri Harris.

================================
VERSION 5.6.2 (January 13, 2006)
================================

  * FIXED: writing of escape sequences for representation_errors(prolog)
    on streams.  Also fixed reading of '\x61\' and similar sequences.
    Pierre Nugues.

  * FIXED: Make thread time statistics work properly in Linux 2.6 kernels.
    Also some cleanup of the statistics code.

  * FIXED: Bind prolog flag system_thread_id to the thread identifier on
    Linux in 2.6 kernels.

  * FIXED: readline signal interaction (causes problems in alarm/4).

  * FIXED: Bug#134: left-shift (<<) hitting 64-bit boundary.  Holger
    Kanwischer.

  * FIXED: Bug#133: reading non-decimal numbers that do not fit in 64-bit.
    Holger Kanwischer.

  * FIXED: Bug#132: radix domain checking for format/3 using ~r.
    Holger Kanwischer.

================================
VERSION 5.6.1 (January 10, 2006)
================================

  * CLEANUP: Various type issues.  Peter Ludemann.

  * FIXED: Bug#131: error handling in lock-option of open/4.
    Holger Kanwischer.

  * FIXED: stream_property(X, alias(A)) for standard streams.  Paulo Moura.

  * FIXED: Bug#130: Prolog arithmetic functions using rationals.  Koos Dering.

  * FIXED: Online manual index handling (double 'Overview').   
    Pierpaolo BERNARDI.

  * FIXED: expand_term/2 bypass expansion for variables.  Paulo Moura.

=================================
VERSION 5.6.0 (December 22, 2005)
=================================

  * FIXED: Float/integer indexing problems that can cause both slow access
    and much too large datastructures for the index.

  * PORT: pl-stream.h: avoid 'new' (work around MSVC 7 bug).  Alan Baljeu.

  * PORT: Visual studio 2003 (MSVC 8) issues.  Basic Prolog passes the
    test suite, but XPCE crashes quickly.

==================================
VERSION 5.5.40 (December 07, 2005)
==================================

  * ADDED: prolog flag timezone.

  * ADDED: Foreign functions to exchange GMP numbers.  Roberto Bagnara.

  * FIXED: library(listing) sending some of its output to current output
    rather than the specified stream.

  * ENHANCED: More flexible matching in library(prolog_clause).


==================================
VERSION 5.5.39 (November 29, 2005)
==================================

  * FIXED: Bug#122: Crash in GC on last-call to an autoloaded procedure
    where the autoloader calls the garbage collector.  Fabien Todescato.

  * PORT: More Cygwin issues by Corinna Vinschen.

  * FIXED: library(occurs), occurrences_of_*() predicates to be thread-safe.

  * ADDED: Started package `nlp', providing some basics from the natural
    language processing and information retrieval community.  Currently
    stripping accents, Porter stem and Double Metaphone.

  * ADDED: library('clp/simplex') for solving linear programming problems.
    Contributed by Markus Triska.

  * FIXED: floor and ceil using rational numbers.  Markus Triska.

==================================
VERSION 5.5.38 (November 18, 2005)
==================================

  * FIXED: Add support for attributed variables in unify_with_occurs_check/2.
    Tom Schrijvers.

  * PORT: Added many patches for updated support for the Cygwin environment.
    Contributed by Corinna Vinschen, Redhat.  Work in progress.

  * FIXED: Possible crash in meta-calling large terms.  Matt Lilley.

  * FIXED: avoid loosing the next input character after abort.

  * FIXED: memory leak and off-by-one buffer overflow reading from the
    console through GNU readline.

  * ADDED: Ssetenc() to negotiate manipulation of stream encoding.  Used
    to protect encoding on plwin.exe as well as pce_open/3 for anything
    but socket-related streams.

  * FIXED: Bug#118: interaction numbervars and ignore_ops options in
    write_term.  Bart Demoen.


==================================
VERSION 5.5.37 (November 12, 2005)
==================================

  * FIXED: Memory leak in arithmetic combining GMP numbers with floats.
    Dmitry.

  * FIXED: plld: schedule .a files with the libraries.  Roberto Bagnara.

  * FIXED: Bug#116: shell/0 on Windows.  Dmitry.

  * FIXED: QLF and saved-state handling of big clauses (>65000 VM
    codes).  Matt Lilley.

  * ADDED: functions lsb/1 and popcount/1 to improve support for handling
    GMP numbers as bitvectors.  Enhanced clp_distinct.pl to use these
    functions.  Suggested by Markus Triska.

  * ADDED: library(clp/clp_distinct.pl).  Contributed by  Markus Triska.

  * COMPAT: prolog_load_context/2 to support the SICStus key `source'.
    Bart Demoen.

  * PORT: Bug#109: Added --disable-custom-flags for configure.  
    Mike Frysinger.

  * ENHANCED: locale based detection of natively (UTF-8 or ISO Latin-1)
    supported encodings.  Richard O'Keefe.

  * ADDED: library(clp/clp_tuples.pl), Symbolic constraints on tuples.
    Later moved these predicates to clp/bounds.pl. Contributed by
    Markus Triska.

  * PORT: Bug#110: Solaris float handling.  Andreas Vögele.

  * FIXED: IO_RECORDPOS handling.  Bug exposed by changes for UTF-16 I/O
    on Windows.  Dmitry and Holger Kanwischer.

=================================
VERSION 5.5.36 (October 24, 2005)
=================================

  * FIXED: UTF-16 I/O on Windows systems.  Dmitry.

  * FIXED: integer arithmetic returning results between -1<<63 and -1<<31.
    Leslie de Koninck.

=================================
VERSION 5.5.35 (October 19, 2005)
=================================

  * ENHANCED: delete choicepoint of catch/3, maintaining last call
    optimization in goals using catch/3 on deterministic code.  Leslie
    de Koninck.

  * FIXED: Bug#104: float formatting.  Holger Kanwischer.

  * FIXED: Memory leak in sformat/3.  Mike Elston.

=================================
VERSION 5.5.34 (October 11, 2005)
=================================

  * PORT: Deal with systems that breakdown arguments of #! scripts.

  * ADDED: message_queue_size/2.  Woon Kiong.

  * FIXED: Singleton warning for variables with Unicode name.  Dmitry.

  * PORT: Bug#90: parallel make.  Mike Frysinger.

  * PORT: Bug#97: Some packages configure issues.  Mike Frysinger.

  * FIXED: abs/1 for large integers and rationals.  Mike Elston.

===================================
VERSION 5.5.33 (September 30, 2005)
===================================

  * FIXED: when/2: unifyable -->unifiable.  Grzegorz Chrupała.

  * ADDED: Allow hooking into output of library(debug).  Added XPCE Gui
    frontend for the debugging library called with prolog_debug_monitor/0.

  * FIXED: Prevent recursive calling of Sclose().

  * ADDED: Win32: current_prolog_flag(pid, Pid).

===================================
VERSION 5.5.32 (September 26, 2005)
===================================

  * FIXED: Typo in new PL_unify_term() conversions.

  * PORT: Allow for CFLAGS=xx ./configure.  Use LDFLAGS when building
    plrc.  Tim Brown.

  * FIXED: Initialisation bug in format/3.  Sergey Tikhonov.

  * FIXED: upcase_atom/2 and downcase_atom/2 for atoms holding characters
    in the range 128..255 but not > 255 as well as for 8-bit atoms whose
    converted version does not fit in 8-bit.  Grzegorz Chrupała.


===================================
VERSION 5.5.31 (September 19, 2005)
===================================

  * PORT: Bug#94: compilation error in pl-flag.c.  Christoph Quix.

  * ADDED: library(url): protocol https.  Anjo Anjewierden.

  * ADDED: Extra conversion arguments to PL_unify_term() to pass strings
    as wchar_t* as well as in the current locale.  Sergey Tikhonov.

  * FIXED: Retry after executing a ! to do proper undo.   Alan Baljeu.

  * FIXED: library(url): allow "-_~" in hostnames.  Jacco van Ossenbruggen.

  * PORT: Bug#90: Fix Prolog Makefile for parallel make.  Mike Frysinger.

  * ENHANCED: Faster merging of memory left from terminated threads.  Code
    contributed by Servey Tikhonov.

  * FIXED: shell/[1,2] when executed by multiple threads (Unix version).

  * ENHANCED: Safer abort from format/[2,3].


===================================
VERSION 5.5.30 (September 12, 2005)
===================================

  * ADDED: library(nb_set): manipulate non-backtrackable sets of terms.

  * FIXED: Re-loading files while other threads execute them.

  * FIXED: Bug#88: Safe reloading of running code.  Dmitry.

  * FIXED: Unicode handling in read/1 for \-escape sequences
    Lyosha Ilyukhin.


===================================
VERSION 5.5.29 (September 07, 2005)
===================================

  * FIXED: library(url) bug re-appeared due to version management problems.


===================================
VERSION 5.5.28 (September 05, 2005)
===================================

  * FIXED: Bug#82: Make win_shell/[2,3] Unicode aware.  Dmitry.

  * MODIFIED: renamed assume/1 to assertion/1.  Suggested by Steve Moyle.
    The debug library issues a compatibility warning for assume/1.

  * MODIFIED: Translate {} in DCG to true.  Allows for
    t --> {/*comment*/}, ... without error.  Michael Mueller.

  * PORT: Added Slackware package management targets.  John Poplett.

  * FIXED: Safe 64-bit integer multiplication before moving to bignum
    or error.  With help from Bart Demoen.

  * MODIFIED: No longer convert the result of arithmetic that is float
    but happens to be an integer into the integer.  This habbit was not
    ISO compatible and critized too often.

  * ADDED: is_stream/1.  Jocelyn Paine.

  * FIXED: Bug#80: floor/1 and ceil/1 functions to create a big integer
    instead of an integer overflow exception.  Holger Kanwischer.

  * FIXED: Bug#78: documentation of bounded, max_integer and min_integer
    flags.  Holger Kanwischer.

  * ADDED: function rationalize/1, predicate rational/1.  Make number/1
    succeed on rational numbers.

  * MODIFIED: renamed rat/1 to rational/1.

  * FIXED: abs/1 on integers (caused by gmp changes).

  * FIXED: make function integer/1 rational-aware.  Lyosha Ilyukhin.

  * FIXED: converting `whole' rationals to integers.  Lyosha Ilyukhin.

  * FIXED: increment save-version of qlf-files as new instructions for GMP
    causes incompatibilities.

  * FIXED: Crash in retract/1 (caused by gmp changes).

  * FIXED: handling @ in format/3.  David Duke.

  * FIXED: format ~f for rational numbers loosing digits.  Lyosha Ilyukhin.

  * ADDED: Allow format arguments to ~d, ~D, ~f, ~g, ~e to be arithmetic
    expressions (allows passing in rational values).

  * MODIFIED: Dropped int_to_atom/3.  Considered non-standard and absolete.
    New code can use atom_number/2 for decimal numbers or sformat/3 for
    arbitrary conversions.

  * FIXED: Hack in clp/bounds.pl to fake +/- infinite.

  * ADDED: Elementary support for infinite precision arithmetic based on
    the GNU gmp library.

================================
VERSION 5.5.26 (August 12, 2005)
================================

  * FIXED: library(ordset), ord_del_element/3.  Mike Elston.

  * FIXED: PL_get_chars() to revert to write if CVT_WRITE is provided.

================================
VERSION 5.5.25 (August 05, 2005)
================================

  * ADDED: thread_initialization/1, as a per-thread version of
    inititialization/1.

  * FIXED: loading library(chr).  Mike Elston.

================================
VERSION 5.5.24 (August 04, 2005)
================================

  * ADDED: documented in_pce_thread/1.

  * MODIFIED: Operator ambiguity resolution, preferring prefix over
    infix.  Sentences of the form "pre inpre atom" are read as
    pre(inpre(atom)) instead of inpre(pre, atom) if both interpretations
    are allowed.  This is the de-facto standard, tested on SICStus,
    GNU, YAP and Ciao.  Needed for lptp (www.inf.ethz.ch/~staerk/lptp.html)
    After comments from various people, including Bart Demoen and 
    Joachim Schimpf.

  * FIXED: format/3: rubber handling error printing numeric values.

  * FIXED: Bug#73: honour char_conversion flag.  Holger Kanwischer.

  * FIXED: CanoniseDir() caching issues for absolute_file_name/[2,3].
    Wim Delvaux.

  * PORT: Bug#70: Use inttypes.h instead of stdint.h for portability.
    Andreas Vögele.

  * FIXED: atom_concat(X, a, a).  Mike Elston.

  * FIXED: Added two missing CHR files to the Windows installer.  Mike
    Elston.  Replaced the w32pl5523.exe installer on July 26.  Source
    update of MS-Windows makefiles and installer-generator will be in
    5.5.24.


==============================
VERSION 5.5.23 (July 24, 2005)
==============================

  * ENHANCED: add readline.so/dll to the clib package and make
    library(readutil) decide at runtime to use the foreign or Prolog
    implementation.

  * ENHANCED: Handle incomplete .QLF files through print_message/2.

  * FIXED: Bug#69: file_name_extension/2 not functioning properly on Windows.  
    Due to conflict between REP_UTF8 and new CVT_EXCEPTION flag.  Changed the
    value for the latter.  Foreign language code using this flag must be
    recompiled.  Holger Kanwischer. 


==============================	
VERSION 5.5.22 (July 15, 2005)
==============================

  * FIXED: predicateName for predicates using wide-characters in their
    name.

  * FIXED: Bug#59: QLF (Quick load files and saved states not storing
    atoms correctly if they contain characters >= 256.  (Dmitry).  Also
    fixed strings for this issue.

  * FIXED/MODIFIED: Typo unifyable/3 --> unifiable/3 (Richard O'Keefe).
    The predicate is used internally for dif/2.  Considering it is not
    around very long, I believe there will be very few users of it.
    Code using unifyable/3 must be updated.

  * FIXED: Bug#67: Crash in parsing 0'<unicode char>.  Also fixed parsing
    solo Unicode characters.  Holger Kanwischer.


VERSION 5.5.21 (July 05, 2005)
==============================

  * PORT: Float classification for NaN and infinity.  Better portable.

  * ENHANCED: MS-Windows: remove 256 character paste-limit from plwin
    console.  Steve Moyle.

  * FIXED: float formatting in atom_number/2, etc.  Richard O'Keefe

  * ADDED: Documentation of the gensym library.

  * FIXED: parse_url(-, +) to insert %XX escape sequences for characters
    that are not allowed in path-name or fragment names.

  * FIXED: pl -dump-runtime-variables value for PLLIB in single-threaded
    version.  Roberto Bagnara.

  * FIXED: Bug#64: Error handling for failing Prolog arithmetic functions.
    Roland Illig.

  * FIXED: unifyable/3 corrupts the stacks when called with variables
    living on the local stack.  This notably affects dif/2.  Hugo Ferreira.  


VERSION 5.5.20 (June 30, 2005)
==============================

  * FIXED: Write for floats always uses the C locale decimal point (.).
    Hugo Ferreira.

  * FIXED: Unicode handling in filenames associated with streams (error
    reporting and prolog_load_context/2).

  * FIXED: Unicode support for environment variables (non-Windows version).

  * FIXED: Unicode handling of commandline arguments.

  * FIXED: Bug#56: UNICODE handling for shell/1 and win_exec/2.  Dmitry.

  * FIXED: absolute_file_name/2 and friends for UNICODE filenames on
    windows platforms.

  * FIXED: Bug#59: seek/4 on output streams.  Holger Kanwischer.


VERSION 5.5.19 (May 24, 2005)
=============================

  * ADDED: PL_query(PL_QUERY_USER_CPU) to get portable CPU statistics.


VERSION 5.5.18 (May 20, 2005)
=============================

  * FIXED: Bug#44 ?=(X,Y) in when/2.  Roy Haddad and Tom Schrijvers.


VERSION 5.5.17 (May 09, 2005)
=============================

  * PORT: Bug#43: remove / after $(DESTDIR) to avoid paths starting
    with //.  Causes problems on Cygwin.  Dmitry.

  * MODIFIED: Allow for goal_expansion/2 on named meta-predicates.

  * FIXED: nb_setarg/3 using float arguments.

  * FIXED: setarg/nb_setarg allows to overwrite the functor using Index
    = 0.

  * ENHANCED: do 1st argument indexing on floats.

  * PORT: Prefer library ncursesw.  Unclear what this means, but might
    solve some issues on MacOS X.

  * FIXED: Bug#40: Unable to `ungetc' multibyte codes under some 
    circumstances.  Grzegorz Chrupala.

  * FIXED: Bug#38: incorrect spacing in write_term on Unicode characters.
    Dmitry.


VERSION 5.5.16 (May 02, 2005)
=============================

  * FIXED: hash_term/2: various problems handling compound terms:
    instable results, undefined results on terms with shared
    subterms.  Hugo Ferreira.

  * FIXED: PL_new_atom_wchars() did not canonise the atom representation,
    so PL_new_atom_wchars(2, L"nl") != PL_new_atom_nchars(2, "nl").  Paul
    Singleton.


VERSION 5.5.15 (April 22, 2005)
===============================

  * FIXED: Bug#32: offset in colouring using cyrillic data.  Actually
    a bug in subterm_positions option of read_term (Dmitry).

  * ENHANCED: The functions min and max to return one of the values 
    rather then converting to float.  Avoids rounding errors on large
    integers.  Markus Triska.

  * FIXED: thread_get_message/[1,2] using a lot of system time on some
    Unix based platforms.  Jacco van Ossenbruggen.

  * FIXED: alignment for some platforms (Andreas Schwab).

  * PORT: Made compilation clean for GCC 4.0.  Work with Stefan Dirsch
    from SuSE preparing for the next SuSE release.

  * MODIFIED: renamed option initfile for qsave_program/2 to init_file.
    Inconsistent with the documentation and the rest of the system calls
    it init_file as well.  Mike Elston.

  * FIXED: two memory leaks in concat_atom/3.

VERSION 5.5.14 (April 18, 2005)
===============================

  * FIXED: Bug#31: Crash when asserting predicates with wide-character
    functor name (mutex-name problem).  Also fixed mutex_statistics/0
    for such predicates.  Dmitry.

  * FIXED: Do not add BOM by default when a file is opened for write with
    explicit encoding.

VERSION 5.5.13 (April 12, 2005)
===============================

  * FIXED: Sungetc() update of position->charno

  * MODIFIED: Deleted built-in operator op(500, fy, ?).  Non-standard.
    Paulo Moura.  Very infrequently used for style_check(?dollar) and
    similar queries.  Also changed for ISO compatibility:

		op(500, fx, \)  --> op(200, fy, \)
		op(500, fx, -)  --> op(200, fy, -)

  * FIXED: Win32 console lockup when writing using put_byte/1 or using
    a modified encoding.

  * FIXED: Bug#30: Sprintf() and friends format bug.  With patch from
    Koenraad Heijlen.  Thanks.

  * ADDED: Support for BOM (Byte Order Mark), detecting various UNICODE
    file formats


VERSION 5.5.12 (April 04, 2005)
===============================

  * MODIFIED: write(1.0) --> 1.0.  I.e. floats are always written with
    either a . or an 'e' inside them.  Paulo Moura.

  * ENHANCED: give error on gensym(?, +).

  * FIXED: crash in PL_open_query() on undefined predicate.  Wim Delvaux.

  * FIXED: Doubles in the head on 64-bit platforms.  With many thinks to
    Christoph Quix for the research.

  * FIXED: Bug#27: set_stream_property/2 for representation errors.  
    Jiri Spitz.


VERSION 5.5.11 (March 15, 2005)
===============================

  * FIXED: PL_get_chars() using REP_UTF8.

  * ADDED: rewrite of `xos' layer to do all interaction in UTF-8, mapping
    to Windows UNICODE filenames.  Allows for accessing the filesystem using
    UNICODE names.

  * ADDED: setlocale/3: change/query locale settings at runtime.

  * CLEANUP: deleted old win32s stuff from uxnt.c


VERSION 5.5.10 (March 09, 2005)
===============================

  * FIXED: Support locales in communicating filenames.

  * ADDED: Pl_unify_chars().

  * MODIFIED: copy_stream_data/[2,3] now copies using get_code/2 and
    put_code/2 semantics instead of byte-by-byte.

  * ADDED: Multibyte encodings for PL_get_chars() and PL_get_filename().

  * ADDED: Support for default locale multibyte I/O using encoding 'text'.

  * ENHANCED: library url www_form_encode/2 not to encode _, and :.  Needed
    for some broken servers.  What is the full list we must use here?

  * FIXED: PL_get_chars() using CVT_WRITE.  Wim Delvaux.


VERSION 5.5.9 (March 02, 2005)
==============================

  * FIXED: Bug#12: poor error reporting on illegal module export list.
    Remy Haemmerle.

  * ADDED: Enh#21: hide details of library debug from the tracer.
    Holger Kanwischer.

  * FIXED: compiler error causing crashes on some weird variable patterns.
    With fix from Sergey Tikhonov.  Thanks!

  * ADDED: allow defining behaviour of streams when writing characters
    that cannot be represented.  Suggested by Anjo Anjewierden.

  * FIXED: getting character code value for characters with code > 255.
    Anjo Anjewierden.


VERSION 5.5.8 (Februari 25, 2005)
=================================

  * FIXED: negative random numbers on MS-Windows.  Upgraded random/1 to
    return 64-bit random numbers.  Jocelyn Paine.

  * FIXED: typo in message context.

  * FIXED: Seek issues for wchar and unicode streams.

  * MODIFIED: changed encoding 'none' to 'octet'.  Streams opened as
    type 'binary' now by default use the 'octet' encoding.  Adjusted
    and documented sgml-parser interaction with Prolog stream encoding.

  * ADDED: More library(ordsets) primitives to support library clp(R).

  * FIXED: Allow for errornous parse_url('http://2004.bloggies.com/', X).
    Anjo Anjewierden.


VERSION 5.5.7 (Februari 21, 2005)
=================================

  * ADDED: wide-character support for '$apropos_match'/2.

  * FIXED: Serious error in saved states dealing with multifile predicates
    and modules.  Jocelyn Paine.

  * FIXED: Possible deadlock in set_prolog_flag/2.

  * ADDED: Various new predicates to the ordsets compatibility library,
    used for the new CHR version.
   
  * ENHANCED: Provide better error context.  Suggested by Paulo Moura.

  * FIXED: library(readutil): complete dispatch of options. Wim Delvaux.


VERSION 5.5.6 (Februari 11, 2005)
=================================

  * ADDED: library(unicode/unicode_data), providing access to the official
    UNICODE data files (UnicodeData.txt, UCD).

  * FIXED: Bug#16: plwin.exe: having DISPLAY defined removes the menu.
    Richard Cheek.

  * FIXED: write_term/3: honour portray(true), numbervars(false) not to
    number the variables.

  * PORT: documented Linux-threads vs. NPTL issues.  Notably affects
    per-thread or per-process statistics.

  * FIXED: Bug#13: typo prevents building.  Jack Woehr.

  * PORT: Add LDFLAGS for building shared object (Paulo Moura,
    Gregory Wright)

  * ENHANCED: Change Prolog integers to be 64-bit on all platforms.  Also
    some critial sizes have been changed to 64-bit.  Consequences:

	* Foreign code using IOSTREAM (SWI-Stream.h) must be recompiled
          (i.e. source but no binary compatibility).
	* Code using PL_get_int() or PL_get_long() must be aware these
   	  can return FALSE, even if the value is a Prolog integer.  The
  	  new API PL_get_int64() can be used to extract 64-bit values on
  	  32 bit hardware.  On 64-bit hardware these functions are the
  	  same.
	* Code using PL_get_term_value() must be aware that integers
   	  are returned as int64_t.  Such code must be recompiled.  In
  	  addition the application should decide how to handle values
  	  outside the domain of a C long.

    Issues: the current implementation may access 64-bit values from
    the stack and embedded in compiled code at 32-bit alignment.  This
    surely works on IA32 (PC), appears to work on PPC (Mac).  There are
    probably processors out there for which it doesn't work.

VERSION 5.5.5 (Februari 01, 2005)
=================================

  * FIXED: Bug#9: Windows console menus did not work.  Jiri Spitz.

  * FIXED: make sure PL_initialise(0, argv) inititialises the system with
    reasonable defaults.

  * FIXED: precompilation of chr files in build environment.  Paulo Moura.

VERSION 5.5.4 (Januari 26, 2005)
================================

  * PORT: Enhanced support for MacOS.  Put the Prolog kernel in a shared
    object, support JPL in the MacOS version.

  * FIXED: source-file administration in saved-states.  Matt Lilley.

  * PORT: Enhance detection of support for ELF visibility attributes.


VERSION 5.5.3 (Januari 17, 2005)
================================

  * ADDED: copy_term_nat/2: copy without attributes.  Required by
    Tom Schrijvers for CHR.

  * FIXED: Avoid wakeup in tracer, portray, event-hooks and interrupts.
    Fixes problems reported by Hugo Ferreira and Tom Schrijvers.

  * FIXED: Attribute wakeup in functor(-,+,+).  Spotted by Jon Sneyers.

  * ADDED: PL_query() option PL_QUERY_ENCODING to synchronise default
    encoding towards XPCE.

  * ADDED: library(unicode/blocks): naming of the various unicode code
    blocks.

  * FIXED: Parsing numbers with 0-base written as 00'...  Anjo Anjewierden.

  * ADDED: PL_new_atom_wchars() and PL_atom_wchars() for create/fetch
    text from a wide-character atom.


VERSION 5.5.2 (December 23, 2004)
=================================

  * FIXED: Bug#216: Random() name conflict with MacOS libraries. 
    Helmar Spangenberg.

  * FIXED: Bug#215: Encoding documentation issues.  Holger Kanwischer.


VERSION 5.5.1 (December 17, 2004)
=================================

  * FIXED: Protocol issues due to wide character encoding.

  * MODIFIED: Cleanup of foreign predicate registration by Salvador
    Fandio.  Added PL_register_foreign_in_module() and
    PL_register_extensions_in_module().  Deleted the possibility to
    use PL_register_foreign("module:predicate", ...).  Foreign code
    using this construct must be updated.

  * ADDED: clp(r): Constraint Logic Programming over Reals.  Leslie De
    Koninck, K.U. Leuven supervised by Tom Schrijvers and Bart Demoen.

  * FIXED: error handling issues when running out of virtual memory due
    to creating too many threads.  Steve Moyle.

  * FIXED: Several issues with recursive mutexes in Windows, leading to
    errors in stream closing (Bug#211) and wrong error messages when dealing
    with Prolog-level mutexes.

  * ENHANCED: Make some system calls (shell/1, getenv/2, etc.) raise
    exceptions instead of printing a message.

  * FIXED: Bug#210. reporting of encoding of console streams in Windows.
    Holger Kanwischer.

  * FIXED: Large file support on Linux (wrong order of includes).


VERSION 5.5.0 (December 1, 2004)
===============================

  * FIXED: sub_atom/5 in mode +, -, -, +, +) mode.  Servey Tikhonov.

  * ADDED: wide character support for plwin.exe console.

  * FIXED: (a)cyclic_term/1.  Paul Singleton.

  * FIXED: Bug#204: conflicting <sys/malloc.h> on FreeBSD.  Deleted
    test for this header.  Tuomo Latto.

  * FIXED: PL_query(PL_QUERY_ARGC).  With patch from Salvador Fandio.

  * MODIFIED: incremented external record version format.  Unfortunately this
    makes old BerkeleyDB databases loading Prolog terms unusable.  The only
    work-around is to dump the database using an older version and rebuild
    it using the new version.

  * UPDATED: URL references

  * FIXED: Atom-gc bug.  Thanks to the analysis work by Servey Tikhonov.

  * ADDED: wide character support for atoms and strings, foreign interfaces
    and some of the atom-handling predicates.

  * CLEANUP: interfaces for storing, accessing and save/load of strings.

  * ADDED: wide character encoding/decoding support for character I/O.
    See open/4 and set_stream/2.

  * MODIFIED: toplevel does not prompt if the user_input stream is not
    connected to a terminal.  Using set_stream(user_input, tty(true))
    the system can be forced to think input comes from a terminal.
    After comments from Roberto Bagnara.

  * ADDED: set_stream(S, tty(Bool)), stream_property(S, tty(Bool)) to
    find out/presume whether a terminal is attached to a stream.

  * ADDED: cyclic_term/1 and acyclic_term/1.  Paul Singleton.


VERSION 5.4.3 (October 18, 2004)
================================

  * PORT: Solaris _FILE_OFFSET_BITS issues in rc library.  Based on
    comments from Ian Collier.

  * FIXED: avoid deletion of clauses for dynamic predicates on reload.
    Hugo Ferreira.


VERSION 5.4.2 (October 02, 2004)
================================

  * FIXED: Garbage collector bug in handling trailed assignments.  This
    code is used by attributed variables, setarg/3 and backtrackable
    global variables.


VERSION 5.4.1 (September 30, 2004)
==================================

  * ADDED/MODIFIED: strip_module/3 is now a public and documented
    built-in.  The old undocumented '$strip_module'/3 has been moved
    to the backward compatibility library.  Applications should not
    notice the difference, but it is adviced to update your application
    accordingly.

  * ADDED: '$btree_find_node'/4 to speed up binary tree handling.

  * FIXED: Bug#193: reading */* .  Sandro Hawke.

  * FIXED: nb_setarg/3 using compound terms.

  * FIXED: Attributes should not influence the standard order of terms for
    variables.

  * FIXED: allow for ISO :- dynamic(a/2, b/3, c/4). style declarations.
    Spotted by Paulo Moura.  Actually I think it is a bug in the ISO
    standard :-)


VERSION 5.4.0 (September 21, 2004)
==================================

  * ADDED: write_term/3 using option numbervars(true) writes atoms
    appearing as argument to '$VAR'(X) without quotes.  I.e.
    write_term(x('$VAR'('Foo')), [quoted(true), numbervars(true)])
    writes "x(Foo)".

  * FIXED: throw/1 crashed on attributed variables in the ball.

  * ADDED: option list to numbervars/4.

  * ADDED: return value for PL_put_blob() to indicate new/reused blob
    identifier.  Also added `acquire' hook to the blob type.
    Salvador Fandio.


VERSION 5.3.21 (September 14, 2004)
===================================

  * FIXED/ENHANCED: license/[1,2] and eval_license/0 issues reported on
    the mailinglist.

  * FIXED: DCG translation of *->


VERSION 5.3.20 (August 26, 2004)
================================

  * FIXED: prolog_frame_attribute(Frame, goal, Goal) created term that
    cannot be handled by the garbage collector.

  * ADDED: read_pending_input/3, fetching pending input from a stream.

  * ENHANCED: On Windows-NT, use Waitable Timers to realise sleep/1,
    resulting in improved handling of events and timeouts as well as
    better timer resolution.  Uses old Sleep() based version on older
    windows platforms.

  * ENHANCED: realised native Win32 guarding of thread message queues,
    sponsored by SSS (www.sss.co.nz).

  * FIXED: Recorded database handling of attributed variables (could loose
    attributes on some terms).

  * ADDED: Support for attributed variables and cyclic terms for =@= and
    \=@=.


VERSION 5.3.18 (August 16, 2004)
================================

  * MODIFIED: perform goal expansion relative to indicated module for
    goals of the format Module:Goal where Module is known at compiletime.


VERSION 5.3.17 (August 2, 2004)
===============================

  * FIXED: source-location handling for if -> then if then holds control
    structures.  Alan Baljeu.

  * FIXED: global-variables related GC bug.  Thanks to David Reitter for
    producing an reproducable case.

  * FIXED: reconsulting a file with dynamic predicate declaration no
    longer deletes the clauses added with assert.

  * CLEANUP: Many stylistic issues to the C-source, removing warnings
    especially for Sun CC.  Richard O'Keefe.

  * ADDED: nb_setarg/3 and nb_linkarg/3, providing non-backtrackable
    assignments on terms.

  * ADDED: cycle-check in bagof/setof code handling existential bindings
    (should be an error!?).

  * ADDED: Support for cyclic terms in the recorded term representation,
    providing cyclic-safe recorda/3, findall/3, bagof/3, setof/3, exceptions
    and Prolog terms in XPCE objects.

  * ADDED: inf/infinite for stack options in create_thread/3 as well as for
    the `High' in between/3.

  * ENHANCED: use right-recursion optimisation in $e_free_variables/2
    used by bagof/3 and setof/3.  Alan Baljeu.

  * FIXED: Avoid "Loading module ... abolished: ..." messages when
    reloading discontiguous predicates.

  * FIXED: A == B if A and B are equal string objects.
    (typo when providing support for cyclic terms)  Jacques Abel.


VERSION 5.3.16 (July 21, 2004)
==============================

  * MODIFIED: print/1 behaves as write/1 instead of writeq/1.  This
    new behaviour is compatible to other Prolog systems and the
    documentation.  Lourens van der Meij.  Use write_term/[2,3]
    to get unambiguous ISO compliant printing in a specific mode.

    Affected code must be updated.  

  * MODIFIED: By default, symbols from shared objects are not made
    global any longer.  The argument order of open_shared_object/3
    has changes, though the predicate automatically reverses the
    arguments when confronted with the old order.

    This is unlikely to affect user code.  If it does, the user can
    use open_shared_object(File, Handle, [global]) for compatibility.


VERSION 5.3.15 (July 16, 2004)
==============================

  * FIXED: MS-Windows: same_file/2 for relative paths.

  * ADDED: support for open(pipe(Command), ...) for the Windows version
    after recent discussion on the mailinglist.  Works both in plwin.exe
    and plcon.exe thanks to code used from the LUA programming language
    and distributed under the compatible MIT license.

  * FIXED: import/export issues loading QLF files leading to
    ERROR: Failed to import ... into ... messages.

  * ADDED/MODIFIED: print message if a detached thread dies abnormally.
    After report by Fabien Todescato.

  * FIXED: portability issue in Makefile (Solaris).  Bill McEnaney.

  * FIXED: possibility to crash the debugger on exceptions in callback
    from C.  Salvador Fandio.


VERSION 5.3.14 (July 1, 2004)
=============================

  * MODIFIED: Merged backtrackable and non-backtrackable global variables.
    Tom Schrijvers.

  * ADDED: term_variables/3: difference list version of term_variables/2.
    Suggested by Tom Schrijvers for the next version of CHR.


VERSION 5.3.13 (June 28, 2004)
==============================

  * FIXED: at_end_of_stream/[0,1] to throw an exception if the stream
    is at the end due to an error.

  * FIXED: attributed variable handling in findall/3 and friends.
    David Reitter.

  * FIXED: nb_linkval/2 (and therefore nb_setval/2) if value is an
    attributed variable.  David Reitter.


VERSION 5.3.12 (June 15, 2004)
==============================

  * FIXED: option processing in read_line_to_codes/3.  David Reitter.

  * ADDED: library(prolog_stack) to get and print stack-traces from Prolog.


VERSION 5.3.11 (May 25, 2004)
=============================

  * FIXED: hash_term/2 to handle terms holding attributed variables
    and cyclic terms.  David Reitter.

  * ADDED: first integration of JPL with the normal Prolog tree.

  * ADDED: [=format] to -dump-runtime-variables to dump them in CMD.EXE
    compatible format.

  * PORT: Added a few NetBSD patches (incomplete, ongoing work).
    Hubert Feyrer.

  * FIXED: cleanup at exit if there are engines not attached to threads.

  * ADDED: Hook prolog:error_message//1 to add new error types and print
    them in readable format.

  * ADDED: plld: add -Wl,* options to the linker options.

  * MODIFIED: Renamed checklist/2 --> maplist/2 for compatibility reasons.
    Added checklist/2 to the compatibility library.

  * ADDED: Maplist/4

  * FIXED: Bug#152: making active dynamic predicates static using
    compile_predicates/1.  Marc Bezem.

  * CLEANUP: some errors reported by the valgrind tool.


VERSION 5.3.10 (Apr 29, 2004)
=============================

  * FIXED: import warning on $derived_source/3.  Mike Elston.

  * FIXED: numbervars option of the write predicates.  Steve Moyle.

  * Provided limited stack trace for errors during GC.

  * FIXED: throw/1 throwing a single variable if the exception is not
    caught (Roberto Bagnara)

  * ADDED: PL_is_ground() to check for term groundness in the foreign
    interface.

  * ENHANCED: error messages produced by load_foreign_library/1.

  * MAINTENANCE: Fixed incorrect assertion in O_SECURE mode.  Barry Evans.

  * ENHANCED: some Makefile cleanup.  Fixed typo spotted by Tom Schrijvers.

  * PORT: Cleanup of autoconf configuration (dropped acconfig.h)

  * ENHANCED: Exploit GCC visibility("hidden") attribute.  Improves symbol
    handling for embedded applications on ELF-based systems.


VERSION 5.3.9 (Apr 15, 2004)
============================

  * MODIFIED: the library for embedded linking has been moved from
    runtime/$ARCH to lib/$ARCH.  Installation scripts using plld work
    without modification, but hand-crafted building of embedded executables
    must be adapted.

  * ADDED: configure option --enable-shared to create the Prolog kernel
    as a shared object.  Works on ELF based systems using the GNU toolchain.
    MODOFIED: configure option --disable-shared is renamed to
    --disable-load-foreign.

  * FIXED: Renamed corouting --> coroutining (Joachim Schimpf).

  * FIXED: debug/nondebug issues with multifile predicates (causing
    gtrace/0 to trace itself).  David Reitter.

  * MODIFIED: listing/1 throws exception if the target cannot be
    found (Enhancement#143).  Holger Kanwischer.

  * FIXED/MODIFIED: Syntax errors are now reported using a term
    file(Path, Line, LinePos, CharPos) or stream/4 if a stream is
    not associated to a file.  The LinePos element is added to this
    structure.  Syntax errors are reported using file:line:linepos.
    After suggestion from David Reitter.

  * FIXED: Made when/2 module-aware.

  * FIXED: Debug-settings for system predicates defined as discontiguous,
    etc.  Tom Schrijvers.

  * FIXED: bug in b_setvar/2 when assigning a local-stack hosted variable.
    David Reitter.

  * FIXED: read_term/3 option subterm_position on @receiver?(mode).

  * FIXED: assertion failure in b_setval/2 and b_getval/2.  David Reitter.

  * MODIFIED: moved XPCE boot file pce_operator.pl to the general Prolog
    library under the name operators.pl.  Applications that used to fetch
    this file using unsupported :- use_module(boot(pce_operator)) should
    now use :- use_module(library(operators)).  

  * FIXED: Turn error messages produced	by format/[1-3] into proper
    exceptions.  Dima.

  * ADDED: predicate_property/2: `nodebug' to detect predicates without
    debug info.  Used by the guitracer.

  * MODIFIED: listing/0 now only lists predicates defined in the target
    module.  Used to also list imported predicates.  Applications that
    rely on the old behaviour should use listing/1 on all predicates
    enumerated by current_predicate/1.


VERSION 5.3.8 (Apr 07, 2004)
============================

  * FIXED: Quoted write of -(0) and similar cases.  Mike Elston.

  * ADDED: Exporting operators from modules.

  * ADDED: flag called generate_debug_info and commandline option -nodebug.
    Fixed/cleanup of various tracing options.

  * FIXED: Bug#140, various problems with complicated reload of files.
    Hans van de Koot.

  * FIXED: clause garbage collection for references from retract/1,
    clause/2, etc.

  * FIXED: profile detection on older versions of gcc.  Tom Schrijvers.

  * FIXED: repetitive qsave_program/2 handling.  Dima.

  * FIXED: Buffer overflow asserting to predicates with a very long
    name (caused by naming the mutex for mutex statistics).  Reported
    by Lourens van der Meij.

  * MODIFIED/FIXED: ensure_loaded/1 and use_module/[1,2] now use 
    load_files/2 with the option if(not_loaded) rather than if(changed).
    This avoids time handling problems with quick-load files, especially
    on Windows systems that base their time-stamp on local time rather
    than universal time.

    Use make/0 to update your project.  Applications that really need
    the old semantics should use load_files/2 directly.

  * ADDED: Central "make check" to run regression tests in main system and
    all packages.

  * CLEANED: handle command history per thread.

  * FIXED: handling of attributed variables in meta-calls.  Tom Schrijvers.

  * ADDED: set_prolog_OI/3 to handle interactive I/O from arbitrary
    streams.

VERSION 5.3.7 (Mar 26, 2004)
============================

  * ADDED: First prototype of binary-blobs-in-atoms after
    discussion on the mailinglist.

  * ADDED: CHR Debugger.  Tom Schrijvers.

  * FIXED: sub_atom/5 with variables sharing in the call.  Emerson.

  * MODIFIED: delete_file/2 now throws an exception rather than failing
    silently if the file cannot be deleted.


VERSION 5.3.6 (Mar 17, 2004)
============================

  * ENHANCED: performance for term_variables/2 in terms with many variables.

  * FIXED: handling attributed variables in bagof/setof.  Tom Schrijvers.

  * FIXED: Handle goal_expansion/2 for the arguments of call_cleanup/2.

  * ADDED: clp/bounds.pl: an Integer Bounds Constraint Solver by
    Tom Schrijvers.


VERSION 5.3.5 (Mar 13, 2004)
============================

  * FIXED: Bug#138: Avoid trying to compile pl-xterm.c on Cygwin.
    Shawn Legrand.

  * FIXED: Bug in copy_term/2 when copying (sharing) ground terms with
    nested compounds.  David Reitter.


VERSION 5.3.4 (Mar 12, 2004)
============================

  * ADDED: style_check(+charset) option.

  * FIXED: Bug#139 Trail-stack overflow after many assignments
    (using setarg/3) to the same location in deterministic code.
    Holger Kanwischer.

  * ADDED: handle cycles in term_variables/2 and numbervars/3 as well as
    in the goal for bagof/setof.

  * MODIFIED: character classification for the range 159-255 to follow
    ISO-latin-1.  Richard O'Keefe.  All these characters used to be
    classified as lowercase letter.  Note that this may cause errors
    reading old code containing not-quoted atoms holding such characters.
    For example, ab used to be read as an atom but is now read as a
    Prolog variable.  Please use ?- style_check(+charset) to get warnings
    in possible conflicts.

  * ENHANCED: Cleanup of dif/2 by Tom Schrijvers.

  * FIXED: ensure a thread is considered to exist before it actually
    starts running.

  * ADDED: experimental	predicate unifyable/3.  New versions of dif/2
    and when/2 based on this predicate by Tom Schrijvers.

  * ADDED: when/2

  * ADDED: ?=/2

  * FIXED: A \= B to run attributed variable wakeup handlers before
    doing the negation.


VERSION 5.3.3 (Mar 5, 2004)
===========================

  * ADDED: Initial version to control printing attributed variables.
    With input from Tom Schrijvers.

  * FIXED: Bug#127 (partially), system slowing down after Control-C
    followed by abort if the Control-C happens inside retract/1.
    Holger Kanwischer.

  * ENHANCED: CHR compiler and documentation.  By Tom Schrijvers.

  * ADDED: dif/2 in the library(dif).  Code contributed by Tom
    Schrijvers.  Thanks!

  * FIXED: reconsult to lock other threads (Unix).  Sandro Hawke.

  * FIXED: http_open/3 problems using redirection to non-absolute URL.
    Anjo Anjewierden.

  * FIXED: Bug#133: setarg/3 did not throw an exception.  Holger
    Kanwischer.

  * ADDED: Handle ~@ in format/[2,3].  SICStus compatibility.  Reported
    by Tom Schrijvers.

  * FIXED: sizeofClause() type error.  Michal Cihar.

  * FIXED: int/char problem in parser.  Michal Cihar.

  * FIXED: Bug#128: memory deallocation problem in library(memfile).
    MS-Windows only.  Added Sfree() to free memory from the right
    pool.  Holger Kanwischer.

  * FIXED: Bug#129: determinism in bagof/setof.  Holger Kanwischer.

  * FIXED: Bug#125: rename_file/2 if source and destination are the same.
    Dr. Werner Wolff.

  * FIXED: phrase/3.  Detmar Meurers and others.


VERSION 5.3.2 (Feb 4, 2004)
===========================

  * ADDED: frozen/2.

  * FIXED/ADDED: Merged win_shell issues from main branch

  * ADDED: CHR library by Tom Schrijvers and Christian Holzbaur.  Thanks!

  * ADDED: Support for cyclic terms in ==/2, @>/2, etc.

  * ADDED: library assoc.pl, Adapted YAP version, originally by Richard
    O'Keefe.

  * FIXED: Bug in unifying cyclic terms.  Kuniaki Mukai.

  * ADDED: Support for cyclic terms in ground/1

  * FIXED: Bug#130: writeq('/*').  Holger Kanwischer.

  * FIXED: win_shell/2.  Added win_shell/3.  Dmitry.

  * FIXED: allow for peek_byte(-1), etc.  Michael A. Covington.

  * FIXED: Merged saved-state patches from main branch

  * NEW: renamed nb_setval/2 to nb_linkval/2, giving nb_setval/2 a better
    defined semantics.  Added duplicate_term/2 to really duplicate a term.

  * FIXED: module handling in flag/3

  * ADDED: derived_from(File) option to load_files/2.

  * MODIFIED: renamed free_variables/2 into the more widely used name
    term_variables/2.  Added free_variables/2 to the library backcomp,
    so applications with autoloading enabled (default) do not have
    to be modified.

  * ADDED: protect write/1 from looping on cyclic terms.  Short-term
    solution writes ** if it detects a cycle.

  * FIXED: Hanging atom garbage collector in multi-threaded execution
    on Unix platforms.  With lots of help from Sergey Tikhonov.

  * FIXED: make convert_time/7 thread-safe using localtime_r() if
    provided.

  * ADDED: msb/1 arithmetic function.

  * ADDED: support for attributed variables and cyclic terms in copy_term/2


VERSION 5.3.0 (Jan 16, 2004)
============================

  * ADDED: Partial support for cyclic terms.  Covered sofar:
    unify()

  * ADDED: global variables: b_setval/2, b_getval/2, nb_setval/2,
    nb_getval/2.

  * ADDED: Coroutining: freeze/2

  * ADDED: Attributed variables: attvar/1, put_attr/3, get_attr/3.


VERSION 5.2.12 (Jan 17, 2004)
=============================

  * FIXED: Crash in atom-garbage collection.  Sergey Tikhonov.

  * FIXED: Memory corruption problem in prompt handling of threads.
    Sergey Tikhonov.

  * FIXED: Deal with EINTR in sem_wait (Sergey Tikhonov).

  * FIXED: AGC problem.  With patch from Sergey Tikhonov.

  * FIXED: destroying thread-local clauses with the GUI debugger loaded.
    Fabien Todescato.

  * DOCUMENTATION: Typo in term_expansion/2 docs.  Mrcio Mazza.

  * INTERNAL: changed tag schema freeing up an entry for attributed
    variables.

  * ENHANCED: Reduce hash-table size on retract/retractall, avoiding
    performance problems with retract after shrinking a very large
    predicate (Leo Khramov).

  * FIXED: Memory leak in hash/1 (Sergey Tikhonov).

  * ADDED: Partial support for large files (>2GB) on Unix systems.  Tested
    on SuSE Linux.  Note that the SWI-Prolog cannot fully handle such files
    as Prolog cannot represent offsets using its 32-bit integers.  It can
    however open them for reading and writing.

  * ADDED: Bug#107 (Enhancement request): added advisory lock interface
    (lock(Type) argument to open/4) for MS-Windows based on LockFileEx()
    as suggested by Holger Kanwischer.  Thanks!


VERSION 5.2.11 (Nov 29, 2003)
=============================
	
  * FIXED: interrupt and error handling in wait_for_input/3.  With patch
    from Leonid Khramov.  Second patch dealing with overruled sets. Thanks.

  * FIXED: Generate syntax error on `based numbers' without digits.  Dima.

  * ADDED: PL_unify_term: handle (PL_BOOL, int) to unify boolean
    values as true or false.

  * FIXED: peek_code/2 and friends on end-of-file.  Steve Moyle.


VERSION 5.2.10 (Oct 27, 2003)
=============================
	
  * FIXED: call(1) exception handling (not callable).


VERSION 5.2.9 (Oct 05, 2003)
============================
	
  * MANUAL: Fixes to skeleton code for non-deterministic foreign predicates
    (Willem de Bruijn).

  * LINK: pl -dump-runtime-variables to set PLLIB to the link-option to
    link the Prolog library (e.g. -lpl)

  * ADDED: gspy/1 to start the guitracer on a spyed predicate.

  * ADDED: goal_expansion/2 to work on the arguments of catch/3.

  * ENHANCED: more debugger issues.  Still unsatisfactory.

  * FIXED: proper writing of variables in the normal terminal debugger.
    (Marc B).

  * FIXED: absolute_file_name/[3] to return order consistently.

  * ENHANCED: handling of redo in the debugger.

  * FIXED: sub_atom('1', _, _, 3, Sub) (2nd or 3th argument longer than
    atom).  Anjo Anjewierden.

  * FIXED: Prolog flag abort_with_exception to be true in multi-threaded
    version and make it read-only.  `Cosmetic' only.

  * FIXED: Compilation of (a, ! -> b) to cut the choicepoints of a.
    Sergey Tikhonov.

  * ADDED: MS-Windows: library(registry): win_flush_filetypes/0 to forward
    changes to registered types to the shell, so the proper icons are
    displayed.  Also used by the install-script to propagate the Prolog icon
    immediately.

  * FIXED: Source level debugger: ERROR: Arithmetic: `very_deep/0' is
    not a function.  David Reitter.

  * ENHANCED: library(check) only reports redefinition on modules that
    default to user and system (otherwise we are dealing with special
    purpose usage of the module system that must be handled seperately).

  * FIXED: Bug#92: pathname handling on paths like \\machine\c$\more\...
    Also, the argument to -s (script) is not expanded. Tolga Konik.

  * ADDED: Keep track of line-number where a module is defined (no public
    interface yet, available through '$module_property'(+Module, -Property).

  * FIXED: Bug#91: source level debugger generates error.  Holger Kanwischer.


VERSION 5.2.8 (Sep 13, 2003)
============================

  * ENHANCED: more consistency tests and replaced some old-style
    warnings with print_message/2 and exceptions in module handling.

  * FIXED: current_predicate(Name/Arity) with unbound Arity.  Dmitry.

  * FIXED: More robust extistence check in get_message_queue().

  * FIXED: Problem compiling \+/1 if \+ introduces new variables.  May
    lead to crashes in the garbage collector.  Sergey Tikhonov.

  * FIXED: Hashing predicates defined with :- thread_local/1 (correct result,
    but wasting memory and poor performance).

  * FIXED: Made O_SECURE tests in pl-gc.c thread-safe (maintenance only).

  * FIXED: P_VARARG handling through PL_load_extensions().  With patch from
    Salvador Fandio.

  * FIXED: bug in debugger crashing on an exception.

VERSION 5.2.7 (Aug 29, 2003)
============================

  * FIXED: message_queue_destroy/1: deletion of the name-alias and added
    (heuristic) test to avoid destroying active message queues.

  * FIXED: Alignment problem in struct clause using gcc on mk68.  Reported
    by Michael Piefel.  Debugged with help from the Debian Linux project.

  * PORT: A few minor glitches for clean build as Debian package.
    Michael Piefel.

  * FIXED: Mutex initialisation in abolishProcedure().  Notably affects
    redefine_system_predicate and abolish on imported predicates.
    Sergey Tikhonov.

  * FIXED: PL_destroy_engine().  Uwe Lesta.


VERSION 5.2.6 (Aug 15, 2003)
============================

  * FIXED: Cleanup problem in threads.

  * FIXED: Memory management problem in message_queue create/destroy.

  * FIXED: proper hidden window handling in Windows version.  Shows up as
    MS-Word not starting or very slowly on NT4 if a thread is blocked in
    in thread_get_message/[1,2].

  * ADDED: handle thread_signal/2 inside thread_get_message/[1,2].

  * FIXED: pl -o myexe --goal=hello,halt -c hello.pl (handling complex
    terms in --goal= and --toplevel=)

  * FIXED: pl -q -t true printed a single newline.  Eric Goldlust.

  * FIXED: Ignore -x in pl -- -x foo.  With patch from Salvador "Fandio.

  * FIXED: Memory management issues in the multi-threaded version.  Thanks to
    Sergey Tikhonov for his analysis.

  * FIXED: Redesign of frames for foreign-term handling (FliFrame), fixing
    problems with the garbage collector in some situations.  The new design
    is easier to understand and debug.

  * FIXED: Bug#85: Prolog arithmetic functions in optimised mode evaluating
    complex not-compiled expressions.

  * PORT: make sure the profiler-support autoconf test runs at least 1 sec.
    This makes the test work regardless of the speed of the machine.

  * FIXED: profiler/2 and '$prof_procedure_data'/7 to deal with sibling
    ticks accounting.  Direct use of profile/1 was ok.  Also fixed getting
    details from predicates in the user module.  David Reitter.


VERSION 5.2.5 (Aug 01, 2003)
============================

  * FIXED: Bug#81 memory leak issues around recursive mutex creation.  Also
    provide faster initialisation of recursive mutex objects.  Thanks to
    Ross Johnson (pthread-win32 maintainer).

  * ADDED: Option SIO_NOMUTEX to make faster temporary streams that are
    not shared between threads.  Provides a work-around for Bug#81 causes
    my a memory leak in pthread-win32.  Mike Elston.

  * PORT: Bug#83 Added dummy foreign profiler interface on systems that
    do not support the profiler.  This causes problems on Solaris 2.8
    for compiling XPCE as the profiler was not detected correctly.
    Lourens van der Meij.

  * FIXED: configure for profiler on systems with non-BSD signal semantics
    (e.g. Solaris).  With help from Lourens van der Meij.

  * FIXED: Error handling complex meta-calls in the stack-shifter (only
    affects operating systems that have nothing better than malloc() for
    allocating the Prolog stacks).

  * FIXED: Compilation problems using --disable-mapped-stacks.  Ralf
    Petzschmann.

  * FIXED: Bug#82: Saved states in Windows try to load the `associated file'.
    Mike Elston.

  * FIXED: Bug in \+ inside ;/2 or (if -> then ; else) if the \+ introduces
    new variables.  Jorge Baier Aranda.  Compiler bug; saved states and
    QLF files must be recompiled.

  * FIXED: Switch off profiler during show_profile/2.  David Reitter.

  * FIXED: Bug#79, Gui tracer loosing pending exceptions.  Holger Kanwischer.

  * FIXED: properly reset after an abort.

  * FIXED: Bug#77, manual tools handling call/[2..].  Holger Kanwischer.

  * FIXED: Bug#76, deadlock in see/1 if the argument file does not exist.
    Holger Kanwischer.


VERSION 5.2.4 (Jul 17, 2003)
============================

  * FIXED: Bug#74, call_cleanup/3 handler not called if it must be autoloaded
    and is called due to an exception.  Mike Elston.

  * FIXED: Bug#73, GUI tracer using decompiled code where it shouldn't.
    Holger Kanwischer.

  * ENHANCED: More thread-allocation issues.  Avoid memory floating
    uncontrolled between threads through message exchange or other dynamic
    datastructures allocated by thread 1 and consumed by thread 2.
    Sergey Tikhonov.

  * FIXED: Pretty printing not proper lists in the GUI tracer.  David Reitter.

  * ADDED: Hooks into the profiler that allow for profiling external
    packages such as XPCE.

  * FIXED: Bug in profiler causing very large overhead under some
    circumstances.  Tolga Konik.

  * ENHANCED: thread memory pooling could waste memory, especially in
    designs where a pool of threads is fired, waited for, re-started,
    etc.  Sergey Tikhonov.

VERSION 5.2.3 (Jul 04, 2003)
============================

  * ENHANCED: make trace/0 work while skipping, so an explicit trace command
    always works.  Alan Baljeu.

  * FIXED: Bug#71: graphical tracer confused about (a,b),c nested inside
    an if-then-else.  Holger Kanwischer.

  * FIXED: call_cleanup/3 to call the handler on deterministic exit in
    debug mode.  Holger Kanwischer.

  * MODIFIED: hide predicates starting with $ from listing/0.  Paulo Moura.

  * FIXED: compiler warnings on initPrologThreads().  Paulo Moura.

  * MODIFIED: Predicates whose name starts with '$' are automatically
    hidden from the tracer.  To comfort Logtalk.  Paulo Moura.

  * FIXED: retractall/1 to call setDynamicProcedure() instead of simply
    modifying the predicate.  setDynamicProcedure() to call the clause
    garbage collector before deciding it cannot turn static predicate
    with clauses into a dynamic one.  Anders Bouwer.

  * FIXED: Deadlock in thread_statistics on `self'.  Sergey Tikhonov.

  * FIXED: plwin.exe menu link to the XPCE documentation.  Robert Shiplett.

  * INSTALL: fixed various path-problems in the packages.  Michael Piefel.

  * ADDED: Added #define _THREAD_SAFE for FreeBSD (Clemens Fischer).  Also,
    make plld add -D_THREAD_SAFE on this platform if prolog support threading.

  * FIXED: don't give a warning on pl -L128m.  John Li.

  * ADDED: plld --version to run <cc> --version and test for GCC version.
    Michael Piefel.

  * FIXED: toplevel configure and makefile driver

  * FIXED: Bug #68: building on  cygwin.  Lourens van der Meij.

VERSION 5.2.2 (Jun 23, 2003)
============================

  * MAYBEFIXED: Bug#68: lacking headers compiling pl-stream.c.  Lourens
    van der Meij and Djam Seddah.

  * FIXED: GC during autoload.  Fabien Todescato.  Thanks for the extensive
    test-suite!

  * FIXED: avoid deadlock with set_prolog_flag(trace_gc, true).

  * FIXED: dependency problem in library(win_menu).

  * FIXED: Windows 95/98/ME error running the profiler.   Joseph Bush.

  * FIXED: PL_set_feature() when called before PL_initialise() on some
    versions of Windows.  Caused executable created with xpce-stub.exe
    to crash immediately.  Paco Gutierrez.

VERSION 5.2.1 (re-distributed on Jun 17, 2003)
==============================================

  * FIXED: file associations.  Thanks to Lourens van der Meij.

  * FIXED: Added files forgotten in the Windows installer.  PacoG.

  * FIXED: Bug#66: thread_statistics/2 returning illegal values on floats
    and large integers.  Mike Elston.

VERSION 5.2.1 (Jun 13, 2003)
============================

  * FIXED: Bug#63: exception-term lost (reported as unbound).  Mike Elston.

  * ENHANCED: Bug#64: make ground/1 do last-argument optimisation.
    Mike Elston.

  * FIXED: Win32 version generation of the runtime kernel. Radoslaw Scislo.  

  * PORT: Updated MSVC project files (*.dsp and *.dsw) from MSVC 5 to
    MSVC 6 and fixed to reflect the current build-system.  Contributed
    by Radoslaw Scislo.

  * ADDED: Package semweb: semantic web operations

  * PORT: Some MSVC6 issues (Radoslaw Scislo).

  * FIXED: Reading 'xxx\<NL> y'.

VERSION 5.2.0 (May 22, 2003)
============================

  * FIXED: Various issues with indexing on multiple arguments (JAcques).

  * FIXED: '\<NL>' to read as '' (JAcques).

  * ENHANCED: Source-level debugger only to disactivate the binding view
    on abort, so you can cut-and-paste bindings to the interaction window.

  * FIXED: Bug #56: various issues with 0-bytes in format/3 and friends.
    Mike Elston.

  * PORT: Semaphore handling needed by the multi-threading version to
    MacOS X (Darwin).

  * FIXED: Bug #55: random/1 generating same sequence in all threads on Win32.
    Mike Elston.  There are still many issues left about random numbers in
    multi-threaded code.  See comments in pl-os.c

  * FIXED: Bug #54: preserve the tracer being disabled in nested
    C->Prolog calls.  Tolga Konik.
    
  * ADDED: portray_clause/2 (compatibility and consistency).

  * FIXED: Bug #52: write/1 to write SWI-Prolog string objects with
    embedded 0 chacters.  Mike Elston.

  * FIXED/MODIFIED: library(url), parse_url_search(-Spec, +Fields), packing
    a search specification.

  * ADDED: 'F' (fail) option to graphical debugger (Feature #51, Holger
    Kanwischer).

  * FIXED: Bug #50: Handle \c<blank*> with character escapes.  Mike Elston.

VERSION 5.1.13 (May 19, 2003)
=============================

  * ADDED/PORT: New Windows installer based on NSIS, NullSoft Scriptable
    Install System.  Also added a dedicated windows readme file to the
    installation.

  * FIXED: handling uninitialised data in compilation of \+/1.  Could
    result in wrong results if the garbage collector is executed in the
    critical window or the graphical tracer it used.  Alan Baljeu.

  * FIXED: qsave_program/[1,2] to save the thread_local attribute.
    Mike Elston.

  * FIXED: Handling of 0'\n and friends if character-escapes is enabled
    (default).  Richard O'Keefe.  Note:

    MODIFIED: as a consequence, 0'\ is not interpreted as the character
    code for '\', but as the start of an escape sequence.  Replace this
    by 0'\\.  In most cases the old code will raise a syntax error while
    being parsed.  You can also grep for potential conflicts.  On Unix
    systems:

    	fgrep -n "0'\\" `find . -name '*.pl'`

  * FIXED: Handling "x" in arithmetic (e.g. A =:= "a").  Richard O'Keefe.

  * FIXED: Wrong usage of the term ASCII in the manual.  Suggested
    by Marc Bezem.

  * ADDED: Pentium-based timing of virtual machine (development only)

  * PORT: fixed many signed/unsigned warnings generated by GCC 3.3

  * ADDED: announced compatibility checks for last/2 (library checklast).

  * DOCS: Updated some comments in Makefile and INSTALL.notes files.

  * FIXED: Compiler warning in pl-proc.c.  Paulo Moura.


VERSION 5.1.12 (April 25, 2003)
===============================

  * ADDED: library(checklast) to check for the modified argument order of
    last/2.

  * ADDED/FIXED: Bug#46: loading .qlf files using use_module/1 and friends.
    Holger Kanwischer.

  * PORT: Patch to rc/access.c for HPUX-11 (and possibly more).  Tim Brown.

  * ENHANCED: messages printed with set_prolog_flag(verbose_autoload, true)

  * MODIFIED: Argument order of last/2.  Compatibility to other Prolog
    systems.  Please update your sources.  If you have a Unix shell
    and utitilities you find most calls using

		grep -n '\<last(' `find . -name '*.pl'`

    On all systems you can run ?- check_old_last. before loading your
    program.  This spots if last/2 is used at compiletime as well as
    trapping suspicious calls at runtime.

  * ADDED: time/1 and profile/1,3 to call expand_goal/2.  Time/1 to
    report elapsed time.

  * FIXED: Bug#42: starting a saved state with no known Prolog home.

  * FIXED: do not show FAIL from ports created by dummy choicepoints.
    Alan Baljeu.

  * FIXED: Handling QLF file if their location has changed.  Various
    posters to the mailing list.  Also fixed re-entrance problem in
    the QLF-loader (affecting various XPCE tools) and location sources
    of XPCE objects.  The installation should now be truly position
    independent.

  * FIXED: autoloader bug in multi-threaded code.

  * FIXED: Bug#41: Syntax error with backquoted strings and no
    space after operator =/2.  Holger Kanwischer.


VERSION 5.1.11 (April 1, 2003)
==============================

  * FIXED: Bug#38: optimized prolog arithmetic functions in saved-states.
    Holger Kanwischer.

  * PORT: (Maybe ...) Make compile using SunSoft C-compiler.  Michel Sall. 

  * FIXED: Bug#37 writeq(`hello`) with backquoted_string set to true. 
    Holger Kanwischer

  * ADDED: very first start for multiple engines in single-threaded version
    for benchmarking.

  * FIXED: building on machines that do not support profiling.  Steve Moyle.

  * ENHANCED: Use a mutex per module for functor --> predicate lookup for
    better speed of threads doing meta-calls in different modules.

  * ADDED: compile_predicates/1

  * ADDED: some more statistics on mutex usage

  * ENHANCED: Use mutex per dynamic predicate in the multi-threaded version.
    This reduces contention a lot on the Aleph test.


VERSION 5.1.10#2 (Mar 15, 2003)
===============================

  * FIXED: sort([X], [Y]), X == Y.  Paul Singleton.


VERSION 5.1.10 (Mar 14, 2003)
=============================

  * FIXED: Avoid thread_signal/2 to signal a just-exited thread.  More
    patches here ...

  * ADDED: New execution profiler providing much more readable and detailed
    output.

  * FIXED: thread_setconcurrency/2 detection (Steve Moyle).

  * ENHANCED: Implementation of thread_signal() and friends on Windows.
    Avoid using a window and allow exceptions to be raised in blocking
    calls.

  * ADDED: Separating Prolog engines from threads.

  * ADDED: -embed-shared option to plld

  * ADDED: Make safe signal handling possible from various blocking I/O
    operations, expanding the useability of call_with_tim_limit/2.

  * ENHANCED: Use Richard O'Keefe's natural merge-sort for sort/2, msort/2
    and keysort/2.  More space efficient.  As good as the best qsort()
    from libc and replaces old slow keysort with an efficient alternative.

  * ENHANCED: make == and \== last-argument-tail-recursive, so they apply
    to arbitrary long lists.

  * FIXED: Bug#32: A number of issues around unloading shared objects.
    Mike Elston.

  * FIXED: Avoid tracing the $aborted exception.

  * FIXED: Call stack-shifter when low on stack in built-in sort/1.
    Only applies to systems where mmap() doesn't work or isn't detected
    properly. Richard O'Keefe.  

  * FIXED: Bug#29: PLWIN.EXE console scrinks one row each invocation.
    Holger Kanwischer.

  * ADDED: PLWIN.EXE: make tty_size/2 return the window size in rows and
    columns.

  * FIXED: Bug#30: calling halt/0 and friends from `sub-threads' now causes
    a permission error.  This isn't perfect, but better than an uncontrolled
    crash.  Joachim Katzer.

  * PORT: Fixed various problems on SGI (IRIX 6.5), including realisation
    of dynamic stacks based on MAP_AUTOGROW|MAP_AUTORESRV.  Thanks to
    Matthijs Mourits for providing me with access to his machine.

  * FIXED: only open /dev/zero once in multi-threaded version where
    MAP_ANON is not supported.


VERSION 5.1.9 (Mar 06, 2003)
============================

  * ENHANCED: Check for instantiation errors in send_list/[2,3].  Anjo
    Anjewierden.

  * ENHANCED: Use a key	to speedup searching for potentionally matching
    messages in long message queues.

  * FIXED: Bug#28: race condition on message queues.  Mike Elston.  Added
    abstracted version of his test to the thread test-suite.

  * FIXED: Error-reporting in thread_join/2.  Added check to avoid joining
    detached threads.

  * PORT: Added #define _GNU_SOURCE 1 into pl-thread.c to compile without
    warnings on glibc based systems.

  * FIXED: error handling if alias(Alias) option is used in thread_create/3
    with an already used thread or queue name.  Part of Bug#28, Mike Elston.

  * MODIFIED: succ/2 now only handles natural (>= 0) numbers.  Compatibility.
    See discussion in the mailing list (Richard O'Keefe):
    http://www.swi.psy.uva.nl/projects/SWI-Prolog/mailinglist/archive/2833.html

  * ADDED: library(url): is_global_url/1

  * ADDED/FIXED: Various problems and enhancements to check/0 reporting
    undefined predicates.  Moved make/0 to library(make) and added a
    call to list_undefined/0 to report on undefined predicates after
    completing the make.

  * FIXED: features not available in some port are not reported with the
    exception not_implemented(Category, Description).  Lourens van der Meij.

  * FIXED: Bug #25: compilation on Solaris 8

  * ADDED: op(1150, fx, meta_predicate) to avoid syntax errors if library
    quintus is not loaded explcitely.


VERSION 5.1.8 (Feb 24, 2003)
============================

  * FIXED: Bug #23: profiler on Windows platform crashed.  Holger Kanwischer.

  * DOC: Bug #24: Rearranged description of Prolog flags to be alphabetical
    and added missing documentation.  Holger Kanwischer.

  * ADDED: flag toplevel_print_anon to hide variables starting with an _
    After comments from Attila Csenki.

  * ADDED: pthread_setconcurrency/2 to query/set thread concurrency.

  * FIXED: Alignment problems in message_queue_create/1.

  * FIXED: testing for gcc -pthread in configure.

  * FIXED: Many PL_cleanup() problems, notably related to thread-management.

  * FIXED: compiling pl-atom.c for single-threaded operatation (Barry J Evans).

  * FIXED: exitPrologThreads() counting problem.

  * FIXED: Syntax error in pl-atom.c

  * FIXED: MT: Problem in the atom-garbage collector reclaiming atoms
    in use by other threads.  Sergey Tikhonov.

  * FIXED: MT: Initial thread has wrong status, causing trouble with
    atom garbage collection.  Sergey Tikhonov.

  * ADDED: reload_library_index/0 and automatic reloading if the set of
    library directories changes and predicates cannot be found.  After
    comments by Tolga Konik.

  * ADDED: plld.exe -dll option to create a DLL with Prolog embedded into it.

  * ADDED/FIXED/MODIFIED: Windows: PL_initialise() can now be passed the
    name of a DLL that has a state attached.  Alan Baljeu.

  * FIXED: int->float conversions reading large integers.  Anjo Anjewierden.

  * MODIFIED: PL_get_chars() and friends always return floats in a format
    that reads as a float.

  * FIXED: atom_number('1.0', X).  Added test-cases.  Anjo Anjewierden.

  * ENHANCED: Make library(gensym) thread-safe.


VERSION 5.1.7 (Feb 02, 2003)
============================

  * FIXED: Don't call cleanup of deterministic foreign predicates after
    an abort.

  * FIXED: Bug #19: documentation and status of numbervars/3.  Richard
    O'Keefe and Lourens van der Meij.

  * FIXED: qsave_program/2: ensure the banner is a defined predicate.

  * FIXED: Bug #18: Initialisation problem for single-threaded version
    caused by the addition below.  Lourens van der Meij.

  * ADDED: Prolog flag emacs_inferior_process, which is set to true
    if SWI-Prolog is running as Emacs inferior process.  After comments
    from Michael Covington.

  * FIXED: include <time.h> in pl-stream.c (Anjo Anjewierden).

  * ENHANCED: downcase_atom/2 and upcase_atom/2 performance if both
    arguments are instantiated.

  * FIXED: symbol typo when compiling for threading on systems that do 
    not support recursive mutexes.

  * FIXED: Bug #7: Protocol of typed input in (Windows).  Tolga Konik.

  * ADDED: assume/1 (library(debug)) to call expand_goal/2 on arguments.

  * FIXED: Bug #9: GUI tracer handling string objects (Holger Kanwischer)

  * FIXED: Bug #8: module-specifier while listing declarations.
    Tolga Konik.

  * ADDED: Perform goal-expansion on 2nd argument of findall/3, bagof/3
    and setof/3.


VERSION 5.1.6 (Jan 17, 2003)
============================

  * ADDED: Using ?- set_prolog_flag(prompt_alternatives_no_bindings, true)
    the system prompts for alternative answers on the toplevel if the goal
    makes no bindings.  Requested by Paulo Moura.  Experimental.

  * MODIFIED: deterministic/0 has been replaced with deterministic/1.  It
    also is fixed and its semantics has been changed.  See manual.

  * FIXED: \=@=/2 (Lourens van der Meij).

  * ADDED: relative uri net path resolution (awkward, but needed for RDF
    test-suite).  library(url).

  * FIXED: #2: Handle Control-C in plcon.exe (Windows console app).


VERSION 5.1.5 (Jan 06, 2003)
============================

  * FIXED: Make alarm/4 (library(time), package clib) handle exceptions more
    elegant.

  * FIXED: Quoting rules for plld.c.  Failed to link packages on MacOS X
    (Kuniaki Mukai)

  * ADDED: HTTP package for dealing with HTTP server and client software
    from Prolog.

  * ADDED: library(debug) for dealing with print-statements from your code
    and assumptions you make during development.  Documented in the reference
    manual.


VERSION 5.1.4 (Dec 20, 2002)
============================

  * FIXED: race-condition in autoloader.

  * FIXED: Streams with timeout could signal end-of-file on an interrupt.

  * ADDED: Base sleep/1 on nanosleep() if this function is available.

  * FIXED: copy_stream_data/[2,3] locking problem.

  * FIXED: call_cleanup/[2,3] to pass exceptions properly

  * ADDED: thread_detach/1.

  * MODIFIED: thread_create/3 returns alias-name for id if an alias is
    specified.

  * FIXED: Make Unix I/O restart after an interrupt.

  * ADDED: backquoted_string(Bool) option to read_term and write_term
    (Holger Kanwischer).

  * FIXED: More graceful handling if a thread cannot be created due to
    lack of virtual memory (Wouter Jansweijer).

  * ADDED: first implementation of thread-local-predicates.

  * REORGANISED: introduced abstraction between procedures and their
    definitions to allow for thread-local predicates (work in progress).

  * ENHANCED: profile-utilities to raise proper exceptions.

  * FIXED: Ensure the message queue of a thread is available after
    thread_create/3 returns.  Holger Kanwischer

  * FIXED: manual page for thread_peek_message/2 (Wouter Jansweijer).

  * ADDED: Possibility to add test-scripts to a directory hierarchy.

  * FIXED: thread-cancelation for threads that are in
    thread_get_message/[1,2]


VERSION 5.1.3 (Dec 8, 2002)
===========================

  * MODIFIED: ISO Compliance: retract((head :- _)) also retracts facts.
    Grard Milmeister and Roberto Bagnara.

  * FIXED: make destruction of the Windows console somewhat more careful.
    (Bob Wielinga).

  * ADDED: turning thread message queues into explicit objects.

  * IMPL: Cleanup of thread-message queue, preparing for stand-alone
    object.

  * FIXED: Lost mutex and condition variable after destroying a thread.
    (Mike Elston).

  * FIXED: text-buffering rules for strings (Sebastian Sardina).

  * FIXED: plld: properly quote arguments holding "

  * ADDED/MODIFIED: The toplevel calls expand_goal/2 before actually
    executing the typed goal.

  * FIXED/ENHANCED: Allow goal_expansion/2 to return the same term, in
    which case recursion is stopped.

  * FIXED: possible deadlock when there are Prolog threads created using
    PL_thread_attach_engine() (Unix implementation).

  * PORT: Cleanup windows makefiles for make clean and make distclean

  * ADDED: PL_action(PL_ACTION_ATTACH_CONSOLE) to simplify attaching a
    console to a thread from foreign code.

  * ADDED: PL_thread_attach_engine() `cancel' attribute to determine
    what should happen at halt/cleanup.

  * FIXED: PL_thread_attach_engine() to deal with the `alias' attribute
    and to interpret stack sizes in K-bytes as advertised.

  * ADDED: timeout to Prolog streams.

  * ADDED: Make Prolog safe for pthread_cancel(), canceling threads
    holding a Prolog engine.

  * ENHANCED: `exit' command from debugger in threads exit the thread
    rather then the entire system.

  * MODIFIED: wait_for_input/3 now takes the value `infinite' as timeout to
    wait forever.  The integer 0 has the same function for backwards
    compatibility.


VERSION 5.1.2 (Nov 27, 2002)
============================

  * FIXED: Windows select() cleanup (wait_for_input/3).

  * ADDED: Guitracer: provide editable write-options to detailed term-view.
    Suggested by Wouter Jansweijer.

  * FIXED: backtracking foreign predicates using integer handles (between/3).
    Anjo Anjewierden.

  * FIXED: toldString() didn't unlock current output, notably causing
    warnings from background threads to lock I/O.  Sergey Tikhonov.

  * FIXED/MODIFIED: mutex-locking stragety for I/O after comments from
    Sergey Tikhonov.  Thanks

  * ADDED: non-buffering user_error stream with interactor/0 on Unix/X11.

  * FIXED: stack and detached option parsing in thread_create/3.

  * PORT: Windows, plld.exe: Add /MD to flags and /GX when compiling C++.
    Use libpl.lib, even for the MT version.  SWI-cpp.h: deal with MSVC
    if it fails to recognise throw doesn't return.

  * FIXED: error message for illegal export list (Holger Kanwischer).

  * PORT: Check for -lexc on Tru64/DUnix when compiling for multi-threading
    (Sergey Tikhonov).

  * FIXED: make qsave work if predicates from library(lists) are
    redefined (Sergey Tikhonov).

  * FIXED: Scanning resource-file without using mmap().  (Sergey Tikhonov).

  * FIXED: Detection of mmap() for regular files (Sergey Tikhonov).

  * FIXED: Avoid calling flatten from library(lists) in toplevel.pl.
    Wouter Jansweijer.

  * FIXED: PL_open_query() on auto-loaded procedures cause data corruption.

  * FIXED: IOSTREAM Locking problem in set_stream/2.

  * FIXED: Extranous unlock in format/[2,3].  Diagnosed by Sergey Tikhonov.

  * FIXED: Proper handling of pthread error codes.

  * FIXED: listing/1 and friends (bug due to moving list predicates).
    Anjo Anjewierden.

  * ADDED: thread_statistics/3: get statistics on other threads.

  * PORT: MacOS X: check for both plain symbol and _symbol on
    call_shared_object_function/2 to deal with different versions of
    the dlcompat library.

  * FIXED: Preserve exceptions in GUI tracer (notably abort).  Kanwischer
    Holger.


VERSION 5.1.1 (Nov 16, 2002)
============================

  * FIXED: Atom-reference corruption problem for the `built-in' atoms.
    With many thanks to David Schumann who found the problem, sometimes
    trapping the assertion assert(p->references >= 0); in
    PL_unregister_atom().

  * MODIFIED: moved list-processing primitives to library(lists), where
    most Prolog systems have these.  Using the autoloader this should
    have no consequences for most applications.

  * PORT: Adapt Windows makefile suite for use with Windows 2000 and
    spaces in the destination path

  * FIXED: deadlock when loading a file with a module-name conflict.

  * FIXED: Removed size-limit on clauses of 256Kbytes compiled code.
    Spotted by Wouter Jansweijer.

  * ADDED: atom_number/2 as a contraction of atom_codes and number_codes/2

  * PERFORMANCE: switched to use -O3 on GCC.  Seems to be about 5-10%
    faster.  Also pass -O3 to ld to optimize function placement.

  * FIXED: handle abort-exception from -g goal to go to the toplevel.

  * PERFORMANCE: better implementation finding clauses, much faster
    shallow backtracking code.  Faster lookup of arithmetic and small
    improvements to the compiler.

  * FIXED: bug loosing clause-indexing after abolish on an undefined
    predicate (caused by MT redesign).

  * FIXED: load .pl files rather then .qlf if user told us so.  Thanks to
    Holger Kanwischer.

  * MODIFIED: use ; as separator for the -p alias=path1:path2 option
    on MS-Windows.  Mike Elston.

  * FIXED: deadlock reconsuling files with breakpoints (debugger).

  * FIXED: remove rc/rc.o from libpl.a (anonymous).

  * FIXED/ENHANCED: many issues use call_with_depth_limit/3: fixed
    determinism	test, handle exceptions, handle user-defined arithmetic
    and report exceeded limit in the debugger.  With help of Steve Moyle.

  * FIXED: Improve error message if a user-arithmetic function fails.

  * FIXED: module-transparency of is/2, etc to make arithmetic function
    declarations work again.  Steve Moyle.

  * ADDED: edit/0 to edit the default script- (-s file) or associated file.

  * LIBRARY: make read_line_to_codes return the atom end_of_file upon reaching
    the end of file.

  * PORT: improve portability of SWI-Prolog.h and SWI-cpp.h after comments
    from Silvio Malisani concerning Borland's C++ Builder 5.I.

  * FIXED: preserve exceptions with the GUI-tracer over callbacks to the
    tracer.


VERSION 5.1.0 (Oct 26, 2002)
============================

  * FIXED: call_cleanup/3 when called directly from PL_next_solution()
    or tail-recursively from the initial goal.

  * ENHANCED: use per-message-queue mutex for synchronising the
    queue access in the MT version.  Sergey Tikhonov.

  * PORT: Check whether mmap() can map regular files and check for
    the need of _XOPEN_SOURCE.  Fixes QNX portability. See
    http://gollem.swi.psy.uva.nl/twiki/pl/bin/view/Porting/BuildQNX
    
  * ENHANCED: allocate clause as one chunck, reducing allocations and
    memory-requirements and improving locality.

  * ENHANCED: Multi-threaded performance:

	- No longer use reference-counts on static code but use clause
	  garbage collection to collect redefined static procedures.
	- Large reduction of access to thread-local data by passing
	  this data around and use one-fetch-per-function more widely.
	- Introduced thread-local heap-allocation policy to reduce
	  the use of locks.

  * ADDED: multi-threading support in the windows version based on
    pthread-win32, an Open Source emulation of POSIX threads on
    Win32.  Progress:

	- Kernel running on top of pthread-win32
	- Console code (plterm.dll/plwin.exe) allows for multiple consoles
	- Basics seem to work fine.
	- Now uses CRITICAL_SECTIONS and Windows native TslGetValue() to
	  improve performance.  Slow down is now 12% compared tolisting(library_directory).

	  single-threading.

    Consequences:

	- All access to the console using plterm.dll and console.h is
	  incompatible due to an extra console-handle argument required
	  by all functions.

VERSION 5.0.10 (Sep 26, 2002)
=============================

  * FIXED: incorrect messages about not being able to import predicates
    from module user.

VERSION 5.0.10a (Sep 25, 2002)
==============================

  * ADDED: plwin.exe: win_window_pos/1 to control the geometry and zorder
    of the console.

  * FIXED: thread_peek_message/1 unification problem if the head message
    didn't unify (Sergey Tikhonov).

  * FIXED: Demo .plrc (pl.ini) to use the flag `gui' rather than `xpce' to
    see whether to load the gui-tracer (Jakub Jiricek).

  * FIXED: GUI tracer: check whether file is modified outside the built-in
    editor.  (Jakub Jiricek).

  * FIXED: Properly compile A *-> B (without else-branche) to a normal
    conjunction.  (Jakub Jiricek).

  * FIXED: GCC 3.2/SPARC problems and Solaris 9 portability issues.
    Thanks to Pieter Donche for providing access to their machine.

  * FIXED: Various MacOS 10.2 portability issues (Paulo Moura).

  * FIXED: portray_clause(q:-x*->y).  (Jakub Jiricek).

  * ADDED: Handle *-> in DCG (Jakub Jiricek).

  * FIXED: Cleanup dangling records in findall/3 and friends if an abort
    happens inside one of the bag predicates.


VERSION 5.0.9 (Jul 26, 2002)
============================

  * FIXED: Report variables _starting_ with an _ (e.g. _X) in the
    variable_names(Names) option of read_term.

  * FIXED: tmp_file/2 problem in library(emacs_interface). Tolga Konik.

  * ADDED: -nosignals option to inhibit signal handling.  Added a section
    to the manual about embedding in complicated environments. With help of
    David Sitsky.  

  * PORT: Removed static linking of frame.o.  Shouldn't be needed anymore
    and raised problems on PPC Linux (Aaron Macks).  Typo found by
    Paulo Moura.


VERSION 5.0.8 (Jul 7, 2002)
===========================

  * FIXED: quoted write of negative floats could write as integer.

  * FIXED: registry_get_key/[2,3] (undefined predicate).  Also prepared
    for use inside saved-states.  Published shell_register_file_type/5.

  * ADDED: PL_NCHARS option to PL_unify_term().

  * ADDED: current_prolog_flag(pid, Pid) to get the process identifier.

  * ADDED: gtrace/0 as alias for guitracer,trace.

  * ADDED: PL_get_file_name() to fetch the name of files from Prolog
    terms with options to include search, test properties, etc.
    
  * REMOVED: Undocumented interface function PL_get_filename().  Please use
    the new PL_get_file_name(), providing a stable and much more flexible
    API.

  * FIXED: compilation error on systems where profiling doesn't work
    (Pierre Barbier de Reuille).


VERSION 5.0.7 (Jun 5, 2002)
===========================

  * FIXED: Informational messages from the PLWIN.EXE console when opening
    a URL. 

  * FIXED: Editor handling problems.

  * ADDED: Statistical profiling to the Windows version.  Also modernised
    the Unix profiling implementation a bit.

  * FIXED: string_to_list(-String, +List) crash on machines with
    signal-based stack-expansion with lists of >500,000 elements
    (Wouter Jansweijer).

  * ADDED: Borland C compatibility in the SWI-Prolog header files.
    Additional information using SWI-Prolog with BC is in
    http://gollem.swi.psy.uva.nl/twiki/pl/bin/view/Foreign/BorlandC
    By Gerhard Wolfstieg.

  * MODIFIED: More improved classical I/O compatibility in telling/1
    and seeing/1.  Peter Dadam.

  * FIXED: Source-level debugger: be aware that clauses holding floats
    that are written and read-back may not unify exactly due to float
    rounding errors.

  * FIXED: quoted write to write floats using decimal dot or exponent,
    regardless of the float-format in effect.

  * ENHANCED: Skip intermediate system-predicates when walking `up' in
    the source-level debugger.

  * ENHANCED: Clear source-location on close/1 of the file currently
    holding it.

  * ADDED: allow for swapped 2nd/3th argument in absolute_file_name/3.

  * MODIFIED: relative_to(FileOrDir) to assume the relative-to is a 
    directory if nothing is known about it (Nikolaos Angelopoulos).

  * FIXED: Some manual typos (Nikolaos Angelopoulos).

  * FIXED: GC/GUI-Tracer crash related to the compilation of \+ if the
    argument contains non-singleton variables that appear nowhere else
    in the clause and in the argument of a compound term.  Thanks to
    Sergey Tikhonov for providing a neat small crash-demo!

  * FIXED: working_directory/2 to raise a proper exception if it can't
    get the working directory (crashed).

  * FIXED: MT: lookup/register/unregister atom mutex mismatch.
    Sergey Tikhonov.

VERSION 5.0.6 (May 21, 2002)
============================

  * ADDED: absolute_file_name/3 file-type `source' and option relative_to
    for easier compatibility to SICStus (who changes the argument-order as
    well). Nikolaos Angelopoulos.

  * FIXED: Be more consistent on attempts to redefine system predicates.
    Tolga Konik.

  * ADDED: type-check on 2nd argument of absolute_file_name/2 as well as
    a new option expand(Boolean) to control expanding meta-characters.

  * FIXED: MT: At halt/0, joint threads that are already terminated rather
    than canceling them.

  * FIXED: MT: avoid race-conditions in atom-garbage collection when creating
    new threads or threads are about to end.  Patch by Sergey Tikhonov.
    Thanks!

  * FIXED: expand_file_name/2 to return directories again.

  * FIXED: module(Module) argument of read_term/[2,3], fixing GUI-Tracer
    problems when using local operator-declarations.

  * PORT: pl.spec (building RPMS) to follow current standards.
    By Michel Alexandre Salim.

  * FIXED: Choicepoint-view of GUI tracer.

  * PORT: Added -fno-strict-aliasing when compiling using gcc, needed for
    gcc-3 (Lourens van der Meij)

  * PERFORMANCE: Allow a certain (16%) amount of `dirty' clauses
    in a predicate, also if the reference-count is 0 when starting a retract.
    This makes a *tremendous* difference retracting 60,000 facts from a
    predicate holding almost 600,000 facts.

  * FIXED: GUI-tracer source-location problems with (If->Then).

  * FIXED: PLWIN.EXE getting into a loop after using Page Up/Down buttons.
    Yair Greenberg.

  * FIXED: qsave_program/2: properly handle small and 0 (= max) stack-size
    specification.  Detmar Meurers.

  * FIXED: Flush user_output before query/error messages in the toplevel,
    avoiding confusion due to stream-buffering for more simple cases.
    Martin Sondergaard.

  * FIXED: Correctly perform unquoted write on atoms starting with a 0-byte.
    Mike Elston.

  * FIXED: make exists_file/1 and exists_directory/1 properly say no if the
    filesystem object is not of the right type.  Dr. Werner Wolff.

  * ADDED: Windows: mkboot.bat script to the bin-directory to easily redo
    the boot-compilation.

  * FIXED: Windows: make double-clicking possible on filenames holding
    special characters.  Reported by Graham Thomason.

  * ADDED: downcase_atom/2 and upcase_atom/2 to do quick case-conversion
    on atoms.

  * FIXED: reporting boolean features using the FEATURE mask.

  * FIXED: quicker and more graceful stack-overflow exception from sort/2
    if available local-stack space doesn't suffice (Anjo Anjewierden).

  * FIXED: Editor-handling based on $EDITOR (Ulrich Zimmermann).

VERSION 5.0.5 (April 16, 2002)
==============================

  * PORT: Hopefully get plld -shared -o test.so test.c to produce foreign
    libraries on BeOS.  With lots of help from Axel Drfler.

  * FIXED: Avoid re-loading the initial file after qsave_program/2 from
    PLWIN.EXE (Ron Sele).

  * MODIFIED: Improved tell/1 and see/1 compatibility with Edinburgh
    `standard', allowing for `interleaved I/O'.  After a couple of
    complaints that text-book code was broken.

  * FIXED: Various problems in the manual (rjan Johansen).

  * FIXED: expand_file_name/2 handling of ~fred (rjan Johansen).

  * DEBUGGER: Modified the trace-hooks to examine choice-points as first
    class objects.  Adjusted the GUI tracer to use the new code.  This
    opens the route for better handling of choice-points in the debugger.
    for now it just avoids a crash of the GUI tracer on particular code
    where the old view didn't work.

  * PORT: Allow for compiling using Compaq compilers (__DECC) on Tru64
    Linux/Alpha (Sergey Tikhonov).

  * ADDED: Read `hello world` as a string if the Prolog flag backquoted_string
    is true (LPA compatibility, Holger Kanwischer).

  * FIXED/ADDED (MT-Version):

	* Atom-gc problems
	* assert/retract corruption
	* Atom reference counting deadlock
	* Added thread_self/1 to the single-threaded version (returning
          main).
	* Added thread-indication to warning and error messages in
	  print_message/2.

    Most of this hard work by Sergey Tikhonov.  Thanks!

  * DOC: Various updates to web-references and XPCE references

  * FIXED: PL_cons_functor_v() and related interface functions: forgotten
    dereference (Fabien Todescato).

  * PORT: Added (non-tested) support for loading shared objects in BeOS
    (with help by Axel Drfler)

  * PORT: Detect <SupportDefs.h> in recent BeOS and use it (Axel Drfler).

  * PORT: Fixed detection of ru_idrss in struct rusage (not around in BeOS,
    reported by Axel DÃ¯Â¿Â½rfler).

  * FIXED: Documentation on obsolete prolog_navigator/1 replaced by new
    prolog_ide/1.  Fixed prolog_ide(open_navigator(Dir)) (Tolga Konik).

  * MODIFIED: Home/End keys in PLWIN.EXE to go to the start/end of the line.

  * ADDED: Wheelmouse support to PLWIN.EXE

  * ADDED: Windows: support for UNC-filenames (\\host\share\...).

  * FIXED: call_cleanup/3 crashed if the cleanup handler invoked GC.  GC
    is now explicitely blocked.  Found by Mike Elston.

  * callProlog(): replaced warning with exception.

  * IDE: Avoid various problems selecting the preferred editor.  See the
    new prolog-flag `editor' and the example .plrc (pl.ini).

  * INSTALL: Added some code to configure and Makefile.in in the top-directory
    to allow for ./configure --with-world && make && make install to build
    the complete suite on a well-supported platform.

  * INSTALL: Fixed detection of profiling support on really fast machines
    (Sergey Tikhonov).


VERSION 5.0.4
=============

  * DOC: re-arranged sections on I/O handling a bit to clarify the position
    and relation between Edinburgh-style and ISO I/O handling.

  * ADDED: prolog_load_file/2: a hook into load_files/2.

  * MODIFIED: source_location/2 no longer changes the filename into an
    absolute path (instead, it is the path used to open the file).

  * ADDED: set_stream(Stream, file_name(Name)) and set_stream(Stream.
    record_position(Bool)).

  * ADDED: loading a program from a stream.  See load_files/2 for details.

  * FIXED: plwin.exe: console placement to use
    SystemParametersInfo(SPI_GETWORKAREA, ...) to determine the boundary.
    Also, get current window position from GetWindowsPlacement().
    (Tolga Konik).

  * MODIFIED: Prolog Navigator now calls default edit/1 interface (suggested
    by Tolga Konik).

  * ADDED: EWOULDBLOCK handling in pl-stream.h, so we can use this interface
    on machines that do not support this error (Windows).

  * FIXED: Various minor improvements in the Windows registration of Prolog.

  * ADDED: unwise_install to wise.pl to do the registration after running
    Wise.

  * FIXED: qsave_program handling of loaded foreign libraries.  Reported
    by Fabien Todescato.

  * ADDED: GUI-Tracer: add pseudo variable names DCG_list and DCG_tail

  * ADDED: plwin.exe: add menu item to edit the `associated' file.

  * FIXED: Various GUI-Tracer problems concerning source-location in DCG
    rules.

  * FIXED: Properly handle breakpoints in $xr_member/2 (used by explain/1).


VERSION 5.0.3
=============

  * FIXED: Win32: Various issues in the TCP/IP package (library(socket))
    and XPCE socket handling: Better error checking and messages and proper
    handling of WSAEWOULDBLOCK messages.

  * PORT: No longer print a message if the locale cannot be initialised.
    A bit dubious, but some installations appear to have a broken locale
    subsystem.

  * FIXED: Non-portable test in config.guess (Kenneth Pronovici).

  * FIXED: reported undefined predicate by check/0 on plcon.exe (Mike Elston).

  * ENHANCED: Allow for PL_set_feature() before PL_initialise().  Improved
    initialisation procedure for plwin.exe for better compatibility with
    the other versions.

  * ENHANCED: Cleanup procedure on Windows library(shlib) and PL_cleanup():
    try to avoid (some) crashes when unloading foreign code.

  * FIXED: Properly deal with the vararg foreign calling convention
    for cleanup (CUTTED).  Spotted by Sergey Tikhonov.

  * FIXED: Check whether stack sizes are not allocated above physical
    limits (128 MB on 32-bit machines)

  * BUILD: Fixed missing references to `runtex' from various Makefiles
    in the packages (Paulo Moura).

  * FIXED: File/Consult menu of plwin.exe to load the file into the
    user module rather then the win_menu module providing the menu
    interface.

  * FIXED: Use GetWindowsDirectory() rather then the current drive as
    last resort for expanding ~.

  * PORT: Add -fno-strict-aliasing when using GCC.  SWI-Prolog doesn't
    satisfy the requirements for this optimization and some gcc versions
    seem to use it using -O2.


VERSION 5.0.2
=============

  * ADDED: library(time) to the clib package, providing alarm and timeout
    functions.  Works on Unix systems having setitimer() as well as on
    Windows using Multi Media timers.

  * ADDED: PL_handle_signal() to handle synchronous interrupts from foreign
    code.  Option PL_SIGSYNC to PL_signal() to schedule synchronous
    interrupts.

  * FIXED: Try to be a bit more intelligent on the expansion of ~ (home)
    in the Windows versions by checking the various alternatives to be
    existing and writeable directories.  Now prefers %USERPROFILE% over
    %HOMEDRIVE%\%HOMEPATH%.  With help from Lee Sanders.

  * FIXED: PL_recorded_external() handling ground terms.  Spotted by
    Volker Wysk.

  * FIXED: Multi-threaded version: make sure the thread itself thinks
    it exists right from the start (Lyosha Ilyukhin).

  * ENHANCED rl_add_history/1 does not add a line to the history if it is
    the same as the last line added (Anjo Anjewierden).

  * FIXED: Errornous messages on recursively receiving (error) signals.

  * FIXED: Various issues in the GUI tracer, making the trace more
    intuitive, print pending exception-terms in the status window,
    and fix some source-location handling problems.

  * FIXED: when loading foreign libraries in `system mode', the loaded 
    predicates are available to the tracer as other built-in code.  This
    fixes tracing XPCE code.

  * ADDED: option qcompile to load_files/2.

  * ENHANCED: Replaced some more warnings with exceptions in pl-trace.c

  * PORT: Port to MacOS X (darwin), with help from Paulo Moura.
	- Various BSD enhancement to configure
	- Make plld aware of the -bundle -bundle_loader stuff
	- Deal with foreign symbols starting with a _
	- Resolve some macro conflicts
	- Various missing :: in Makefiles (needed on case-insensitive
	  filesystems like Mac HFS+)

  * MODIFIED: compiling/0 now also succeed during execution of all directives
    when compiling a state or qlf file.

  * FIXED: Make compilation in `runtime' mode work again
    (Lourens van der Meij).

  * FIXED: GUI tracer to handle the dynamic code used for handling compound
    meta-calls.  Found by Holger Kanwischer.  Thanks.

  * FIXED: make pl-wam.c compile in `runtime mode'.  Lourens van der Meij,

VERSION 5.0.1
=============

  * PORT: Make sure all packages are compiled with plld and passed -fpic
    to fix building shared objects on some platforms.  Reported by
    Michael Piefel.
    
  * PORT: Updated config.sub and config.guess using SuSE 7.3 versions.

  * FIXED: configure message if libreadline is not found.

  * FIXED: Installing the manuals by Pixel <pixel@mandrakesoft.com>

  * UPDATED: web-locations in help and Windows console.

  * MODIFIED: is_list/1 now checks for a poper list.  proper_list/1 has
    been moved to library(backcomp).  Thanks to Richard O'Keefe for pointing
    out this non-standard behaviour.

  * FIXED: name-clash in plld.c on AIX (Victor Bancroft).

VERSION 5.0.0
=============

  * ADDED: menu to PLWIN.EXE (the windows normal executable).  These menus
    can be programmed from Prolog. 

  * FIXED: make/0 detection of directories to update when using MKINDEX.pl
    (reported by Holger Kanwischer).

  * ADDED: autoload(Bool) option to load_files/2 to allow external packages
    to use the verbose/silent loading of demand-loaded files.  Now used for
    the pce_autoload/2 declaration.

  * FIXED: random/3 in library(quintus).  Thanks to Peng Te.

  * FIXED: improved type-checking converting code-lists or character-lists
    to text.  The routine is now also faster, especially if the argument is
    not a valid codelist of character list.

  * MODIFIED: Renamed write_ln/1 into writeln/1 for better compatibility.
    Added write_ln/1 to library(backcomp), so existing code shouldn't be
    bothered.

  * FIXED: sub_atom(+,-,-,+,-): crash on backtracking.  Thanks to Anjo
    Anjewierden.

VERSION 4.1.0
=============

  * ADDED: statistics/2 to recognise the keys used by Quintus and SICStus,
    for improved compatibility.

  * ADDED: library(main) for simple #! scripts processing the commandling.

  * FIXED: Make file_search_path/2 resolved paths relative to the current
    working directory work properly after changing CWD.  Reported by Bert
    Bredeweg.

  * ADDED: working_directory/2 to query/change working directory, providing
    better compatibility and a non-hacky way to get the current directory.

  * FIXED: Another problem handling `inlined' calls for the new implementation
    of call/1.  Thanks to Lyosha Ilyukhin.

  * FIXED/PORT: Win32 missing cleanupTerm(), some signed/unsigned problems
    in debug mode.

  * ENHANCED: latex2html to use \label{} following a \*section or \chapter
    as base for constructing a filename for that section.  Changed manual
    sources to give all chapters and sections a label.  This gives sections
    from the SWI-Prolog HTML manual a more stable URL.

  * FIXED: Problem handling `inlined' calls for the new implementation
    of call/1.  Thanks to Lourens van der Meij.

  * FIXED: Printing syntax errors holding ~-characters to avoid problems
    with format-special characters.  With patch by NIDE Naoyuki.  Thanks.

  * ADDED: Allow for MKINDEX.pl to control indexing process of library
    directories for auto-loading.

  * ADDED: call_cleanup/2 and call_cleanup/3.

  * ENHANCED: handling of call/1.  Instead of doing a full compilation of
    the clause the temporary clause now shares terms from the goal and
    is stored in the stack-frame itself.  In general call/1 will be faster
    when used on a term holding control-structures (,/2, ;/2, ->/2, etc)
    and does not suffice from getting slower when argument-terms get bigger.
    In addition, no unsolicitated copying of terms takes place.

    PLEASE TEST AND BE CAREFUL ON PRODUCTION SYSTEMS!!

  * FIXED: Stack overflow detection in PL_unify_list() and
    PL_unify_functor() on machines without mapped stacks (i.e. using the
    stack-shifter).

  * FIXED: current_predicate/1 using the pattern A:B/C (i.e. generating
    modules).  Also added current_predicate/1 to the manual.  
    Reported by Tolga Konik.

  * FIXED: Updated pl-term.c to fit with multi-threaded code as well as
    behave properly on PL_cleanup() followed by re-initialisation.

  * ENHANCED: Change errors in pl-term.c predicates to raise exceptions
    rather then just warning messages.

  * PORT: Now decided to allow for unaligned access only on systems where
    we *know* it works and is faster then emulating it (Intel x86).
    Improved hppa architecture detection.  Thanks to Michael Piefel.

  * ENHANCED: Better error message on common syntax-error leaving an
    extra `,' or `;' before ) or end-of-clause.

  * PORT: Improved configure check for non-aligned access on long values.
    On the ARM processor such access doesn't result in a crash, but in
    incorrect result.  With help of Sergio Martinez.

  * FIXED: Added overflow test for too many (>32 million) atoms.  TBD:
    turn into proper exception, but getting a relyable exception from
    PL_new_atom() is very difficult.  This at least is better than
    an uncontrolled crash.

  * FIXED: wait_for_input/3 crash if stream-list contains an
    non-stream.

  * FIXED: Handle "-F base" option in combination with -c file.pl.
    Reported by Alok Singh.

  * FIXED: configure when readline could not be found.  Nide Naoyuki.

  * ADDED: "-F base" option to plld, allows for embedding XPCE.

  * FIXED: Proper type-check on 1st argument of thread_create/[2,3]
    to avoid a low-level error when started with an invalid goal.

VERSION 4.0.11
==============

  * PORT: Integrated patches by John Towler, mostly dealing with
    building XPCE and the other SWI-Prolog packages on NetBSD.  Many
    apply to other BSD variations.  Thanks!

  * FIXED: Many typos and some clarifications in the manual pointed out
    by Jack Keel.  Thanks!

  * FIXED: predicate reference handling when running out of stack.  This
    could leave the system unstable after an out-of-stack, especially
    caused by dynamic code.

  * FIXED: Documentation of file_directory_name/2 (Lourens van der
    Meij).

  * PORT: Deal with missing rl_done declarations from older readline
    libraries (Nide Naoyuki).

  * FIXED: Language setting for test.pl (Nide Naoyuki).

  * FIXED: Check argument domain of random/1 and properly report error.
    Spotted by Pablo Lopez.

  * FIXED: Avoid absolute_file_name/[2,3] to dig indefinitely for
    non-existing paths if there is a recursive definition in the search
    paths (Bob Wielinga).

  * ADDED: set_prolog_flag(verbose_file_search, true). to make
    absolute_file_name/[2,3] print what it is doing.

  * FIXED: Avoid crash in concat_atom/2 when called with a list holding
    variables (Lourens van de Meij).

  * FIXED: avoid using alloca() in recorded terms with many variables.  Found
    by Lyosha Ilyukhin.

  * MODIFIED: current_thread(id, X) to fail silently if id is of the right
    type, but the thread doesn't exist.  dima@solvo.ru.

  * FIXED: library(readutil), read_file_to_terms: option handling and
    end-of-file detection.

  * FIXED: writef('\\X'), where is is not a digit raised exception.  Now
    writes \X.  Patch by Lyosha Ilyukhin.

  * FIXED: report "x, ), y" as syntax error rather then , ')', y.  Reported
    by Tolga Konik.

  * ADDED: installation of dotfiles (Unix Makefile)

  * ADDED: edit/1 to include definition for uedit32 (Tolga Konik)

  * IMPROVED: edit/1 feedback when calling user editor through shell/2.

  * FIXED: Cleanup after exceptions inside the generator of
    bagof/setof/findall.  Left inconsistent linked-list with possibility
    for random crashes on further use of these predicates.  Spotted by
    Lourens van der Meij.

  * ADDED: option lock to open/4, providing simple fcntl() based advisory
    locks on files.  POSIX only (Windows says it is, but appearently this
    isn't true as they don't have fcntl()).

  * MAINTAIN: Some improvements to manual generation (Serg Korolyov).

  * FIXED: expected type in sub_string/5 (Pierre.Nugues)


VERSION 4.0.10
==============

  * FIXED/ENHANCED: Win32: Various issues around installation.

  * FIXED: Prefer %HOMEDRIVE%\%HOMEPATH% over %USERPROFILE% for expanding
    ~ on Windows.

  * FIXED: MT version: cleanup mutex after closing a stream.  Memory leak
    detected by Andrew V. Diatchkov.

  * PORT: On machines using FPE rather then IEEE754 math error reporting
    supporting the fpsetmask() interface, use this interface to make math
    errors IEEE754 compliant.  This applies to FreeBSD upto 3.x.  Thanks
    to NIDE Naoyuki for a clear explanation and fix.

  * MODIFIED: Windows.  If Prolog was started as <exe> <file.pl> and file.pl
    is a script file, change directory to the directory holding the <file.pl>.
    This makes starting a script by opening it from the explorer and dragging
    a script on plwin.exe behave the same.

  * FIXED: Mistake handling script arguments (#!): forgotten string
    termination.

  * FIXED: "nmake /f makefile.mak DBG=true install" to install .PDB files for
    all .EXE and .DLL files making up SWI-Prolog.

  * ADDED: Allow single-keystroke selection of edit/1 with upto 10
    alternatives.

  * PORT: deal with latest libreadline that renamed
    filename_completion_function into rl_filename_completion_function.
    Thanks to Lourens van der Meij.

  * ADDED: edit/1 now merges more specific with more general matches:
    matching just a file is overruled by a match on the same file with
    a line number.  This implies that edit(Pred), where Pred is the
    name of a predicate in a file with the same name will immediately
    jump to the predicate.

  * FIXED: Two more mutex handling problems with patch contributed by
    Emerson dos Santos.

  * FIXED: with_mutex/2 deadlock, reported by Lyosha.

  * ADDED: library(socket): tcp_setopt/2 to set options on sockets.

  * FIXED: make library(socket) ready for multi-threaded operation.

  * FIXED: plld detection of multi-threaded version.  Patch by
    Kirill Evstigneev.

  * FIXED: wait_for_input/3 to check for input buffered in the Prolog
    stream.  Reported by Leonid V. Khramov.

  * FIXED: profiler/2 not to reset profile statistics.  Spotted by
    Mike Elston.

  * FIXED: <, >, =<, etc to handle user-defined arithmetic functions
    properly.  Reported by Emerson dos Santos.

  * ADDED: library(mime) as part of the clib package for parsing MIME
    serialized objects.  Requires maildrop development libraries installed.
    Currently Unix only.

  * MAINTAIN: Added "nmake /f makefile.mak DBG=true" to Windows building
    suite to make a version ready for debugging using MSVC.  Still to
    to: install all .pdb during "nmake /f makefile.mak DBG=true" install.

VERSION 4.0.9
=============

  * ADDED: 0.5 second delay after printing an ERROR: line, making error
    recovery on fast-scrolling messages easier.

  * FIXED: Memory management problems in Windows version introduced
    in 4.0.8.

  * ADDED: PL_get_char() to accept a 1-character string, so put(" ")
    writes a space.

  * FIXED: Two-step import/export of predicates with special ordering
    of the loading.

  * FIXED: While checking the export list of a module, consider imported
    predicates defined, even if they have no definition.

  * ADDED: The following predicates where added to library(quintus):
    compile/1, midstring/[3-6], date/1, subsumes_chk/2.

  * ADDED: library(occurs), a Quintus compatible library for subterm
    relations.

  * ADDED: library(ordsets), a very partial implementation of this
    Quintus compatible library.

  * FIXED: compilation of pl-load.c on MacOS X (Paulo Moura).

  * ADDED: library(qpforeign) to load Quintus foreign code.

VERSION 4.0.8
=============

  * FIXED: Guitracer not closing a stream when tracing decompiled
    (e.g. dynamic) code.

  * PORT/ADDED: Started moving the trouble of compiling and linking
    foreign packages into plld.  It now supports the following to
    generate x.so, x.dll, ... from the given object files.

    	plld -shared -o x object-file ...

  * PORT: Lots of stuff to make SWI-Prolog compile under Cygwin, the
    open source POSIX layer for Windows.  Added README.cygwin for
    details.
			
VERSION 4.0.7
=============

  * FIXED: stream_property/2 to report close_on_abort.  Was documented,
    but not implemented ...

  * ADDED: Informational print message when abort closes a stream.

  * ADDED: close_hook to IOSTREAM to allow setting a foreign hook on the
    closure of any stream  

  * ADDED: library(memfile) to the package clib providing streams to
    memory-buffers.

  * ADDED: library(cgi) from package clib is now standard part of the
    Windows distribution.

  * ADDED: stream_property/2 and set_stream/2 set and query the buffer mode
    of existing streams.  Also added eof_action(Action) and
    close_on_abort(Bool) to set_stream/2.

  * MODIFIED: The sequence X=!, X doesn't cut any longer as this was
    in conflict with the ISO standard (Bart Demoen).

  * FIXED: Memory leak when an exception is thrown from the generator
    of findall/3, bagof/3 or setof/3.  Reported by Bart Demoen.

  * FIXED: Possible infinite loop looking for attached state.  Spotted with
    fix by Nide Naoyuki.   Thanks!

  * PORT: Added various issues to make SWI-Prolog compile on BeOS.  Thanks
    to Axel Doerfler.

  * FIXED: Make plld using -lplmt if prolog is multi-threading.  Reported
    by Sergey Tikhonov.

  * ADDED: Documentation for library(check), library(registry),
    library(netscape) and library(url).

  * ADDED: library(readutil) with some utility predicates to read larger
    units from streams and files.  Started structured documentation of
    the library in the SWI-Prolog reference manual.

  * ADDED: simple/1 to quintus compatibility library.  Also exported some
    more of the predicate-based arithmetic from there.

  * ADDED: Notes on slight but useful difference between ISO and SWI
    exception-handling to the manual of throw/1.  Thanks to Bart Demoen.

  * ENHANCED/FIXED: expand_file_name/2.  Problems when expanding to files
    holding wildcards in their name and removing the limit on matching files
    (was 1024).  Completely re-written the filesystem code.  Pattern-matching
    code is retained.

  * FIXED: include/1, reported by Sebastian Sardina.  Bug introduced in
    4.0.4.

VERSION 4.0.6
=============

  * PORT: Fixed PL_unify_term() and calls to distinguish between int and
    long.  User foreign-code that must be portable to 64-bit should verify
    their calls.

  * PORT: Fixed string-handling on 64-bit platforms.  Made the compilation
    of all tools and standard libraries fairly clean on the INTEL Itanium
    (Merced) processor using gcc and Linux.  Thanks to the SuSE team for
    providing access to their hardware.

    Make all default stack-limits a factor of the word-length

  * PORT: Included some patches from the SuSE team.

  * ENHANCED: MT-Version: install libpl.a as libplmt.a for the
    multi-threaded version.

  * FIXED: MT-Version: open xterm for thread on systems using the
    /dev/pts filesystem.  On these terminals the xterm is started
    using <basename of slave>/<descriptor>

  * FIXED: MT-Version: deadlock and corruption problem.  Modified
    mutex-structure slightly, so new problems may have been be
    introduced.

VERSION 4.0.5
=============

  * FIXED: Actually make re-hashing predicates work.  This bug causes
    large (dynamic) predicates that are queried while they are build
    to show linear rather than constant-time access behaviour.  Performance
    difference on victim programs can be dramatic!

  * ENHANCED: GNU-readline interface.  Detect useful additions from readline
    4.2, avoid type-conflicts and handle re-entrance through XPCE much more
    cleanly as well as aborts.

  * PORT: Many C-compiler warnings, making the native IRIX cc compile
    SWI-Prolog silently.  Improved detection of wait() variations.
    Thanks to Jean Wang for providing me with access to their machine.

  * ENHANCED: Handling of prolog_edit:select_location/3.  Enhancement
    exploited by XPCE to use GUI-based selection if running from GUI.

  * ADDED: -s file to load a script-file in addition to the user
    initialisation file.

  * ADDED: -q commandline option to make the system operate silently.

  * ADDED: PrologScript support using #!, providing direct scripting
    in Unix and additional parameters on MS-Windows.

  * FIXED: Wipe the anonymous clauses for meta-calling on $dcall/1 as
    soon as possible.  Reported by Stefan Mueller.

  * ADDED: Save home in saved-state for class development and kernel.  This
    enables saved-states to find the installed SWI-Prolog.  Especially
    useful for Windows.

  * ADDED: Save default stack limits in the Windows registry and add a
    menu item to the manpce/0 File/Edit Preferences menu to manage these
    registry settings.


VERSION 4.0.4
=============

  * FIXED: Problem in GUI tracer tracing predicates loaded from ?- [user].

  * MODIFIED: The file-reading predicates (consult, use_module, load_files,
    etc.) no longer change current input to the file loaded.  This implies
    that read/1 and friends read from the current input before the load
    predicate was started rather then the file we are loading from.

  * FIXED: Setting break-points on facts, or in general on the last
    (I_EXIT or I_EXITFACT) instruction of a clause.

VERSION 4.0.3
=============

  * ADDED: New hooking system for help/0, help/1 and apropos/1.

  * FIXED: Allow for -f "c:\..." in Windows.

  * ENHANCED: Moved boot/listing.pl to the library, reducing the
    footprint and startup time.  Also modernised the code a bit,
    allow for hooks, so listing(class->method) lists an XPCE method
    and allow for partial listing: listing(foo(a, _)) to get only
    the clauses for which a unifies to the first argument.

  * FIXED: tracer not to trap cut-port in system predicates (GUI).

  * FIXED: Atom-GC problem: global options structured used pointers
    to string of unlocked atoms.

  * ENHANCED: the GUI debugger.  Too much to name it here.

  * INTERNAL: Moved message-activation of spy and nospy predicates to
    foreign-code to make sure it gets always called.

  * FIXED: Bug in recorded database, reported by Michael Heerdegen.

  * FIXED: Removed trace of rl_add_history()

  * FIXED: Handling of :- dynamic Module:Name/Arity in PceEmacs
    cross-referencer.

  * FIXED: Cleanup of code for setting break-points.  Make this code
    work again from PceEmacs.

  * ENHANCED: prolog_to_os_filename(-Pl, +Os) to convert 8+3 filenames
    to long filenames.

  * ENHANCED: Allow setting spy-point from PceEmacs.

  * CLEANUP: Replace some more warnings with exceptions.

  * ENHANCED: library(url) for breaking down and constructing URL strings
    with some new functionality.  Additions by Lukas Faulstich.  Also
    fixed a dangling choice-point in decoding a www-encoded string.

  * ENHANCED: Moved tty_size/2 from library(tty) to built-in, exploiting IOCTL
    calls to fetch the terminal size when available.  This make tty_size/2
    return the actual values rather than constant values from the moment of
    startup.  Reported by Robert van Engelen.


VERSION 4.0.2
=============

  * FIXED: Memory leak in PL_get_chars() using CVT_WRITE.  Reported by
    Marcin Golebski.

  * INSTALL: export CIFLAGS=/path/to/local/include should now be
    honoured correctly by configure (Lukas Faulstich)

  * FIXED: absolute_file_name/3 not to trust its cache.

  * ADDED: callable/1 for better compatibility.

  * FIXED: $qlf_info/4 to request information on QLF files.  Also turned
    a couple of common warnings into proper exceptions.

  * FIXED: Avoid the usage of the appearently badly supported Win32 function
    GetFileInformationByHandle(), now using GetFileSize().  This fixes some
    false-alarm about not being able to find the system resources.

  * REMOVED: ed/1, also from the backward compatibility module.  Edit/1
    is the generic editing front-end.

  * FIXED: writeq(a(b,c,(d,e))), reported by Joachim Katzer.

  * FIXED: Memory leak in expand_file_name/2.  Reported by Daniel Cote.

  * FIXED: Print error-locations in files holding the ~-character.
    Thanks to Mike Maxwell.

VERSION 4.0.1
=============

  * PACKAGE: Many installation patches, added libraries, notably to
    the XPCE subsystem.

  * ADDED: Skeleton dotfiles for both Prolog and XPCE to the dotfiles
    directory.

  * FIXED: plrc utility for modifying archives.  Thanks to Lourens
    van der Meij.

  * FIXED: ANSI-C incompatibility, breaking compilation using AIX cc
    (Sterling Smith).

  * FIXED: end_of_file issues in readln/[1,2,5] (library(readln)) and
    modernised the code a bit.

  * FIXED: Write out-of-range floating point numbers properly (Bart Demoen).

VERSION 4.0.0
=============

  * ADDED: Integrated generally useful packages and the now Open source
    XPCE GUI toolkit into the source and binary distribution.

  * ADDED: Integrated NMAKE makefiles for building on MS-Windows.  Requires
    Windows-NT or 2000 to build, but result works on all Win32 platforms.

  * FIXED: Instantiation problems in source_file/2, reported by
    Richard O'Keefe.

  * FIXED/MODIFIED: DDE Server (Windows) returns data as atom instead of
    list of character codes.  It treads the data as a 0-terminated string.


VERSION 3.4.5
=============

  * FIXED: missing ports in the tracer when the choicepoint is pruned by
    a cut.

  * FIXED: reference-counting problem in exit(Block, Return).  Thanks
    to Robert van Engelen.

  * FIXED: arithmetic to detect overflow of negative floats properly
    (Richard O'Keefe).

  * FIXED: MT-Version: allow calling utility threads/0 from an exit
    hook.  Improve error message when joining `myself'.  Reported by
    Andrew V. Diatchkov.
	
  * FIXED: Don't save prolog_flag `argv'.  Reported by Mark Staples.

  * FIXED: MT-Version: wrong saving of undo information in
    run_thread_exit_hooks(), causing a crash when a GC happens inside the
    execution of an exit hook.  Reported by Andrew V. Diatchkov.

  * FIXED: Predicate reference-count problem trapping an undefined
    procedure.  Thanks to Radek Marik.

  * FIXED: Some path problems installing Unix runtime environment.
    Thanks to Lourens van der Meij.

VERSION 3.4.4
=============

  * PORT: Fixed some compiler warnings for SunSoft C-compiler.  Still
    quite some left, but at least it now compiles. Thanks to
    Richard O'Keefe.

  * FIXED: memory stream-size if no output was written.  Fixes sformat
    and swrite calls not producing output.  Thanks to Daniel Cote.

  * FIXED: MT version: deadlock in append/1 and tell/1.  Thanks to
    Andrew Diatchkov.

  * FIXED: Stop profiler in PL_cleanup().  Reported by Lourens van der Meij.

  * PORT: added MacOS X required sys/malloc.h to files from rc directory.

  * FIXED: compile ! in x :- (!, y -> z) to C_LCUT rather then C_CUT.

VERSION 3.4.3
=============

  * FIXED: Quoted write issues around the ,.  Thanks to Jan Echternach.

  * PORT: Added __unix__ definition for __APPLE__ in pl-incl.h, fixing
    one of the problems on MacOS X Public Beta.  Also allowed for sys/malloc.h
    rather then malloc.h.  Thanks to Paulo Moura.

  * ADDED: concat_atom/3 to work the other way around:
    concat_atom(X, -, 'aap-noot-mies') --> X = [aap, noot, mies]

  * ADDED: Calling PL_halt(2) on SIGHUP, forcing halt handlers to run.

  * FIXED: Properly throw exception when compiling arithmetic with
    unbound (but not anonymous) variable.  Reported by Leo (leo@solvo.ru)

VERSION 3.4.2
=============

  * FIXED: More AIX autoconf and Makefile trouble.

  * FIXED: erase/1 test for clause or record.  Bug introduced with the
    addition of PL_record_external().  Found by Uwe Lesta.  Thanks.

VERSION 3.4.2-beta-1
====================

  * FIXED: open_shared_object() to raise exception instead of old printing
    message and trapping the tracer.  Reported by Leo (leo@solvo.ru).

  * PORTABILITY: Autoconf to produce suitable linking options for AIX.
    Tested on AIX 4.3.3.  Also a change in the Makefile to produce a correct
    SWI-Exports file in the include directory.

  * FIXED: handling operators of type yfy.  Reported by Johann Schumann.

  * FIXED: Terminal control for raw-mode (OpenBSD, patch by Kamo Hiroyasu).
    Actually a bug in OpenBSD 2.5, but the patch probably won't hurt
    other systems.

  * FIXED: PL_get_nchars(), used when casting Prolog-terms to char *
    using the C++ interface.  Spotted by Sebastien Devaux.

  * FIXED: library(url), www_form_encode/2, decoding %OD%OA

  * FIXED: Honour fileerrors/2 to supress errors on file-operations.

VERSION 3.4.1
=============

  * FIXED: Serious redesign of the plwin.exe interaction window.  Should
    fix the Windows 95 and 98 crash problems while exiting Prolog.

  * ADDED: PL_cleanup(): Run all cleanup hooks but do not terminate the
    process.  This fixed various memory leaking problems.

  * IMPROVED: GC policy to try a few garbage collections just before
    running out of stack.

  * FIXED: abort to enable tail-recursion optimisation.

  * FIXED: Handling PL_throw() exceptions during inlined foreign calls.

  * MODIFIED: expand_term/2 doesn't call rules anymore if the argument is
    unbound.  This should make error recovery a bit more elegant.

  * FIXED: MT-version: do not handle keyboard interrupt except for the
    main thread.

  * FIXED: Garbage collection to restore signal mask properly if foreign
    code plays around with the signal mask.

  * FIXED: MT-version: Avoid assertion failure in running subthreads
    on halt.

  * FIXED: MT-version: Avoid deadlock when closing files on halt.

  * ADDED: Check for interrupts in backtracking code to allow interrupting
    some tight loops (repeat, fail) in Windows and thread_signal/2 to these
    in the MT version.

<Released as w32pl340.exe, using #2 in title of installation>

  * INSTALLATION: Win32: Removed local copy of msvcrt.dll and perform
    version control installing msvcrt.dll globally.

  * ADDED: Win32 to check for interrupts while doing atom-completion,
    allowing for interrupt using Control-C.

  * FIXED: Bug in `retry' at an exception port, sometimes throwing an
    assertion failure.

VERSION 3.4.0
=============

  * FIXED/MODIFIED: argument order of select/3 to be according to the
    de-facto standard: select(Elem, List, Rest).  Please check your code,
    this change is INCOMPATIBLE and does not raise a runtime error.

  * UPDATED: README (home page and GNU-Emacs section), manual (GNU-Emacs)
    and man/Makefile (some comments on building the documentation).  Thanks
    to Sam Steels.

  * IMPROVED: Path presentation of edit/1.

  * FIXED: Win32 notion of `home' to use <currentdrive>:/ instead of just
    /, avoiding some trouble in pl-os.c

  * PORTABILITY: Replaced all references to #ifdef unix with #ifdef __unix__
    to avoid warnings by the latest BSD release on old-fashioned use of
    the unix macro.

  * FIXED: Call dieIO() before detaching loaded foreign libraries as the
    file-handlers may be defined in foreign code.

  * FIXED: abolish on running predicates.  Thanks to Andrew V. Diatchkov.

  * FIXED: at_end_of_stream/[0,1] to succeed if the next character to
    read is end-of-file.  Thanks to Daniel Cote.

  * FIXED: Subframes when handling an exception themselves don't catch
    exceptions.

  * FIXED: read_term/2 subterm_positions option to return a variable
    in some awkward situations.

VERSION 3.3.10
==============

  * FIXED: Crash in exception-handling while running in debug mode.

  * FIXED: GC bug related to destructive assignment in setarg/3 and GC
    bug related to new choicepoint handling (since 3.3.6).  Thanks to
    Gertjan van Noord for reporting and providing access to their
    Dec Alpha for tracking down the problem.

  * ADDED: plld: if the default linker is the C-compiler and there are
    C++ files, make the default linker the C++ compiler.

  * ADDED: PL_same_compound() to test whether two compound terms are
    the same term. 

  * MODIFIED: deleted the export of Quintus compatible statistics/2,
    so this can now only be accessed as quintus:statistics(Key, Value).

  * MODIFIED: Moved gensym/2 into the library(gensym) to avoid export
    redefinition.

  * FIXED: When using both local and global term_expansion/2
    or goal_expansion/2 the local rule was tried twice and the
    global not at all.

  * FIXED: Handling multiple errors in compilation (exception
    handling on load_files/2).

  * FIXED: Added exceptions to export.  Don't allow exporting
    built-in predicates.  Thanks to Nicos Angelopoulos.

  * FIXED: Center alignment in writef (thanks to Lyosha Ilyukhin).

VERSION 3.3.9
=============

  * FIXED: Install boot.prc (the default Prolog bootfile) as
    boot<wordlength>.prc, so the Prolog home directory can be
    shared between machines with different wordlength.
    Thanks to David Starks-Browning.

  * FIXED: Garbage collector bug.  Only relevant for people using
    the non-standard setarg/3 predicate (trail was marked after
    choicepoint stack, causing unwanted early-reset of
    trail-references).  Thanks to Rolf Socher.

  * FIXED: Problem in tail-recursion optimisation when using the
    source debugger (or actually the prolog_event_hook/1 callback
    used by the source debugger).

  * FIXED: Depth-limit handling in write_term for the head of a list.
    Thanks to Lyosha Ilyukhin.

  * FIXED: qsave_program/2: Saving the unknown flag.  Thanks to
    Robert van Engelen.

  * FIXED: Translation of negation in DCG rules (Stefan Berghofer)

  * ADDED: Glossary of terms to the manual.

  * ISO: Use exceptions for errors on length/2 and sort/2.

  * FIXED: hash_term/2 for floating point numbers on machines where
    sizeof(double) != sizeof(long)*2;

  * ADDED: Prolog flag `abort_with_exception' to choose between abort
    using exceptions and forced abort.

  * FIXED: Configure to disallow non-aligned memory access on the alpha,
    (OSF/1), even as this just causes a message being printed.  Thanks
    to Gernot Salzer.


VERSION 3.3.8
=============

  * FIXED: exception-handling problem.

  * MODIFIED: Run at_halt/1 hooks in *reverse* order of registration.  This
    behaviour makes scheduling hooks generally easier and is more consistent
    to (for example) POSIX atexit().  Also properly handle exceptions from
    at_halt/1 hooks.

  * FIXED: Handling 0-bytes in sub_atom/5 and sub_string/5.  Thanks to
    Mike Elston.

  * FIXED: Added initialisation for LC_CTYPE locale used by char_type/2 and
    code_type/2.

  * FIXED: Memory leaking in $write_on_string, used by swritef and sformat.
    With help from Paul Sephton, who pointed the exact problem in the C-code.


VERSION 3.3.7
=============

  * FIXED: \+ (true, !, fail): ! cutted local choice-point created by
    \+ (same for if->then;else).  Thanks to Pierre Nugues.

  * FIXED: VM listing for the C_LCUT instruction.

  * MODIFIED: Syntax error exceptions on file-realated streams are now
    reported as error(syntax_error(Message), file(File, Line, CharNo)).
    (reported by Robert van Engelen, who concluded that getting character
    offset was no longer supported).

  * ADDED: on_signal/3 to report foreign-functions bound using PL_signal().

  * FIXED: current_signal/3.

  * ADDED: PL_new_atom_nchars() and PL_get_atom_nchars() to create and query
    atoms using length/chars notation rather than 0-terminated strings.

  * ADDED: use expand_file_name/1 in load_files/2, underlying all consult
    and compile predicates.  This allows for ?- ['~/.foo'].

  * ADDED: PL_record_external() Experimental recorded-database support
    providing records that are independent from the SWI-Prolog symbol-table
    and thus can be stored in external databases.

  * FIXED: Position handling with \r in a format/2 format spec.

  * FIXED: Deal properly with 0-bytes in the format string for format/[2,3].
    Still a bug: format('~t~w~72|~n', [ 'hello\0\world' ]) (write arguments
    with `pending rubber' holding 0-bytes).

  * FIXED: Deal properly with 0-characters in QLF files and saved-states.
    Reported by Mike Elston.

  * FIXED: Doc says PL_get_string_chars(), Impl PL_get_string().  Fixed
    in the impl. using a macro.  Thanks to Nicos Angelopoulo.

VERSION 3.3.6#2
===============

  * WIN32: Switched back to MSVC 5.0 as 5.0 cannot read the .lib files of
    6.0.

  * FIXED: get_char/[1,2] and friends to return end_of_file rather then
    '\255'.

VERSION 3.3.6
=============

  * FIXED: read, etc. not to raise an exception if the argument is
    instantiated (reported by Mike Elston).
	
  * ADDED: make_directory/1 and delete_directory/1.

  * (RE)ADDED: library(gensym) providing reset_gensym/[0,1]

  * FIXED: discarding the choice-point of current_op/3 could
    lead to an infinite loop.

  * FIXED: Data alignment problem in recorded database on machines
    with sizeof(int) != sizeof(long) (Alpha). Thanks to Christian
    Zuckschwerdt.

  * FIXED: Data inconsistency causing GC to crash.  Notably applicable
    to 32-bit RISC machines (SPARC for example).  Thanks to Lourens
    van der Meij.

  * FIXED: clause/2 to deal properly with imported clauses (fixes
    listing of imported predicates).

  * FIXED: Clauses-index handling in loading .qlf files as well as
    honouring reindex requests on running predicates.  Thanks to
    Lourens van der Meij.

  * FIXED: -DALLOC_DEBUG to function properly again.

  * FIXED: Initialisation of functorDef->flags for builtin functors.
    Symptom: reported undefined on $throw, $apply, etc.

  * INTERNAL: Introduced explicit choice-points on the environment
    stack.  The design of the VM interpreter has been simplified a
    lot by this change.  Deterministic code is a little faster,
    non-deterministic code a little slower and compiled ccntrol
    structures (;, ->, \+) are a lot faster.

<available as V3_3_5 from the CVS repository>

  * FIXED: plwin.exe ... -- file.pl.  Thanks to Lourens van der Meij.

  * MODIFIED: close/1 works as close(Stream, [force(true)]) if the
    stream has an error condition when starting the close.

  * MODIFIED: Replaced warning on atom_prefix/2 with exception.

  * FIXED: Sflush() to return 0 rather then the number of characters
    written on success.

  * ADDED: Messages for new error(limit_exceeded(Limit, Max), _) and
    error(goal_failed(Goal), _).

  * FIXED: Proper reporting of I/O errors reading/writing streams.

  * FIXED: writeq to handle | as a solo-char and avoid extra space
    between multiple '('.

  * FIXED: code_type(97, to_lower(97)) failed.  Reported by Joachim Katzer.
    Also fixed code_type(L, lower(U)), to non-deterministically generate
    pairs of upper- and lowercase charactercodes.

  * FIXED: crash if a complex goal-argument to a meta-calling predicate
    (call/1, findall/3, etc.) is deterministic upto the last call (so
    this is executed tail-recursively).  This patch also applies to
    executing and removed dynamic predicates.  Thanks to Uwe Lesta.

VERSION 3.3.4
=============

  * LICENSE: Announce GPL'ed status in banner.

  * FIXED: Path problems in RPM-file (actually in path-canonisation).
    Thanks to Michael Rohr.

  * ADDED: pl.lsm (Linux Software Map Entry) to the source distribution

  * INSTALL: Fixed `make install-version'.  Thanks to Joachim Katzer. 

  * PORT: Removed accidental C++-style comment from pl-wam.c.  Thanks to
    Joachim Katzer.

  * INSTALL: rel-ln to avoid using grep -q (GNU-grep specific). Thanks to
    Joachim Katzer. 

  * FIXED: avoid call to win_registry_get_value/3 if this is not defined
    (Unix version).  Otherwise check/0 reports this predicate as
    undefined.

VERSION 3.3.3
=============

  * WIN32: Added support in the installation for alternative file-extension.
    Added win_registry_get_value/3 to fetch registry values.

  * FIXED: PL_cons_functor_v() to read before writing, so it can overwrite
    one of the input term-references like similar functions.

  * FIXED: Summary description of subset/2.

  * FIXED: Actually look for pl.ini in the Prolog home directory (Windows
    version).

  * FIXED: Bug in PL_unify_term(), causing incorrect `format error' messages.

  * FIXED: MT-version: deadlock in stream-handling.

  * FIXED: Test for existence of files and directories in expand_file_name/2.

  * FIXED: Handling exceptions from make while updating the library index.
    Thanks to Bob Wielinga.

VERSION 3.3.2
=============

  * PORT: Modified Unix stack-expansion to look for POSIX.1b SA_SIGINFO
    support, fixed various portability problems in src/test/mmap.c.

  * FIXED: Dangling trail-references from trimStacks().  Often causes
    crashes after out-of-stack errors.

  * FIXED: Ensure local stack-allocation on machines lacking hardware
    stack guarding.

  * COMPAT: Renamed argument-names `new' in console.h to allow for loading in
    C++ projects (Uwe Lesta).

  * FIXED: serious mistake in addMultipleBuffer(), causing various conflicts.
    Introduced in 3.3.1.

VERSION 3.3.1
=============

  * INSTALL: Integrated patches from SuSE to improve RPM generation.

  * PORTABILITY: Fixed assumption that a double is twice as big as a long.
    This causes an incompatibility in the .QLF format.  All .QLF files should
    be recompiled to deal with this version.

  * INTERNAL: recorded database to avoid unaligned retrieval using
    memcpy().  Provides a little extra speed notably in findall, setof
    and friends, at the cost of some (temporary) memory.

  * FIXED: scan_options() for machines where sizeof(int) != sizeof(long).
    With help from Bob Moniot.

  * FIXED: configure work-around for shells providing $PWD, but with the
    wrong value ...

  * FIXED: time_t problem in convert_time/2.  Added exception to instantiation
    errors of convert_time/[2,8].

  * FIXED: Portability problem for PPC chip (and possibly others) in
    PL_unify_term(), causing crashes at various places on affected
    processors.  The new implementation is probably a litle faster too.
    With help of Paulo Moura.

  * FIXED: a few type conversions for the 64-bit versions. Just making
    the compiler silent.

  * FIXED: Changed singleton error to singleton warning using a direct
    call to printMessage() rather then the out-of-date warning().  Reported
    by Pierre Nugues.

VERSION 3.3.0 (final)
=====================

  * FIXED: Undesired interaction between abort and exceptions.

  * MODIFIED: Simplified the interface around the undocumented PL_dispatch()
    call to improve interactive response on exceptions, etc.

  * ADDED: PL_is_initialised() to test whether Prolog is initialised.  Also,
    when calling PL_initialise() twice the second call is a no-op.  Made
    PL_initialise() thread-safe, so concurent threads can call it.

  * MODIFIED: Unix version no longer installs Windows specific library
    files (dde.pl, registry.pl, progman.pl).

  * DELETED: libraries toolkit.pl, gensym.pl, qlfutil.pl.  Obscure and
    out of date functionality.

  * ADDED: library url.pl: parsing URL's

VERSION 3.3.0 (release-14)
==========================

  * FIXED: apply/2. Lourens again!
	
VERSION 3.3.0 (release-13)
==========================

  * FIXED: Handling of ! in call/1 (was disabled for debugging purposes).

  * FIXED: retractall/1: could crash.

  * FIXED: apply/2 if the first argument is not an atom.  Thanks to
    Lourens van der Meij.

  * FIXED: thread_get_message/1 (deleted all messages from queue if
    the first was extracted).

  * ADDED: message_to_string/2 for translating message-terms to text.

VERSION 3.3.0 (release-12)
==========================

  * PORT: MT version: provided support for systems lacking recursive
    (UNIX98) mutexes, amoung which Solaris 2.5.  With patch received
    from Frank Cornelissen.  Thanks!

VERSION 3.3.0 (release-11)
==========================

  * INTERNAL: Got -DCOUNTING cpp option to work again for statistics
    on the virtual machine.

  * ADDED: PL_agc_hook() to register a hook into the atom garbage
    collector.

  * PERFORMANCE: Changed clause/2 to fully exploit clause-indexing.

  * PERFORMANCE: Changed interface of firstClause()/findClause() for
    somewhat faster indexing.

  * MODIFIED: Allow for abolish of static procedures, unless the iso
    prolog flag is set to true.

VERSION 3.3.0 (release-10)
==========================

  * FIXED: MT version: ensure calling thread_exit/1 gets the thread_at_exit
    handlers called.  Improved handling of halt/[0,1] by cancelling the other
    threads first (incomplete).

  * FIXED: open_null_stream/1 to register the stream open for writing
    (resulted in permission error).

  * FIXED: tracer to disable tail-recursion optimisation again (resulted
    in poorly readable trace output).

  * FIXED: clause/[2,3] not resetting predicate-reference properly.

  * PERFORMANCE: Exploit hashed first-argument indexing by retract/1.
    Schedule predicate clause collection to avoid quadratic behaviour
    of retract/1.

  * ADDED: code_type/2: type `xdigit' for hexadecimal digits.

  * ADDED: Support for deeply nested right-recursive terms to the
    compiler.  Limit (stack-overflow) spotted by Bob Wielinga.

VERSION 3.3.0 (release-9)
=========================

  * ADDED: option syntax_errors to read_term.  Modified read_clause to
    use syntax_errors(dec10).

  * FIXED: Performance problem in registerAtom(), slowing down loading
    large files by a factor 10.  Caused by atom garbage collector.
    Reported by Luis Iraola Moreno.

  * FIXED: Avoid tracing $messages:prolog_message/3 after ?- trace.

  * FIXED: Force a linebreak after trace-output from trace/1.

VERSION 3.3.0 (release-8)
=========================

  * FIXED: Get tracer option `show context' working again.

  * FIXED: Module-handling in trace/1 (when using in module user).

  * FIXED: Printing messages from C.


VERSION 3.3.0 (release-7)
=========================

  * FIXED: Path-handling problem loading Quick Load Files from a different
    location then they were created.  Notably affects handling of
    discontiguous.

  * FIXED: File association in Windows to allow for additional arguments
    (notably stack-expansion).

  * MODIFIED: moved all internal messages to $messages:prolog_message/3
    rather then prolog:message/3, so all messages can be overrulled by
    adding clauses to prolog:message/3.

  * ADDED: Printing of goals by the trace through print_message/2 to allow
    for better tailuring by the user.

  * FIXED: Bug in call/1 on ground-calls and very specific control.

  * FIXED: Incorrect verification in SECURE-mode in pl-bags.c (maintenance
    only).

  * FIXED: Bug in handling logical-update view of assert/retract.  Thanks
    to Paolo Moura.


VERSION 3.3.0 (release-6)
=========================

  * FIXED: Problem in the debugger, leading to a possible crash on the exit
    port (very complicated conditions).

  * ISO: Added the Prolog flags unknown and debug.  Moved unknown/2, debug
    and nodebug predicates to new library(edinburgh).

  * ISO: Added current_predicate/1

  * ISO: clause/2 errors.

  * FIXED: clause/2: clauses for which the body executes in a different
    module as the head to tag the body with the body-context module.

  * ISO: Added exceptions to =../2 and functor/3.  In old SWI-Prolog,
    these predicates failed silently on all errors.

  * ADDED: ISO char_conversion/2 and friends.  They are not really enforced
    though.

  * ADDED: ISO option variables(-Vars) to read_term/[2,3]

  * FIXED: number_chars/2 exception on illegal number-syntax.

  * FIXED: handling ! in call/1, \+/1 and condition-part of if-then-else

  * FIXED: time/1 library predicate to pass exceptions correctly.

  * ISO: renamed misnamed close2/2 to close/2.

  * ISO: Renamed flush/0 to flush_output/0.  Added backward compatibility
    flush/0 to library(backcomp).

  * ISO: Enforced number for arg1 in number_chars/2 and number_codes/2.
    Succeed on number_codes(15, "0xf") and similar cases (i.e. if both
    arguments are instantiated, convert the string and match the number
    as there are multiple representations of numbers.

  * ISO: raising permission-error when reading from an output stream
    or writing to an input stream.

  * FIXED: Put `iso' feature back in place (was lost in rewrite of
    prolog-flag handling.

  * ISO: fixed exceptions thrown on atomic non-evaluable term (i.e.
    A is foo).

  * FIXED: atom_concat/3 on backtracking.

  * FIXED: Problems with non-deterministic foreign predicates raising
    exceptions on the first call for which the cleanup made assuptions
    on the returned context.  Thanks to Frank Cornelissen.

  * FIXED: Layout problem in the online manual

VERSION 3.3.0 (release-5)
=========================

  * WIN32: get_time/1 now returns the time in 1/1000 of a second rather
    then whole seconds.

  * FIXED: expand_file_name/2 and wildchard_match/2 for filenames containing
    uppercase characters on systems with case-sensitive filenames (Unix).
    Also fixed for handling pattern and names containing non-ASCII characters.

  * MODIFIED: expand_file_name/2 and wildchard_match/2 to raise exceptions
    on instantiation errors.

VERSION 3.3.0 (release-4)
=========================

  * FIXED: unload_foreign_library/[1,2] calling of the uninstall hook.
    Might fix exit problems in the Windows version.

  * ADDED: load_foreign_library/[1,2] now first looks for lib<D>.dll
    if the SWI-Prolog kernel is compiled for debugging.  That should
    simplify debugging foreign code under Windows.

  * FIXED: current_prolog_flag(windows, X) on windows (returned false).

  * FIXED: retractall/1 and retract/1 not to complain while accessing
    undefined procedures.  The addressed procedures are flagged dynamic.

  * FIXED: Multithreaded creation of new keys in recorda/2 and friends.

  * PORT: Prolog threads to Solaris.  Tested using SPARC/Solaris 2.7, compiled
    using egcs 1.1.  Not dealt (yet) with different cpu-time measurements
    (Linux: per thread, Solaris: per process).

  * FIXED: Stack problem in asynchronous signal handling, also influencing
    thread_signal/2. 

  * FIXED: assertion-error in get_stream_handle() if a stream is set to
    be the alias for multiple of the `standard' stream and the stream is
    closed.

  * ADDED: Atoms can now hold 0-bytes.  API: *_nchars() FLI-functions 
    added to put, unify and get text using length/char *.  No consequences
    in Prolog.

  * ADDED: atom garbage collection.  See release-notes in the manual.
    API: prolog-flag `agc_margin', garbage_collect_atoms/0, PL_register_atom(),
    PL_unregister_atom().

  * FIXED: get_single_har/1 to read from user_input, seeing and friends
    *not* to return current_input ...  Thanks to Cortelli Paolo.

  * ADDED: sub_string/5 modelled after ISO sub_atom/5.  moved substring/4
    to library(backcomp).

  * FIXED: exception raised by atom_concat/3.

  * FIXED: locking problem in set_input/1, set_output/1, see/1 and
    tell/1 (Multi-threaded version).

  * ADDED: C interface for accessing an embedded Prolog engine
    from multiple threads.

  * FIXED: incorrect instantiation-errors from sub_atom/5.

VERSION 3.3.0 (release-3)
=========================

  * FIXED: Windows installation to add icons to the program manager.

  * PORT: Win32: renamed console.dll to plterm.dll to avoid name-conflict
    with Windows 2000 system DLL.

  * PORT: HTML Manual: renamed Index.html to DocIndex.html and place
    the titlepage in index.html.  Should fix problems with systems 
    with case-insensitive files and without links (e.i. Windows).

  * ADDED: ISO predicates close/2, unify_with_occurs_check/2,
    stream_property/2, sub_atom/5.  Moved stream_position/3 and
    current_stream/3 from built-in to library(quintus).

  * FIXED: $term_complexity/2, which determines whether or not a term is
    too large to store as a toplevel variable.  Together with the other
    changes, the toplevel and debugger no longer crash on cyclic terms.

  * ADDED: {put,get,peek}_{byte,char,code}/[1,2] predicates, providing
    ISO compliant character I/O.

  * ADDED: write_term/[2,3] options `module' for defining the module
    from which to use operators and character_escapes to explicitly
    override character-escape handling.

  * FIXED: Don't set system-mode and hide-childs for already defined
    predicates (for XPCE's spypce/1 problems.  Reported by Peter Mott).

  * FIXED: handling portray(Bool) option of write_term/2.

  * ADDED: Prolog flags toplevel_print_options and debugger_print_options
    to control printing of answers and goals by the debugger.

  * ADDED: max_depth(D) option to write_term/[2,3] to limit the printing
    depth.

  * ADDED: `W' option to format/[2,3], providing access to write_term/2:
    e.g. format('~W', [Term, [quoted(true)]]).

  * FIXED: create include directory (Windows-build from the plain sources).
    Uwe Lesta.

VERSION 3.3.0 (release-2)
=========================

  * ADDED: printing PLTHREADS from pl -dump-runtime-variables.  plld
    automatically pushes -D_REENTRANT to the C and C++ options of pl
    is multi-threaded.

VERSION 3.3.0 (release-1)
=========================

  * FIXED: errorneous `redefined' messages.

  * MODIFIED: Implemented `logical update-view' for dynamic predicates!

  * MOVED: time/1 and profile/3 and friends is now in library(statistics)
    rather then built-in.

  * DELETED: qload/1.  Just load the .qlf-file will do the same.  

  * ADDED: message_hook/3 hook into print_message/2.  print_message_lines/3
    (All Quintus/SICStus compatible).  This mechanism is now used for all
    errors and warnings and for a growing number of system messages.
    
    exception/3 using `warning' has been deleted.  Use message_hook/3 to
    hook into printing messages.

  * FIXED: handling mmap() based stacks and shared object interface for
    HP/UX (hppa1.1-hpux10.20).  Tested build using bash, HP/UX make
    and gcc-2.8.1.  With thanks to Gertjan van Noord for providing
    access to their machine.

  * ADDED: char_type/2 and code_type/2 for fast and locale-supported
    character classification.

  * MODIFIED: The following aspects are now local to the module into
    which they are defined: the prolog-flags character_escapes and
    double_quotes and operators.

  * ADDED: prolog-flag double_quotes, replacing and refining the old
    style_check(+string) option, which is mapped to the new interface.

  * MODIFIED: The predicates feature/2 and set_feature/2 have been renamed
    to the ISO compliant current_prolog_flag/2 and set_prolog_flag/2.  
    Definitions of the old predicates have been moved to the
    library(backcomp).
    
  * ADDED: read-only access to system features, strict type-checking and
    allow for arbitrary terms as feature-value.

  * ADDED: feature(argv, Argv) to get (finally) documented access to the
    commandline arguments.  The '$argv'/1 has been put into the backcomp.pl
    library.  The Quintus compatibility unix(argv(Argv)) is still provided
    as well.

  * ADDED: Write exception-term if nobody catches an exception.

  * FIXED: bug in filename canonisation.

  * The manual-helper program pl-bite, use to pick bits of the online
    manual and present them to the pager, thus protecting prolog from
    receiving a broken-pipe signal has been deleted.  The current version
    of Prolog can deal with these errors itself.

  * MODIFIED: Total rewrite of the internal I/O architecture, which
    is now based on streams rather than current input/output.  The
    new model is required for better handling of multi-threadings
    or asynchronous events.  Compatibility consequences:

	+ Edinburgh current stream predicates
	seeing/1 is now the same as current_input/1 and returns a
	stream-handle for the current input stream.  Same for
	telling.  The predicates see/1 and tell/1 are equivalent
	to set_input/1 and set_output/1 if the argument is a stream,
	open/3 followed by setting the current stream otherwise.

    Two new streams have been added to deal with debugging:
    debug_output and debug_input.  Initialy these are the same as
    user_output and user_input.

  * ADDED: Allow PL_new_atom() to be called before PL_initialise()

  * DELETED: read_variables/[2,3].  With ISO read_term, this predicate is
    obsolete.  Put a backward-compatibility definition in library
    backcomp.pl.

  * COMPATIBILITY/ISO: All variations of read/1 and read_term/[2,3] now
    generate an exception rather than printing a message to the terminal.
    This also includes term_to_atom/2 and atom_to_term/3.  The option
    syntax_errors from read_term/[2,3] has been deleted.

  * COMPATIBILITY/ISO: Introduced atom_codes/2 and modified atom_chars/2
    to return a list of one-char atoms rather than a list of codes.
    The atom-breaking routines now generate exceptions rather than
    warnings.  Same for number_chars/2 and the new number_codes/2.

    Renamed concat/3 to atom_concat/3 and also allow for the pattern
    -, -, +.  Added concat/3 to the autoload backcomp.pl library.

  * MODIFIED: PL_register_foreign() can be called with first argument
    of the form <module>:<predicate> to register a predicate into a
    specific module.

  * ADDED: PL_FA_VARARGS flag to PL_register_foreign(), allowing for an
    alternative, arity-independent calling convention to foreign-defined
    predicates used by the new C++ interface.

  * ADDED: Allow PL_register_foreign() to be called before PL_initialise().
    This function now does lazy initialisation of the modules required to
    register foreign predicates (allocation, atoms, functors, tables and
    modules).

  * MODIFIED: Unified Prolog-side of Unix and Windows foreign library
    (.so/.dll) interface.  Updated library(shlib) and manual accordingly.
    The predicates dll_open/2 and friends have been deleted.  Please use
    open_shared_object/2 and friends, also on Windows.

  * MODIFIED: PL_initialise() handling of argv[0].  Updated documentation
    on how and why this argument is used.  The feature symbol_file has been
    deleted and replaced by the feature executable.

  * DELETED: load_foreign/[2,5], symbolfile related foreign interface
    primitives.  On all modern OS'es we should have some form of shared
    object or DLL interface for dealing with loading dynamic code.  On
    others, static relinking of the kernel can be used.

  * FIXED: Bug in PL_get_chars() handlings lists of ascii characters and
    variables.  Also bug in SWI-Prolog.h.  PACKAGES USING CVT_ALL OPTION
    SHOULD BE RECOMPILED!

  * ADDED: CVT_WRITE option to PL_get_chars() C-interface function to
    get the printed representation of a term.

  * FIXED: Memory alignment problem.  Affects RISC/Unix machines where
    inode_t and/or dev_t are larger than `word'.  Same for longjmp()
    data saved on the Prolog stack.  With help of Johan van Rijn.

  * ADDED: PL_chars_to_term() to transform a C-string into a term by
    parsing.

  * ADDED: -class option to plld to allow for setting the save-class
    (see qsave_program/2).

  * FIXED: check for prolog options if save-class is not "runtime".
  
  * FIXED: library(tty) to be robust against style_check(+string) and
    menu/3 to clear instead of simply `home'.  Reported by Robert van
    Engelen.

  * FIXED: Parser error, failing to read /\ = X if it is the start
    of a term.  Reported by Robert van Engelen.

  * ADDED: pl.spec to tarball to allow for rpm -tb pl-x.y.z.tar.gz
    (also Jan Nieuwenhuizen)

  * FIXED: Proper cleanup using `make distclean', suggested by
    Jan Nieuwenhuizen.

  * FIXED: Deleted temporary assert() statements from pl-rec.c.
    reported by Jan Nieuwenhuizen.

  * PORTABILITY: Added <stdio.h> to pl-os.c for rename() and remove()
    prototypes (Linux/PPC), thanks to Paulo Moura.

VERSION 3.2.9
=============

  * FIXED: Changed default C++ compiler for Windows to cl.exe.  After
    a bug-report from Peter Tselios.

  * FIXED: config.{sub,guess} for openbsd.  Contributed by Kamo Hiroyasu.

  * FIXED: Documentation of mod/2 and rem/2 (arithmetic).  Spotted by
    Koos Dering.

  * FIXED: plld -g to add /ZI /Od to the compiler options.  Thanks to
    Lutz Wohlrab.  He also mentiones that a MSVC can't debug the joined
    emulator+state: use plld -nostate, make the state separately and
    use -x state to PL_initialise() in the emulator to associate the
    state.  All this only if you want to debug the C-code.

  * IMPLEMENTATION: Base sleep/1 on usleep() if present.

  * PORTABILITY: Fixed various compiler warnings on Alpha under Digital
    Unix 4.0D, using egcs-1.1b.

  * PORTABILITY: Added patches required for MSVC 6.0 (Windows), contributed
    by Lutz Wohlrab.

  * MODIFIED: Represention of atom and functor table to be MT-safe
    and for the atom-table to make one step towards garbage collection.

  * MODIFIED: Added exception-throwing on errors to many predicates:
    record{a,z}/3, recorded/3, erase/1, current_atom/1, current_functor/2.

  * FIXED: handle --name=value arguments for compilation using -c.
    catch exceptions during -c compilation and exit if one happens.
  
  * MODIFIED: the default `init-file' of a `runtime' saved-state is
    now `none', stopping normal saved-states from reading personal
    setup.

  * DOCUMENTATION: Fixed various mistakes in the documentation: -c 
    compilation, added unix/1 to the docs.

  * IMPROVED: Raised maximum limits for the stacks from 64 Mb to 128 Mb.

  * FIXED: plld to quote arguments if they contain spaces.  Required
    on Windows to pass the SWI-Prolog include directory properly.
    Thanks to Peter Tselios. 

  * MODIFIED: Looking for user profile file.  Now searched for using
    user_profile(ProfileFile), where ProfileFile is by default .plrc
    on Unix and pl.ini on Windows.  The default for user_profile is
    ., ~ on Unix and ., ~ (if it exists), SWI home and Windows directory
    on Windows.

  * MODIFIED: built-in predicates, with the exception of expand_file_name/2
    no longer expand $ENVVAR and ~, allowing access to files with any name.
    The old behaviour can be accessed by setting the feature
    file_name_variables to true.

  * FIXED: ( \+(!), fail ; true ) and similar cases where ! cuts
    are placed in the condition-part of if-then-else. Resulted in 
    ../src/pl-wam.c:xxxx: pl_alt: Assertion `0' failed.

  * CONFIG: Allow specifying $CIFLAGS before running configure to
    deal with strange locations of include files.  Fixed typo in
    looking for readline.h.  Thanks to Stefan Mueller.

VERSION 3.2.8
=============

  * FIXED: Save unknown/2 status with qsave_program/2.  Reported
    by Robert van Engelen.

  * FIXED: include __register_frame_info and friends into the executable
    (egcs 1.1.1 exception handling stuff). Should make SWI-Prolog
    binaries portable between installations with different
    egcs/gcc/glibc versions.

  * FIXED: Exception generation for optimized arithmetic.  Reported
    by Robert van Engelen.  Thanks.

  * FIXED: qload/1 to check for predicate redefinition just as normal
    loading does.

  * FIXED: qload/1 to load unqualified code (i.e. if the compiled file
    is not a module-file) into the context module of the qload/1 call.
    Reported by Paul Sephton.

VERSION 3.2.7
=============

  * MODIFIED: term_to_atom/2, atom_to_term/3 now yield an exception on
    instantiation errors.

  * IMPROVED: rewrote pl-read.c (read_term/2 and friends) to be fully
    reentrant by removing all global variables from this module.  Also
    many reentrant problems solved from pl-file.c (basic file handling).
    This is part of a very slow process to prepare SWI-Prolog for
    multi-threading.

  * ADDED/FIXED: type-checking on options list of qsave_program/2.

  * DELETED: library(whereis).  Function is obsolete using the new
    edit/1 interface (was not documented anyway).

  * FIXED: saving numbers like 0x00ff0000 to saved-state (numbers with
    more than 22 bits, all whose bytes are either 00 or ff).  Found by
    Stefan Mueller.

  * PORT: Fixes to configure to deal with alloca() and dlopen() on
    SCO-Unix, both for gcc and native SCO cc.  Thanks to Tamas Laufer.  

  * ADDED: user:prolog_file_type/2 hook.  This can be used to define the
    meaning of filename extensions to Prolog.  All extension handling is
    now based on this predicate.

  * MODIFIED: absolute_file_name/3 default for file_errors option is
    now `error'.  Used to be fail.  file_errors(error) now throws an
    existence_error exception.  This behaviour is compatible to Quintus
    and SICStus.

  * FIXED: absolute_file_name/3 using solutions(all) option.

  * FIXED: PL_handle_signels(): avoid a loop and remove dispatched signels.
    This fixes Control-C handling in the Windows version.  Thanks to
    Bob Wielinga.

  * FIXED: Quote program-name when registering the Prolog Source type under
    Windows.

  * FIXED: proper timing for blocking signals (Unix version), so they
    are delayed during garbage collection.

  * FIXED: Various issues in the GUI tracer, most related to the new
    xpce-5 class-compiler.

  * MODIFIED: Deleted please/3 and added the functionality to feature/2.

  * FIXED: Some compiler warning in plld.c and pl-stream.c.  Might have
    caused problems when using characters >= 128, but quite unlikely. Reported
    by Peter Ludeman. 

  * FIXED: 8-bit transparency of console window.

VERSION 3.2.6
=============

  * FIXED: definition of last/2 to be both logical and determinitic if
    applicable.  Based on implementation published on comp.lang.prolog
    a while ago.

  * FIXED/PORTABILITY: Modified implementation of stack-allocation based
    in mmap() (Many Unix systems).  This makes the configuration work on
    the Linux 2.2 kernels, but most likely fixes problems on many other
    systems.  It also avoids potentional conflicts in the stack management
    with foreign code using mmap().

  * FIXED: retract((p:-true)) is equivalent to retract(p).  Reported
    by Juan Cires Martinez.

  * DOCUMENTATION: Thanks to Xavier Noria, a large number of spelling
    and consistency problems have been removed from chapters 1 and 2
    of the manual.  Keep up the good work!

  * FIXED: Avoid reentrence of the GNU readline library, as this upsets
    the readline signal handling.

  * ISO: load_files/2 now throws an exception rather then printing a
    message if a target file does not exist.

  * FIXED: Initiate hash-based indexing for integers > max_tagged_integer.
    Very important if your code uses large integers and relies on indexing!

  * FIXED: recognise -p option in pl -o state -c file.pl.  Reported by
    Lukas Faulstich.  Thanks.

VERSION 3.2.4
=============

  * FIXED: protocolling the input-stream on the Windows version.

  * ADDED: 'm' command in tracer to examine details of the currently
    pending exception.

  * ADDED: Support for EWOULDBLOCK on input streams required by new
    socket package.

  * FIXED: wait_for_input/3 correct reporting of anonymous streams.
  
  * ADDED: Port of wait_for_input/3 to Windows.  Only works for streams
    referring to sockets!

  * FIXED: Get MAXPATHLEN ok for some more platforms (SCO_SV 3.2), reported
    by Clive Cox.  Thanks.

  * FIXED: Win32: plld.exe to deal properly with the implicitely added
    .exe extension of qsave_program/[1,2].  Thanks to Lutz Wohlrab.

  * FIXED: Some patches to the Windows MSVC project-configuration for
    building SWI-Prolog from the source-code by Lutz Wohlrab.

VERSION 3.2.3
=============

  * ADDED: Win32: Some project settings and debug-options to plld contributed
    by Lutz Wohlrab.

  * ADDED: RPM Packages for swi-prolog, xpce and the GUI tracer.  See the
    new home-page.

  * FIXED: Recursion problem in calling prolog_event_hook/1, causing crashes
    in the graphical debugger.

  * FIXED: Crash after set_feature(history, on).  Thanks to Anjo Anjewierden.

VERSION 3.2.2
=============

  * FIXED: Memory problem at startup.  This caused startup-crashes in
    Windows 95/98.  Normally harmless under NT and Unix, but can cause
    problems here too if the size of a saved state is an exact multiple
    of the machine's page-size.

  * MODIFIED: Win32: qsave_program/[1,2] now adds .exe extension if no
    extension was specified.

VERSION 3.2.1
=============

  * FIXED: qsave_program/[1,2] for Windows 98 and possibly other platforms.
    Thanks to Uwe Lesta.


VERSION 3.2.0
=============

  * WIN32: moved to MSVC 5.0 platform.  Added win32 specific source
    (console, uxnt libraries) to the main source-tree.  Added MSVC
    workspace to manage the whole building process.  Good news is
    that MSVC 5.0 produces considerably faster code.  The Windows
    and Linux versions now perform about equally on the same hardware
    (SuSE 5.3 linux using egcc 1.03 vs. NT 4.0/SP4 using MSVC 5.0).
    With thanks to Lutz Wohlrab.

  * WIN32: Console version of SWI-Prolog (plcon.exe) no longer shows
    a message-box on errors, completion of the boot-compilation, etc.

  * FIXED: Win32 console (plwin.exe), various patches: a startup
    threat-synchronisation problem which might explain why SWI-Prolog
    crashes immediately at startup sometimes on windows 95/98 (NT appears
    more robust for invalid API calls), two memory management problems in
    the window-resize code and some small glitches.

  * ADDED: Win32 version: exported _PL_get_arg() (non-checking PL_get_arg()).

  * FIXED: more patches to PL_Q_PASS_EXCEPTION handling of PL_open_query()
    and PL_call_predicate().

  * FIXED: avoid a debugger trap of an exception if the exception is catched
    in an outer-context and passed over the intermediate foreign-call using
    PL_Q_PASS_EXCEPTION.  Required for XPCE-5.

  * FIXED: PL_cons_*() to make references in the proper direction.  Notably
    caused problems when constructing a term holding variables for PL_throw().

  * ADDED: PL_record(), PL_recorded(), PL_erase()

  * ADDED: edit(Name) now also finds system-predicates.

  * FIXED: toplevel spy, listing, etc. no longer trigger the tracer
    if the predicate doesn't exists.

  * ADDED: pl.spec, RPM specification-file.  Contributed by Tony Nugent.
    Thanks!

  * INSTALL: use mkdir -p if available (detected by configure).

  * FIXED: meta_predicate/1 emulation in library(quintus) to deal with
    :- meta_predicate Module:Head.

  * ADDED: goal_expansion/2 and expand_goal/2 to deal with expansion of
    individual goals.

  * MODIFIED: _PL_get_xpce_reference() dropped object-qualifier
    argument, which was needed for Alpha XPCE 5.0.0, but not
    for subsequent XPCE versions.


VERSION 3.1.2
============= 

  * FIXED: SIO_MAGIC declaration of SWI-Prolog standard streams.

  * ADDED: Indicate debugger status in prompt.

  * FIXED: Windows: correctly maintains stream character-count when
    writing newlines to a text-stream.  Reported by Pete Yule.

    MODIFIED: Calling interface for S__updatefilepos(), making binary
    foreign code using Sgetc() or Sgetchar() incompatible. Code is
    compatible at the source-level.  This includes XPCE 5.0.0!
    Using old binary packages raises a [FATAL ERROR message].

  * FIXED/MODIFIED: PL_get_chars to convert floats using the feature
    float_format.  Hinted by Pete Yule.

  * FIXED: Increased tmp buffer-size in PL_get_chars() to deal with
    printing very large floating point numbers.

  * FIXED: handling of PL_Q_CATCH_EXCEPTION/PL_Q_PASS_EXCEPTION

  * FIXED: PL_open_resource() now passes exceptions, instead of
    catching (and printing) them.  Also fixed setting errno to
    ENOENT.

  * ADDED: feature(iso, Bool) to select ISO conformance in weird
    places, such as the ISO standard order of terms which dictates
    all floats precede all integers.  Default is false.

  * MODIFIED: compare/3 affecting sort, msort, keysort and @</2 and
    family now compare compound terms based on arity first and then
    alphabetically instead of the other way around!  The new behaviour
    is compliant to the ISO standard and (at least) Quintus Prolog.
    Noted by Jonathan Hodgson.

  * MODIFIED: predsort/3 to call the comparison as compare/3, so
    predsort(compare, L1, L2) has the same semantics as sort(L1, L2).
    NB:	This implies the programs using predsort/3 should be MODIFIED!
    Try explain(predsort/3) to find references in your program.

  * FIXED: writing quoted atoms holding characters >= 128.  Reported
    by Lukas Faulstich.

  * ADDED: convert_time(+TimeStamp, -String) as an interface to
    the POSIX ctime() function.

  * MODIFIED: edit/[0,1], ed/[0,1] are replaced by a new extensible
    dynamic-load library(edit), providing only edit/1.  This predicate
    can be extended to locate any type of `object' and call any editor.
    See manual for details.

  * ADDED: module support for DCG expansion, correctly translating
    <module>:<head> --> <body> as well as <head> --> <module>:<dcg-goal>.

  * ADDED: guarding and printing of exceptions during initialisation,
    making debugging a little easier.

  * FIXED: PL_register_foreign() to lock up predicates as system
    predicates when called in `system' mode.

  * FIXED: passing frame references for the tracer-interception.

  * MODIFIED: renamed module explain (from library(explain)) into 
    prolog_explain to avoid conflicts with user module names.

  * FIXED: catch/3 using pointer to non-static local variable.  Could
    cause a crash by jumping into hyper-space.

  * ADDED: manpage for plrc(1)

  * DELETED: chpl and its manpage.  This command is replaced by plrc(1),
    manipulating the SWI-Prolog 3.x resource database.

  * FIXED: Reset gced_size of stacks after an abort to make the garbage
    collector work properly afterwards.  Also fixed detection of
    trail-garbage for specific (deterministic) callbacks from C.  This
    could result in situations where no trail-garbage at all was detected,
    leading to trail-stack overflows.

  * FIXED: Added configure test for sigprocmask.  This fixes repeated signals
    on many Unix platforms (Control-C).

  * FIXED: Determinism of maplist/checklist predicates.

  * FIXED: free_variables/2 typo in 3.1.0, causing it to report variables
    more than once.  Thanks to Luc Van Oostenryck.

VERSION 3.1.1
=============

  * FIXED: catch(Goal, template(Vars), handle(Vars)), i.e. catching
    exceptions based on patterns and using the variable-bindings in
    the pattern.

  * FIXED: Problem in SopenRC()/rc_close() communication, spotted by
    Tamas Laufer.  Could result in  "ERROR: Failed to save system resources"
    message, depending on compiler/and or hardware.

  * FIXED: online help truncated output.

  * FIXED: wrong value of lTop returned by PL_next_solution() on deterministic
    predicates.  Can cause a crash.

  * FIXED: Errorneous ``NOTE: system definition has been overruled ...''
    from listing/[0,1].

  * FIXED: saving operators using qsave_program/[1,2].  Spotted by
    Robert van Engelen.

  * FIXED: added format predicate and arithmetic function status to
    saved-states.  Thanks to Tobias Thelen.

  * ADDED: current_format_predicate/3

VERSION 3.1.0
=============

  * ADDED: PL_put_string_nchars() to register strings using length/ptr    

  * FIXED: bug in the stack-shifter, introduced in 3.0.0

  * FIXED: configure option --disable-mapped-stacks

  * ADDED: configure option --disable-segv-handling

  * ADDED: Mapping signals (software interrupts) onto Prolog predicates
    or exceptions.  See on_signal/3.

  * MODIFIED: signal-handling using PL_signal(): the handler can now
    safely call Prolog.

  * MODIFIED: PL_throw() now performs a longjmp(), instead of returning
    failure.  PL_raise_exception() replaces the old PL_throw()

  * FIXED: FreeBSD testing for rlim_t type (configure).  Thanks to
    Colin E. Johnson.

  * PERFORMANCE: Added indexing for non-tagged numbers (> 16M)

  * FIXED: current_stream/3 for streams having an alias name.  Fix 
    also affects other stream-related predicates returning an aliased
    stream.

  * FIXED: added space in write(a+ -1).

VERSION 3.0.0
=============

  * FIXED: Actually test for GCC-2 feature to handle label-addresses.
    Should fix compilation on Rapsody, where cc says it is gcc-2, but
    the gcc extensions are not enabled (by default).

  * FIXED: Detection of topOfHeap() on m68k linux (and other linux brands),
    using a patch contributed by Roman Hodek.
    
  * FIXED: Garbage collection error, resulting in a false `early reset'
    in a specific combination on call-back from C to Prolog and 
    choicepoints.  With thanks to Lourens van der Meij for reporting
    and localising the problem.

  * ADDED: PL_cons_functor_v() to create a functor from a vector of
    term-references.

  * FIXED: discontiguous and multifile cause the predicate to be considered
    `defined'.  Thanks to Paulo Moura.

  * ADDED: prolog_list_goal/1 hook to intercept the 'L' command from the
    debugger.

  * FIXED: configure detection of type rlim_t on some platforms.  Thanks to
    Volker Stolz.

  * MODIFIED: <module>:<head> :- <body> is now compiled differently from
    <module>:(<head> :- <body>).  The clause is added to <module>:<head>,
    but <body> is executed in the context of the definition module.  This
    behaviour is compliant with Quintus and SICStus Prolog, and required
    to deal with the XPCE 5.0 class-compiler.  In most cases, this just
    allows to remove now redundant module specifiers.  In the rare cases
    the old behaviour is required, just but enclose the close in braces.

  * FIXED: abolish/[1,2] on an imported predicate.

  * ADDED: Putting `resources' into a saved state.  Especially for dealing
    with XPCE (graphics) resources.  See resource/3, qsave_program/[1,2],
    open_resource/[3,4], plrc(1), PL_open_resource().

  * FIXED: Sfread() and Sfwrite() to return proper value on short read/write.

  * FIXED: Copy-problem in Which() (pl-os.c).  Made the problem below
    appearant.

  * FIXED: Symbols() to deal with x-only executables (Unix).  Thanks to
    Gernot Salzer (caused a crash).

  * FIXED: Docs for PL_cons_list().  Thanks to Ivan Karski.

  * ADDED: PL_cons_functor() the first argument may now also appear in
    the argument list.

  * FIXED: putNum()/getNum() format to deal with any value that can
    be represented in a long.  Fixes an assertion failure while booting
    on some platforms.

  * FIXED: Quoted write in feature(character_escape, true) is effective
    to write the atoms such that they can be read back.  Spotted by
    Bernd Werner.

  * ADDED: Seek/4, Quintus compatible implementation for seeking to an
    indicated position in a stream.

  * FIXED: Various traceports to make Prolog exit on reading end-of-file,
    rather then entering an endless loop.

  * FIXED: put/[1,2] to raise an exception on IO errors.  Patched
    SIGPIPE handling to clear the buffer of the offending stream,
    so a subsequent close() on the stream will not cause another
    SIGPIPE.

  * MODIFIED: file_directory_name/2 output never contains a trailing
    /.  If no directory is present, the result is '.'.

  * DELETED: -B command-line switch

  * DELETED: old save/restore facilities.  

VERSION 2.9.10
==============

  * ADDED: dup_stream/2 to copy stream handles.

  * ADDED: Allow for specifying stream alias-name to PL_open_stream(),
    also used by open_null_stream/1, so open_null_stream(null) will make
    `null' an aliased null-stream.

  * UPDATED: Some parts of the documentation.

  * FIXED: Control-C handling on some platforms (notably Solaris 2.5).

  * ADDED: options close_on_abort and buffer to open/4.

  * FIXED: write(not (a,b)) ommited the space and wrote not(a,b).  Thanks
    to Stefan Mueller.

VERSION 2.9.9
=============

  * FIXED: Portability problems for Solaris 2.6.

  * FIXED: throwing Prolog exceptions on `Broken Pipe' in flush/0 and
    flush_output/1.

  * FIXED: detection of limit on datasize on SGI platform.  Thanks to
    Marcello Balduccini.

  * FIXED: Possibility of a crash in Symbols(), notably affecting embedded
    systems (at startup).  Thanks to Anton Eliens.

The 4 bugs below were reported by Luc Van Oostenryck.  Thanks.

  * FIXED: concat_atom/3 if the separator is not an atom.

  * FIXED: arg(0, Term, Arg) to fail

  * FIXED: atom_char(abc, X) to raise an instantiation fault if the length
    of the atom is not 1.  Also, return integers in the range [1..255] instead
    of [-128..127].

  * FIXED: -0xff is now read as -255.  Not sure if -(255) would not be a
    better idea!?

VERSION 2.9.8
=============

  * WIN32: Replaced various C runtime functions by their native Win32
    versions.

  * FIXED: Calling module transparent predicates from the outer foreign
    context using context module NULL to call in module "user", rather than
    in the definition module of the predicate.  Found by Stephane Berhault.

  * FIXED: Early switch off the tracer after an abort to avoid tracing
    the hooks.

  * ADDED: explain/1 reporting references to undefined predicates (i.e. which
    clauses reference the undefined predicate).  Also explain/1 reporting
    references to XPCE methods.

  * FIXED: explain/1 reporting non-existing references to compound terms.

VERSION 2.9.7
=============

  * FIXED: avoid some warnings to get clean compilation on GCC 2.8.0.

  * FIXED: detection of discontiguous predicates (avoids false alarm).

  * ADDED: Predicate definition for (*->)/2, mainly to allow for testing
    for its existence and avoid redefinition.

  * ADDED: Options to qsave_program/2 may be specified as Name(Value)
    or Name = Value.

  * FIXED: `map' option of qsave_program/2.

  * FIXED: handling of dynamic predicates import/export by
    qsave_program/[1,2].  found by Lourens van der Meij.

  * PORT: fixed pl-load.c for systems supporting the ELF dynamic load
    functions, but not RTLD_LAZY (FreeBSD?)  Lost the name of the guy
    pointing me to this problem.  Thanks anyway!

  * FIXED: handling of a functor as key for recorded and frieds, found by
    Lourens van der Meij.

  * FIXED: current_stream/3 if a current stream refers to a pipe.  Found
    by Robert van Engelen.

  * FIXED: dereferencing symbolic link of argv[0] to find the `real'
    symbol file.  Reported by Milan Zamazal, where this problem caused
    a crash when running SWI-Prolog using M-x run-prolog under Emacs.

VERSION 2.9.6
=============

  * MODIFIED: list_to_set/2 retains the first, rather then the last
    occurrence of duplicate members to the set.

  * FIXED: flag/3 using floating-point numbers for machines that cannot
    address doubles on 4-byte alignment (most RISC processors).

  * FIXED: foreign-reference handling of exception terms, causing garbage
    collection problems.  Reported by Robert van Engelen.

  * PORT: improved detection and placement of mmap()-ed stacks (Unix sparse
    stack-management) with help of Marcello Balduccini.

  * FIXED: clause/3 to add/remove predicate reference-count while holding
    a choicepoint to the predicate.  Reported by Marcello Balduccini.

  * ADDED: -c flag to plld to turn it into `plcc', just compiling .c or
    .cc files.  Thanks to Marcello Balduccini.

  * MODIFIED: write/1 and friends now only insert spaces before and
    after operators if these are required to be a valid term for read/1.
    The only exception is ,/2, which is written using a space after the
    symbol.  NOTE: foreign packages including <SWI-Stream.h> need
    to be recompiled!!!

  * FIXED: current_predicate/2 not consider abolished predicates that
    still exist as `current', so current_predicate(_, Goal), Goal is
    guaranteed not to raise an exception on Goal.  Should fix recent
    reconsult problems in XPCE.

  * ADDED: user:message_hook/3 hook for print_message/2 (provisional).

  * MODIFIED: Hooks installed by PL_initialise_hook() are called *before*
    the saved-state is loaded, but after the heap is initialised.  This
    implies only foreign predicates may be called from this hook now.

  * FIXED: testing of write-permissions for the library index for
    make/0.

  * MODIFIED: Toplevel queries are now read from user_input, rather
    than from the current input stream.

  * ADDED: feature(history, Depth).  If 0, no history and no history-prompt
    are provided.  This is the default if feature(readline, true) succeeds.

  * FIXED: set_feature(Name, Integer)

  * FIXED: chdir/absolute_file_name problem, reported by Machiel Jansen.
    Thanks.

  * FIXED: erase/1 on records referenced by recorded/3 choicepoints.  Thanks
    to Robert van Engelen.

  * FIXED: Reference direction in recorded/3 (also used by findall/3 and
    friends).

  * FIXED: Removed various warnings for SunSoft cc compiler.  Fixed
    one error reported by this compiler.

  * FIXED: Cite references in online documentation.  Modified/Cleaned
    man/plindex.pl for this.  Fixed a few typos.


VERSION 2.9.5
=============

  * FIXED: dwim_predicate to deal properly with default modules.

  * FIXED online manual not to use overstrike by default.  See manual
    for details.  XPCE requires patched prolog/lib/swi_help.pl to work
    properly with this version.

  * FIXED: plld for handling -l<lib> correctly in the Unix version, and
    automatically deleting temporary .exp files in Win32.

  * FIXED important fix returning address of local variable, found by
    Jean Daniel Fekete.  Thanks.


VERSION 2.9.4
=============

  * FIXED: Various references to the variable stacks for systems requiring
    the stack-shifter.  Thanks to Michirou Yabuki for reporting.

  * FIXED: recorded database (and findall/3, bagof/3, setof/3 store) 
    handling of strings.  After retrieval, the string's indirect header
    was incorrect, making unification and equivalence fail.  Thanks to
    Andrew Dadakow for providing me with a simple program illustrating
    the problem.

VERSION 2.9.3
=============

  * ADDED: (Simple) support for exceptions in the GUI-tracer.

  * MODIFIED: PL_extensions array now needs to be explicitely registered
    using PL_register_extensions() for compatibility with Win32.  Documented
    PL_register_extensions().

  * FIXED: print/1 to include the `quoted' option as it used to before
    2.9.0.  Thanks to Sam Waugh for noting.

  * NEW: plld is now written in C, and adapted for usage on Windows-NT
    and Windows '95.  The latter is incomplete, but useful for creating
    embedded Win32 console applications.  The old plld is available as
    plld.sh in the source distribution.

  * FIXED: PL_register_foreign() now declares the function-pointer as
    a void * for C++ code, so it may be used with C++.

  * MODIFIED: tmp_file/2 now returns the canonical filename on
    Windows platforms (i.e. c:/temp/base<n>, rather then C:\TEMP\base<n>).
    use prolog_to_os_filename/2 to convert between the two formats.

  * FIXED: catch/3 for proper continuation if the recovery goal
    succeeds.

  * FIXED: definition of ulong on some platforms for the new pl-global.h
    module.


VERSION 2.9.2
=============

  * CLEANUP: Removed various unreachable statements reported by the
    SGI native compiler.

  * FIXED: Unresolved message for S__fupdatefilepos() using native
    SGI compiler, which does not emit code for inline functions.

  * FIXED: diagnosis of `discontiguous' and `redefined' predicates
    while the predicate is reconsulted while it is running.
	
  * FIXED: Posibility of calling alloca(0) in pl-rec.c, spotted by
    Tamas Laufer.  Should fix SCO Unix version.

  * FIXED: absolute_file_name/3, generation of multiple solutions:
    avoid regenerating the same solution.  Caused make/0 to slow down
    more and more.

  * IMPLEMENTATION: Partial preparation for multi-threading.  Removed
    lots of unnecessary global variables and moved most of the remaining
    ones into three structures defined in the new file pl-global.h.
    Read-only global data is now declared `const', putting it into
    shared memory on good machines/compilers.  As a result, SWI-Prolog
    is a little smaller and faster.

    Still need to get rid of the remaining global variables and need
    to embrace all heap-operations to prepare them for the use with
    mutexes.

  * FIXED: trace-interception calling on fail-port, causing the GUI
    tracer to crash on some ocasions.

  * DELETED: Source file pl-dump.c, implementing save/1, restore/1
    and save_program/1.  These predicates only worked on a few
    platforms anyway.  qsave_program is now the only (and portable)
    saved-state mechanism.

  * IMPROVED: Removed limit on number of user-defined arithmetic
    functions.

  * IMPROVED: Format ~s accepts both a list of ASCII chars or a
    string (see string/1) object.  Thanks to Peter Ludeman.


VERSION 2.9.1
=============

  * FIXED: auto-detection of -export-dynamic in favour of -rdynamic
    (GNU-ld based systems using ELF binary format not supporting
    -rdynamic, e.g. Solaris using gcc with GNU-ld).  Thanks to
    Volker Weber.

  * FIXED: mmap configuration issues, with thanks to Daniel Pun.

  * FIXED: some changes to the Makefile(.in) and configure for portability,
    by Joel Faedi.

  * FIXED: wouldBindProcedure(), used by $xr_member, used by the explain
    facility.  Could crash.


VERSION 2.9.0
=============

  * ADDED/MODIFIED: The interface to PL_open_query() has changed.
    The debug argument is replaced by a bitwise or'ed flags argument.
    The values FALSE and TRUE have their familiar meaning, making old
    code using these constants compatible. Non-zero values other than
    TRUE (1) will be interpreted different.

  * DELETED: display/[1,2] and displayq/[1,2].  Added emulation into
    library(backcomp).

  * ADDED: ISO/Quintus compliant write_canonical/[1,2].

  * FIXED: recorded database bug for very large terms.

  * ADDED: Lots of exception codes.  Roughly, file i/o, external program
    invocation and arithmetic now use exceptions.

  * IMPROVED: write/1 and friends now check the return code of the
    low-level I/O functions and fail with exception on read/write
    errors.

  * REMOVED: $print/2.  Doesn't appear to be used anywhere.

  * ADDED: write_term/[2,3], ISO compliant

  * ADDED: ISO compliant exception handling using catch/3 and throw/1,
    including a C-interface for these (PL_throw() and PL_exception())
    Added exception port to the tracer.

  * ADDED: abolish/1, ISO compliant.

  * FIXED: A is "a" (list as abbreviation for a character).


VERSION 2.8.7
=============

  * FIXED: require/1 to be silent on already defined system predicates.

  * FIXED: passing ldflags in plld script.

  * CONFIG: Removed checking for -lelf if the system is not asked
    to configure old save/1.

  * CONFIG: Modified test/mmap.c to find out whether we should allocate
    from the top or base of the heap.  Added TOPOFHEAP to config.h.  Should
    fix Irix problems.


VERSION 2.8.6
=============

  * Included src/pl.1.in (new file, forgotten in the 2.8.5 release)
 
  * INSTALL: slightly more careful installation of the manpages and
    small problem in configure fixed.


VERSION 2.8.5
=============

  * MAN: Updated manual sources for a couple of recent changes, added
    support for generation of the help/1 database using new tools for
    nroff like generation of plain text from a LaTeX document.  Generated
    all three formats of the manual: HTML, PostScript and plain text.
 
  * FIXED: Installation of the manual page for correct description of the
    pl -dump-runtime-variables.

  * ADDED: For machines using memory-mapped stacks (Linux, SunOs, Solaris,
    OSF/1 for example), added heap-size switch: -H.  Default is 256Mbytes.

    Size switch now take optional 'm' (Mega), 'k' (Kilo, default) or 'b'
    (bytes): -L32m specifies 32 Mbytes local stack.

  * FIXED: print error message if heap allocation above prefect fit
    schema (>1024 bytes) fails (malloc() returns NULL).  All allocation
    failures now call outOfCore().

VERSION 2.8.4
=============

  * FIXED: PL_{get,put,unify}_pointer() mapping of pointer to integer,
    to ensure all possible pointer values are restored properly.

  * CLEANUP: Removed various internal unused functions, changed
    functions to be local that were only called locally.
  
  * MODIFIED: Redesign of various parts of the system to get rid of
    terms living in the permanent heap. This modification allows the
    permanent heap (where malloc() operates) to grow unlimited (used to
    be 64 MB).

    + Records (recorda/3, recorded/3, erase/1) are no longer stored
      as copies of the global-terms, but instead as a form of compiled
      code, optimised for copying the object back to the runtime stacks.

      Records are also used by findall/3, setof/3 and bagof/3, and these
      predicates have thus been modified too.  The interface between the
      C and Prolog part has changed, making old saved-states worthless.
      Old QLF files work properly.

    + Records are also used by the /f goal option of the tracer.  The
      implementation of this has been changed drastically.  The result
      is a lot faster while searching and a bug has been fixed.

    + loadXRc() in pl-wic.c has been modified not to store longs, doubles
      and string onto the heap.  This is the desired behaviour anyway.

    + Feature storage changed to use a union type, rather then integers
      on the heap.

    + Variable analysis in the compiler now used TAG_ATOM|STG_GLOBAL,
      like records, to flag the analysed variables.

    + Temporary variable management in read/1 using the same trick.

    + Atoms are indexed over a global, resizable, array.

    GOOD THINGS

    + makeRef() now simply is makeRefLG().

    + Trail() is simplified a lot.

    + makePtr() (pl-gc.c) no longer deals with heap pointers

VERSION 2.8.3
=============

  * FIXED: Changed manual to talk about PL_atom_chars(), rather then
    PL_string_from_atom().

  * FIXED: oset_addel/3, thanks to Robert van Engelen for both the
    report and the patch.

  * FIXED: string_to_list(X, []).

  * FIXED: Order and unlinking shared objects.  Now, all files are
    closed before unlinking any shared libraries.  Shared libraries
    are unlinked explicitely only on non-Unix systems.


VERSION 2.8.2
=============

  * FIXED: GC/tracer for clauses holding string objects at particular
    places.  Reported by Andrew Dadakow.

  * FIXED: Deleted old pl.mak, and added plwin.mak and plcon.mak for
    rebuilding the sources on Windows.

  * FIXED: Typo in the $write_on_* predicates, underlying sformat and
    swritef, causing a crash on > 1024 characters output.  Thanks to
    Shane P. McCarron.


VERSION 2.8.1
=============

  * FIXED: DEC Alpha (64-bit): reading integers	> 2**31-1.  Configuration
    of mmap based sparse stack allocation to deal with the Alpha.  Various
    warnings removed.  Fixed test.pl to be aware of the Alpha where
    necessary (float-3 test).

  * FIXED: Garbage collection problem, occurring with a specific
    combination of call-back from C and choicepoint organisation
    in the callback environment.

  * FIXED: Tracer `retry <n>' (guitracer only) to take care of garbage
    collected choicepoints.

  * FIXED: initialisation of style_check defaults to specify
    singletons, long atoms and discontiguous clauses.  NOTE: THIS MAY
    CAUSE WARNINGS ON OLD CODE.

  * ADDED: Several predicates for math in library(quintus).

  * FIXED: abolish/2 on active (running) predicates, not to remove the
    NEEDSCLAUSE_GC flag, so the clauses are actually removed if the
    predicates is finished.  Thanks to Paulo Moura, author of LogTalk.

  * FIXED: PL_get_arg() when using -L0 -G0 (maximized stacks).  Probably
    only breaks tracing code under these circumstances.


VERSION 2.8.0
=============

  * FIXED: `$qlf_info'/3 (always failed).  Used by the development
    environment under construction.

  * RUNTIME SYSTEM: Made various of the debugger options conditional
    on whether or not the system is compiled as runtime system.

  * ADDED: more options to user:prolog_event_hook/1 for better
    interaction	with the GUI tracer: possibility to `watch' a
    stack-frames end-of-lifetime.

  * FIXED: writeq('%') to write '%' rather then just %.

  * FIXED/MODIFIED: subterm_positions option of read to return the
    positions of possible surrounding braces for a term.  Thus,
    reading (hello) now yields 0-6 rather then 1-5.  This notably
    fixes the 'f' (finish) option in the GUI tracer to properly
    indicate the succeeded clause.

  * PORT: Configure detected tcgetattr()/tcsetattr() usage rather then
    ioctl(), fixing terminal interaction on OSF/1.

  * PORT: Fix in Makefile to make it work with some broken shells.

  * PORT: renamed I_POP virtual machine instruction to I_POPF, to avoid
    a conflict with system headers on some machines.

  * PORT: Added support for the 64-bit DEC Alpha processor (or, more
    in general made the code 64-bit clean).  Tested on a DEC Alpha
    using OSF/1 4.0 and the native C-compiler.  Should also work on
    GCC, but the local GCC installation appeared broken.  With thanks
    to Bryan Sorrows for providing me with access to their machine.
    Exactly while I was working on the port, Martin Ostermann mailed
    me patches for running on the Alpha under Linux.  Thanks for the
    couple of problems I missed!

    Remaining problems: can sparse memory management work on OSF/1?
    Currently, saved states are portable, but the limits on the Alpha
    are much larger.  This should be fixed.  Prolog machine words are
    64 bits on the Alpha, doubling the stack-sizes and virtually
    removing all limits.  In theory, it would also be possible to use
    ints (32-bit) for this.  I have not checked this.  It is not unlikely
    there are variables defined `int', where they should have been
    `long', truncating large numbers.

  * FIXED: globalAlloc() for allocations larger than a page on machines
    with sparse memory management, not handling stack-overflows as
    exceptions (Win32).  Fixes handling of long string objects on these
    platforms.

  * FIXED: (GUI Tracer) Stopped `cut-port' from activating when in
    `leap' mode.


VERSION 2.7.20
==============

  * ADDED: Documentation for expand_query/4 and expand_answer/2.

  * ADDED: call_with_depth_limit/3, to aid theorem provers.

  * ADDED: features 'unix' and 'windows' for these operating systems. 

Version 2.7.19
==============

  * FIXED: functor(X, name, -1), reported by Robert van Engelen.  Thanks.
	
  * FIXED: :- format_predicate/2 handling of arguments.

  * ADDED: external "C" declaractions for SWI-Stream.h, so you can use this
    in C++ programs now.

  * FIXED: the function sign/1 for floating point numbers.

Version 2.7.18
==============

  * ADDED: Directory html for a SWI-Prolog based latex2html translator.
    Very extensive example of using foreign code.

  * REMOVED: Lots of unused files from the source-distribution

  * WIN32: Removed the uxnt.dll library.  This library is now a static
    library linked into libpl.lib, the SWI-Prolog kernel.

  * FIXED: Handling of -p alias=path:...: order of the arguments doesn't
    matter anymore and parsing of the path has been fixed.

  * MODIFIED: load_files/2, `silent' option inherits to loads triggerred
    from this one.

  * FIXED: Garbage collector error, causing a crash if the local
    and global stack together exceed 64 MB.  Now, they can each
    be 64 MB and be allocated at arbitrary positions.

  * CHANGED: Default editor command is now <editor> "<file>", using
    double instead of single quotes.  This fixes problems on Windows
    platforms.

  * ADDED: clause_property(+Ref, ?erased), to support the debugger
    reporting about running modified clauses.

  * FIXED: current_functor(+Name, +Arity).  Reported by Stefan Wimmel.
    Thanks.

Version 2.7.17
==============

  * MODIFIED: the `debug' argument to PL_open_query() now really stops
    the debugger operating inside the called goal, also if an error
    arrises.

  * PORT: Sgi/Irix headers configuration and detection of alignment
    restrictions on doubles.

  * FIXED: Better operator priority checking, making a :- b :- c illegal
    syntax, as it should be.  Also improved the warning issued.

  * FIXED:  Removes MAX_TERM_NESTING from read.pl, previously limiting
    the complexity of terms that could be read.  The new version of
    read requires significantly less (C-) stack and can handle
    much more deeply nested terms.

  * FIXED: term_to_atom(+Term, -Atom) on machines with dynamic stacks,
    but no exception based expansion (PC version).

  * FIXED: Sopenmen() stream functions (was not used before).  This
    is now used by tellString() and toldString(), who now have a
    different interface.  These functions are used by term_to_atom/2,
    and format/[1-3].


Version 2.7.16
==============

  * FIXED: Various minor issues in the Makefiles and configure for
    generating a runtime version.  Error message if the runtime
    system cannot find its state.

  * FIXED: Heuristics for making hash-index.

Version 2.7.15
==============

  * FIXED: Embedding: the kernel now not longer gives up if it cannot
    find the Prolog home directory.  feature(home, Home) will fail if
    the home could not be located.

  * FIXED: Configure problems related to -l[n]curses, etc.

  * FIXED: retractall(Module:Head(+Arg, ...)) (i.e. explicit module and
    instantiated first argument).

  * ADDED: atom_prefix(+Atom, +Prefix): test of Prefix is a prefix
    of Atom.

  * FIXED: Bug in Unify between non-tagged and tagged integer.

  * FIXED: Bugs in configure, both improper test of double alignment
    and improper testing for the cursus libraries.  Thanks to
    Masafumi Nakane.

  * IMPROVED: Moved source_file/2 to foreign language to exploit the
    kernel-maintained database for enumerating the predicates loaded
    from a sourcefile.

  * MODIFIED: prolog_trace_interception/3 now has 4 arguments.

  * ADDED: Support for tracing the cut in the source-level debugger.

  * ADDED: Support for `break-points' to the debugger.

  * FIXED: Protocol to include the prompt in the protocol.

  * ADDED: clause_property(ClauseRef, fact).  Used by source-level tracer.

  * ADDED: Various options to prolog_frame_attribute/3 for the source-level
    tracer.

  * FIXED: allow for tracing the unify-port of a fact.

  * ADDED: prolog_frame_attribute(Frame, argument(N), Arg) to read
    bindings from a stack-frame.

  * ADDED: Various options to plld, the standalone executable linker.

  * IMPROVED: (if->then;else) to generate tail-recursion code for the
    `then' part.

  * ADDED: $clause_position/3 and prolog_frame_attribute(Frame, pc, PC).
    First steps for a source-code debugger.

  * IMPROVED: Clause-representation to delete subclauses member, which
    proved obsolete using the current system.  Added UNIT_CLAUSE flag
    to the clause's flags to achieve the same support for the decompiler.

  * FIXED: handling of the stream user_error by other predicates than
    format/[1-3].  Also, using output from write/2, etc. to unbuffered
    streams like user_error is now buffered in 256 byte-blocks, but
    guaranteed to be flushed after the write operation completes,
    resulting in fewer calls to write() and therefore generally better
    performance.

Version 2.7.14
==============

  * FIXED: Win32 shell/1 implementation has changed radically, not
    using threads anymore.  This hopefully fixes shell/1 on all
    platforms.  The old version started a thread to wait for the
    process, while the main thread continued processing windows
    messages.  The new version loops through PeekMessage, GetExitCodeProcess
    and Sleep, processing messages and waiting in the same (main)
    thread.

  * FIXED: reentrance problem in Sgetc() (low level fetch for character),
    upsetting the tracer sometimes when using XPCE.

<this version was put on the ftp server Sep  6>

  * FIXED: current_stream/3 failed to properly enumerate the streams.
    Thanks to Robert van Engelen.

  * MODIFIED: ensure_loaded and use_module now load if the file has
    been changed since it was last loaded, and not only if it was not
    loaded before.

  * ADDED: load_files/2 to load files with various options (including
    silent loading).  The undocumented $consult_file/2 has gone!

  * INSTALL: Win32: nice looking installation procedure, based on the
    WISE installation expert package.

  * ADDED: A *-> B ; C (softcut).

  * FIXED: Random generation for machines that use rand().  Still
    poor, but then this function is bad.  Maybe use our own someday.

  * ADDED: Win32: console support for variable-pitch fonts and user
    selection of fonts.

  * FIXED: <String> =.. X, found by Robert van Engelen.
	
Version 2.7.13
==============

  * FIXED: prolog_frame_attribute/3 to include the arguments in the
    goal.  Found by Andreas Schlemminger.

  * FIXED: listing (clause/2) for predicates holding if->then;else or
    a;b in their body.  Found by Andreas Schlemminger.

  * FIXED: shell/1 for Windows platforms (waited almost indefinitely
    before executing the program).

  * ADDED: plregtry.dll and registry.dll, providing access to the
    Win32 registry database.  

  * ADDED: setting up a DDE server for better interaction with the
    Windows 95 shell (direct edit and consult from the explorer).

Version 2.7.13 (ALPHA)
======================

  * ADDED: mode update for open/[3,4] to write at any location in an
    existing file. 

Version 2.7.12
==============

  * FIXED: behaviour of the tracer.  Notably included missing fail-ports
    from the trace.  Also fixed the box-counts for the profiler.

  * ADDED: expand_term/2 now first tries term_expansion/2 in the module
    that is being loaded.  After that it tries the module user.

  * FIXED: Various improvements to the explain facility, notably much
    better location of predicate cross-references.

Version 2.7.11
==============

  * MODIFIED: feature(version, Version) and PLVERSION are now numeric.

  * FIXED: reporting out-of-stack now never calls the Prolog exception
    handler to avoid a real crash.

  * ADDED: Syntax for maintaining source-location inside term-expansion.
    If a term of the form $source_location(File, Line):Clause is found,
    not the current, but the given location will be recorded with the
    clause)

Version 2.7.10
==============

  * PORT: More changes to PL_unify_term() by Franklin Chen.  Now really
    compiles on MkLinux.

  * FIXED: retract/1 once more.  Now tested on all combinations of
    (non-)unit-clause and with(out) module specifier.

Version 2.7.9
=============

  * FIXED: interaction between tracer and garbage-collector, sometimes
    causing an assertion-failure in the garbage collector when tracing.
    Reported by Lourens van der Meij.

  * CHANGED: flag/3 now handles full 32-bit integers and double
    float values.  Old version was limited to tagged ints and didn't
    do floats.

  * PORT: Rewrote PL_unify_term() to avoid using va_list *.  May or
    may not help.  Problem arises on the PowerMac version of Linux
    when compiling pl-fli.c.  Reported by Franklin Chen.

  * PORT: Portability patches for AIX 3.2/4.1: avoid name-clash with
    hz and fid_t.  Contributed by Kay Roemer.

  * FIXED: documentation of PL_unify_list() interface function.

  * FIXED: name/2 to behave correctly in the tracer.  This problem
    may appear with more foreign predicates and maybe requires a
    more fundamental solution.  Reported by Chan Kam Fai.
	
  * FIXED: retract/1 on non-unit-clauses.  Thanks to Liviu Badea.

Version 2.7.8
=============

  * Some fixes to the Makefile.  No functional change.

Version 2.7.7
=============

  * DOC: Added documentation for PL_unify_term(), making its specs
    `official'.

  * ADDED: PL_query(PL_QUERY_VERSION) to find the version of Prolog
    running.  Used by plwin.exe to display the correct version in the
    window titlebar.

  * WIN32 Process creation: added win_exec/2 and changed shell/1 such
    that shell('<Command> &') behaves as win_exec(<Command>, normal).

  * WIN32 DDE: Added dde_poke/[3,4] to support DDE poke operation required to
    communicate with the sybase database for Windows.  MODIFIED
    dde_request/3 to return a string object rather then an atom to
    avoid filling the atom-space.

  * WIN32: For filenames, ~ is expanded to %home%.  When not present,
    %homedrive%%homepath% is used, which expands to NT's notion of the
    home directory.  Finally, '/' is used as fallback.

  * MODIFIED: Changed directory structure of make rt-install to be
    the same as normal installation.

  * FIXED: Installation on Pentium Pro: bad detection of canonical
    system type by autoconf's config.sub.  Updated configure.in to
    use autoconf 2.10.

  * FIXED: Backtracking on floats and large integers appearing in the head.
    The VM instructions H_FLOAT and H_INTEGERS handling these didn't
    trail the argument.  Bug introduced in 2.7.0.  Thanks to Peter
    Terptra for reporting.

Version 2.7.6
=============

  * MODIFIED: Added some more support for very deeply nested terms on
    the last arguments (long lists beeing one of them) by introducing
    a new compilation schema for such terms.  Also modified numbervars/4
    to exploit right-recursion of terms.

  * MODIFIED: Argument-stack default-limit changed from 8 KB to 1 MB
    for machines with dynamic stacks.  16 KB for others.  This limits
    most of all the depth of terms handled by assert/retract.

  * FIXED: Emacs-interaction bug using history.  Thanks to Dave Moffat.

  * FIXED: decompilation (retract, listing, etc.) for predicates with
    0 arguments.  Reported by Dave Moffat.

  * FIXED: configuration for system where readline requires -lcurses
    rather then -ltermcap (and the latter is not present).

Version 2.7.5
=============

  * FIXED: typo in float <-> long conversion problem.

  * FIXED: plld now passes -D* to the compiler rather then the linker.

Version 2.7.4
=============

  * FIXED: handling of floating-point conversion to integers on machines
    raising SIGPFE on l = (long)f when f is out of the long range.  Thanks
    to Sven.Hader@Informatik.TU-Chemnitz.DE (Sven Hader).  The problem
    appears at least on Linux running on a Pentium.

  * MODIFIED: Added -F file flag to select from multiple initialisation
    scripts, just like -f file.  Old versions only loaded plrc.   The
    new version by default loads <program>.rc.  -F none stops loading
    this file.

  * FIXED: plld: gave error code 1 (always).  Added various flags: -v
    -help, -pl.  Updated manuals

  * FIXED: PL_next_solution() detection of non-deterministic success
    (reported deterministic for actually non-deterministic goals).

  * ADDED: For XPCE users: nice graphical frontend for the online help
    functions.  Working on much better Prolog mode for PceEmacs.

  * PORTABILITY: Removed void * arithmetic in pl-setup.c, removed
    a couple of other non-strict-ansi things there.  Added configure
    for alloca().  Reported to compile using IRIX 5.3 native compiler
    now.

  * FIXED: Sclose() flushed write-buffer for read-only streams.

  * ADDED: read_term/[2,3]: reading with various options

  * FIXED: copy_term/2: handling of combination of ground compound
    terms and shared variables.

  * FIXED: PL_next_solution() detection of determistic success.

  * ADDED: concat_atom/3 for concatenating multiple atoms with a separator.

  * FIXED: Online manual generation for dynamic/1 and friends.  Parser
    now deletes \verb from summaries.

  * FIXED: $xr_member (underlying explain/[1,2]) for clauses containing
    string objects (crashed).  Improved various details to explain/[1,2]

  * MODIFIED: Quoted writing of an invalid float yields '$Infinity' or '$NaN',
    unquoted Infinity or NaN.

Version 2.7.3
=============

  * FIXED: ?- expand_term(A,B), reported by Fergus Henderson.

  * FIXED: cleanup after calling Prolog-defined arithmetic functions
    (caused a crash when two arithmetic functions are called in the
    same context).

  * Renamed PL_reinit_hook() to PL_initialise_hook(), which reflects
    more the current function.  Use this to register the readline
    interface, so it is available while loading .plrc.  Se also
    pl-extend.c and its public copy stub.c.

Version 2.7.2
=============

  * ADDED: features `debug_on_error' and `report_error'

  * ISO: If a predicate has no clauses and is defined either dynamic,
    multifile or discontiguous, it is considered defined.  This used to
    hold only for dynamic predicates. 

Version 2.7.1
=============

  * FIXED: Signal/readline/abort interfaces for the Win32 versions, so
    signals are handled correctly again and readline-based input handling
    works.

  * FIXED: bug in setup of memory-base pointers, causing all versions
    to fail who allocate memory higher than 128MB, which includes the
    win32 version under win32s (Windows 3.1)

  * FIXED: ar/ranlib configuration (notably for BSD systems, such as
    SunOs 4.1).

  * FIXED: do not load readline interface if the input is not a terminal.
    This bug prevented constructs in shell-scripts such as pl << _EOS_ ...

Version 2.7.0
=============

  * FIXED: HPUX compilation thanks to Gordon Streeter.

  * WIN32: The kernel is now in libpl.dll, which comes with two toplevel
    drivers: plcon.exe for a standard IO version and plwin.exe for the
    windows based version.  New directory embed with the sources of
    both toplevels.

  * FIXED: memory leak after assert/retract of code holding floats,
    32-bit integers or strings (not lists of char-codes).  Also
    provides more compact code for floats and large integers
    (both small and large integers require 2 words, doubles 3 words).

  * IMPROVED: More compact representation of compiled floats, long
    integers and strings.

  * MODIFIED: Complete rewrite of the internal datastructures.  The
    aim is to avoid mixing pointers and unsigned longs on the stacks
    and thus remove the various assumptions on the memory model underlying
    the prior versions. See pl-data.h for details.

  * IMPROVED: Lifted the maximum number of variables in a clause from
    256 to 65536, maximum arity of predicates from 128 to 1024.  Both
    numbers are fairly arbitrary and can be raised further at the cost
    of wasting a little more memory.

Version 2.6.0
=============

  * ADDED: plld and manpage for creating embedded executables.

  * FIXED: flush output of terminal streams while halting.

  * ADDED: option stand_alone for qsave_program to create stand-alone
    executables!

  * INSTALL: The executables are now installed in $(PLBASE)/bin/$(ARCH),
    i.e. using a different directory for each platform, so multiple
    platforms are supported more easily.

  * MODIFIED: Drastic reorganisation of arithmetic handling:

	- All arithmetic is now handled using 32-bit longs and 64-bit
          doubles.

	- Smaller integers (within the range described by the features
	  min_tagged_integer ... max_tagged_integer) are represented
	  internally as tagged integers.  Larger integers and doubles
	  are represented as `indirect data'.

	- A generic representation for `indirect', covering uniform
	  handling of them by the virtual machine, unify and garbage
	  collector.  This deals with strings, doubles and `bignums'.

	- New interface between the arithmetic functions and the
	  arithmetic predicates (is/2, >/2, etc.) as well as their
	  virtual machine instructions.  This new interface is faster.
	  and avoids unnecessary type-conversions.

	- Augmented/renumbered the virtual machine instructions, making
	  old saved states worthless.

	- Fixed a couple of functions translating between floats and
	  integers: integer/1, ceil/1, floor/1, float_integer_part/1,
	  truncate/1, etc. for handling large numbers correctly.

	- Added the feature float_format to define how floats are
	  printed by write/1, print/1, etc.

  * MODIFIED: Disconnected readline and Win32 I/O window interface to
    a separate module.  This is a necessary precondition to arrive at
    a modular and embedible Prolog engine for Win32.  See pl-rl.c

  * FIXED: unknown/2 (reporting instantiation fault).

Version 2.5.6
=============
  
  * FIXED: ceil/1, floor/1 and integer/1 to handle large floating point
    numbers correctly.

  * MODIFIED: write and friends to print floating point numbers using
    the `%g' format by default, printing large floats as -for example-
    3e20.  Use format with the ~f option to format floats as you please.

  * FIXED: on some machines <assert.h> requires <stdio.h> to be included.
    configure now checks for this.

  * FIXED: .qlf file-magic verification.

  * FIXED: Some minor portability problems: test for CC supporting -c -o
    combination, solaris prototypes for random and srandom added, changed
    system parameter detection for file-table-size and page-size to use
    sysconf() when available.  Compilation is now silent on solaris 2.5,
    except for a number of `might not be initialised' warnings in pl-wam.c
    that aren't correct (also, these are not reported by other versions
    of gcc).

Version 2.5.5
=============

  * FIXED: Important bug in =@=, also used by bagof/setof, leading to
    crashes on some structures and failure on structural equal terms
    on others.

  * FIXED: Crash in the tracer under some circumstances, reported
    by Michael Schulz.  

  * FIXED: loading Quick Load Files that do not contain modules.

Version 2.5.4
=============

  * FIXED: read/1 for reading negative floating point numbers (2.5.x bug),
    thanks to Bill Jones.

  * FIXED: read/1, etc. for reading a single variable.  Found by Luu Tran.

  * FIXED: DCG expansion error found by Keith Whitwell.


Version 2.5.3
=============

  * ADDED: ISO at_end_of_stream/[0,1] and peek_byte/[1,2].

  * Fixed and faster nth0/3 and nth1/3 implementations by Martin Jansche.

  * New pl(1) manual page by Martin Jansche.  Thanks.

  * PORT: Ron Ferguson mailed me a couple of fixes for the NeXT machine,
    using release 2 of the C-compiler from the standard development system.
    Thanks.

  * FIXED: decompilation (listing, retract, etc.) for clauses using the
    new (2.5.x) A_REAL instruction.

  * FIXED: \=/2 and recorded/3 for handling shared variables.  Found
    by Joerg Garbers.

  * ADDED: edit definition for emacsclient(1).

  * Fixed unify (=/2) for unification of two floats.  Reported by Dave
    Moffat.

Version 2.5.2
=============

  * FIXED: PL_retry() and friends were lacking from the new SWI-Prolog.h

  * FIXED: PL_cons_functor() and PL_cons_list(), also fixing variable
    handling in bagof/setof.  Thanks to Khanh Doan for reporting.

  * ADDED: string_concat/3 with same semantics as concat/3, but unbound
    will be unified with a string object.

  * ADDED: rl_read_init_file(+File) and rl_add_history(+Line) for better
    readline interaction.  Added readline.3 to the standard installed
    manual set.

  * ADDED: file_name_extension/3 to reason about filename extensions in
    a machine-independent manner.  Fixes Win32 associations if the filename
    has uppercase extension.

Version 2.5.1 (released for Win32 only)
=======================================

  * FIXED: Stack expansion for some foreign predicates using the local
    stack as temporary area for machines with exception-based stack-overflow
    handling that do not provide the address of the segmentation fault to
    the handler (Win32, Linux).

  * FIXED: Linux: repeated handling of the sequence Control-C, abort.

  * FIXED: Crash after the system has ran out of some stacks on machines
    with exception-based stack-overflow handling and POSIX signals.
    Solaris, Linux and Win32 are the examples I know of.

  * FIXED: CVT_NUMBER and CVT_ATOMIC constants in SWI-Prolog.h,
    breaking name(+Float, -Chars).

  * FIXED: plus/3 for +, -, + instantiation (2.5.0 introduced typo).

  * FIXED: prototype declaraction reported by Martin Jansche.

Version 2.5.0
=============

  * Added features `trace_gc' and `gc'.

  * Added `pl -arch' to get the architecture identifier easily for
    installation and makefiles

  * New implementation of copy_term/2 that shares common compound
    sub-terms.

  * Totally new foreign language interface using `term-references' to
    allow for garbage collection and stack-shifts with active foreign
    code.  Ported all foreign predicates to the new interface.  This
    interface also allows for generating multiple alternatives for
    a Prolog goal from C.

    For compatibility with old foreign code, see README.oldforeign.

  * FIXED: optimised compilation of A is X (i.e. second argument is
    a variable).

  * COMPILER: improved compilation of floating-point arithmetic using
    -O (optimised), avoiding unnecessary copying of floating point
    numbers to the global stack.

****************************************************************
	     INCOMPATIBLE FOREIGN LANGUAGE INTERFACE
****************************************************************

Version 2.1.15
==============

  * FIXED: read/1 to push the load context when reading end-of-file, so
    the following works:

	term_expansion(end_of_file, end_of_file) :-
	    	prolog_load_context(file, Path),
		format('Finished loading ~w~n', [Path]).

  * FIXED: abolish/2 on imported procedures.  Reported by Peter Barth.

Version 2.1.14
==============

  * DISTRIBUTION: Removed various out-of-date files from the distribution:
    Makefile.win, Makefile.dos, etc.

  * WIN32S: Fixed problem in the garbage collector.

  * WIN32: Improved cputime for NT ('95 and win32s use the old code).

  * MANUAL: Martin Jansche <martin@pc03.idf.uni-heidelberg.de> has send me
    patches for the manual, fixing many smaller and bigger mistakes in it.
    Thanks!

  * DEBUG: Added stuff for debugging for different memory models on Unix
    machines with an mmap() that can map memory at the addresses normally
    used by the target machine.  See morecore.c

Version 2.1.13
==============

  * WIN32: Fixed error reporting of shell/1.

  * FIXED: added a flush() after completing the user-query.  This gives
    better output for ?- write(hello).

  * FIXED: file-name conversion cache management.  This cache is used
    by absolute_file_name/3.

Version 2.1.12
==============

  * Most of these fixed after comments from David Plummer.  Thanks.

  * FIXED: displayq for ','(...)

  * FIXED: read/1 and friends to handle {}(..) and [](...) correctly.

  * FIXED: format/[2,3] to be able to write unlimited-length output,
    provided there are no `pending' ~t's.

  * COMPAT: absolute_file/3 to accept list of access-modes

  * MODIFIED: access_file/2 to succeed on write and append mode if the
    file does not exist, but the directory can be written.

  * FIXED: unification order in translating grammar --> {goal}.  Noted
    by Andreas Steiner.

  * FIXED: Temporary-buffer management in Svfprintf() and friends.

Version 2.1.11
==============

  * FIXED: functor(X, 8, 0) to yield X = 8.

  * DELETED: library_directory(.).  Gives too much problems because the
    system picks wrong files or directories.

Version 2.1.10
==============

  * ISO: added compliant open/4 predicate.

  * Moved all printing of the system (banner, prompt and warnings to
    use user_error (=stderr) rather than user_output (=stdout), so
    it becomes easier to use Prolog's standard output.  Stderr is
    unbuffered, several predicates that will output more than one
    character now use a `temporary buffer' to reduce IO-load.

  * ISO: Added arithmetic functions: rem/2, ** (= ^), ceiling (= ceil),
    float/1, float_fractional_part/1, float_integer_part/1, truncate/1,
    sign/1 and round/1 (= integer/1).

  * ISO Syntax: Changed quoted atom and string syntax to support character
    escapes, broken lines, etc.  These changes can be switched off
    using ?- set_feature(character_escapes, false). for backward
    compatibility.

    Also, 0b110, 0xa2 and 0o70 (binary, hexadecimal and octal) number
    representations are now recognised.

  * ISO: Added features bounded, integer_rounding_function, max_arity.

  * WIN32: Various changes to the console: use standard colours and
    font, allow for changing colours.  Bind Control-Z to end-of-file
    (alternative for Control-D, which is still valid).

  * WIN32: `pl state.qlx' now assumes state.qlx is the result of a
    qsave_program/[1,2] and automatically loads the state.  This
    allows for associating states with the emulator.  Also, pl file.pl
    will automatically chdir/1 to the directory containing the file
    and load the file before entering the toplevel.

  * WIN32: Fixed some filename case problems: expand_file_name/2 now
    works case-insensitive.  Comparing files for sorting is done case
    insenstive.

  * WIN32: Command-line breaking now handles "quoted arguments".  Only
    double quotes and no escape (I don't know the Windows'95 escape
    conventions).

  * WIN32: Fixed filename completion from console window.

  * INSTALL: Fixed detection of non-gnu/gnu make

  * FIXED: use_module/1, etc. to import predicates exported using the
    export/1 directive instead of the module/2 directive.

Version 2.1.9
=============

  * FIXED: Updated stack-shifter code for the changed layout of the
    environment-stack frames.  This bug prevented pl-gc.c to compile
    on machines having no virtual-memory based stack allocation.

Version 2.1.8
=============

  * ADDED: check in exit code that removes possibly incomplete .qlf and
    bootfiles if an error occurred while building the file.

  * FIXED: WIN32 tmp_file/2.  This fixes help/1.

  * FIXED: configure for users of a shell that doesn't export $PWD and
    the system chooses the install-sh script.

Version 2.1.7
=============

  * FIXED: management of clause index-table.  Old code lead to indefinite
    growing of these tables with repetative assert/retract

  * ADDED: Improved dirty-management on clause indexing system to improve
    the performance on retract from hashed dynamic predicates.

  * ADDED: absolute_file_name/3: options file_type, file_errors and
    solutions for compatibility.

  * Win32: compiled (with small updates) for Win32

  * ADDED: Implemented open_null_stream/1 by defining a null-stream in
    SWI-Prologs stream-i/o package to avoid the /dev/null dependency.

  * ADDED: Saving current operator declarations with qsave_program/[1,2].

  * FIXED: Garbage-collector error.

  * FIXED: predicate-reference count problem
  
  * ADDED: style_check(+dynamic) to report on manipulation of predicates
    that are active in the interpreter.

Version 2.1.6
=============

  * INSTALL: installs pl in the SWI-Prolog tree and just creates a link
    from the binary directory.  Makes it easier to move and redistribute
    the SWI-Prolog binaries.

  * CHPL.c: fixed conflict for basename()
  
  * FIXED: file-searching cache returning alternate answers in different
    order.

Version 2.1.5
=============

  * ADDED: notrace(+Goal) to run Goal invisible to the debugger.

  * ADDED: open_shared_object/3 to be able to pass flags to dlopen().

  * CLAUSE INDEXING: version 2.1.5 provides hashing to speed up first
    argument indexing.  Numerous changes had to be made to realise this:
    Indirection in the clause chain of predicates, implementation of a
    lazy automatic system to guess the proper way to index a predicate,
    a new clause-reference count system (avoiding problems with manipulation
    of `active' predicates.  The representation of predicate and clauses
    has changed in various ways.

  * INSTALL: Changed various things to the configure options and detection,
    to the defaults make more sence.  Upgraded to autoconf 2.4, fixed for
    cross-compilation.

  * PORT: Fixed various things for the Linux/ELF port.  Tested on
    Linux 1.2.13 running libc-5.0.9.  Compiled with gcc-2.7.0.

  * PERFORMANCE: Implemented automatic rehashing of all (previously)
    fixed-size hash-tables.  Prevents performance degradation on very
    large programs.

  * FIXED: profile/3 problem (leading to crashes).

  * FIXED: pl -O bug: trailing of is/2 was not handled properly.

Version 2.1.4
=============

  * MODIFIED: Changed definition of absolute_file_name/2.  Moved
    absolute_file_name/3 from library(quintus) to a built-in predicate.

  * ADDED: file_directory_name/2 and file_base_name/2.

  * ADDED: end_of_file is now passed to term_expansion/2.

  * DOC: Many updates.

  * FIXED: read/1 for foo.%comment (i.e. no space between the . and the
    comment).  Note that foo./*comment*/ doesn't work as this will be
    tokenised as `foo', `./*', `comment', `*/'.

  * ADDED: lazy recomputation of clause indexing.  This notably speeds
    up loading .qlf and bootfiles.

  * ADDED: hash_term/2 for advanced indexing of databases.

  * ADDED: setting file_search_path through the command line using:
    pl -p mydir=/foo/bar.

  * FIXED: Semantics of ensure_loaded/1 if the file is already loaded,
    combined with the module system.  See ensure_loaded/1.

  * FIXED: Grammar rule compiler's handling of non-proper lists in the
    head or body (lists ending in a variable).  Lists of more then one
    element are now translated into append/3.  The following now compiles
    ok: string([H|T]) --> [H|T].

  * MODIFIED: term_to_atom/2 and atom_to_term/3 to fail silently on a
    syntax error.  Both predicates now also accept a string in the place
    of the atom to parse strings: term_to_atom(X, "foo(bar)") works as
    expected.

  * ADDED: `swi' and `foreign' aliases to file_search_path/2.

  * MODIFIED: Grammar rule translator now uses 'C'/3 instead of '$char'/3
    to extract the head.  Compatibility.

  * MODIFIED: at_initialisation/1 is now called at_initialization/1.

  * INSTALL: Fixed Makefile and configure to be able to build the system
    for multiple platforms.

  * ADDED: Infra-structure for making portable saved-states (equivalents
    of boot files):

	+ initialization/1	(goals to run at initialization)
	+ volatile/1		(predicates for which not to save clauses)
	+ require/1		(define we require this predicate)
	+ autoload/[0,1]	(autoload needed things now)
	+ qsave_program/[1,2]	(make a quick-loadable state)

  * ADDED: compound/1 to test for compound terms.

  * FIXED: compilation of ``foo:Head :- Body'' to be equivalent to
    foo:(Head :- Body).

  * FIXED: problem in read/1 and number_chars/2 that may have lead to 
    garbage collection errors.

  * FIXED: setarg/3 integrated in the trail-system.  Removes its
    choicepoint and ensures data consistency.

Version 2.1.3
=============

  * ADDED: setarg/3 for extra-logical assignment to arguments of terms.

  * MODIFIED: PL_new_integer() now returns a floating point value if the
    argument exceeds SWI-Prolog's integer range.

  * ADDED: Automatically dumps the top of the runtime stack on floating
    point exceptions.

  * FIXED: Trap floating point exceptions for the win32 version.

Version 2.1.2
=============

  * FIXED: read/1 problem.  Try reading just '0'. ...  Reported by
    Daniela Genius.

  * FIXED: `toplevel' variable expansion system, leading to various strange
    behaviours in handling queries from the user.  It now can also handle
    cases as:

    	?- X = 5.
	?- X is $X + 1.

Version 2.1.1
=============

  * MODIFIED: DCG translation of free variables now calls phrase/3, which
    has been changed slightly to deal with `un-parsing'.  Modification
    is probably not complete, but it fixes some problems encountered by
    Michael Boehlen.

  * MODIFIED: keysort/2 is now stable with regard to multiple values on
    the same key.  Makes this predicate compatible with SICStus and
    Quintus.

  * FIXED: :- dynamic, :- multifile, :- module_transparent and
    :- discontiguous to accept Module:Name/Arity, ...

  * Moved call/[1..] into the compiler.  call/[1..6] is removed from
    library(quintus) as it is now part of the base system. Also fail/0
    and true/0 are now handled by virtual machine instructions.

  * Upgrade to autoconf 2.3, fixed usage of `tr' for Solaris 2.x and
    with that the configuration of --enable-shared.

  * FIXED: number_chars/2 and name/2 now handle floating point numbers.

  * FIXED: interaction between chdir/1 and absolute_file_name/2.

  * FIXED: format('~*c', [10,45]) (or more in general, providing an argument
    to ~c to print the character multiple times).  Thanks to Michael Boehlen.

  * FIXED: PrologPrompt() to allow reading standard input from the -g and/or
    -t goal options.

Version 2.1.0
==============

  * Added facilities to allow for embedding SWI-Prolog in C applications.

  * Fixed semantics of the cut in toplevel queries by compiling the query
    instead of using meta-call.

  * Fixed bagof(A, member([B, C]), L) to yield L = [B,C] instead of making
    new variables.

  * Fixed typo in dde.pl (reported by Thiebaut Moeglin)

  * Integration of NeXT patches from Thomas Hoppe (hoppet@cs.tu-berlin.de).
    Probably still not 100% ok, but should be closer now.

  * Fixed XPCE event dispatching for pl -tty

  * PL_univg() C-interface function added for supporting XPCE > 4.8.10
    with better interface performance.

  * Fixed operator precedence problem (reported by Dave Moffat)

Version 2.0.9
=============

  * ADDED: HPUX interface for shared libraries, but a HPUX guru should
    fix the import/export details (line was too slow to browse to lots
    of manual pages).

  * FIXED: pl-incl.h typo (breaks IRIX 5.3 port and propably others)

  * FIXED: HPUX detection of mmap()'able stacks fixed.

  * FIXED: generation of include/SWI-Exports, the AIX export declaration
    file.

Version 2.0.8
=============

  * FIXED: loading shared objects using dlopen() for solaris 2.x
  
  * FIXED: shlib.pl current_foreign_library/2 administration.

Version 2.0.7
=============

  * FIXED: compilation (boot and .qlf) now donot look for compiled
    (.qlf) files.

  * CHANGED: Default goal writing the banner is now in the flag
    $banner_goal (used by XPCE as a shared library).


Version 2.0.6
=============

  * CHANGED: retractall/1 implementation is now compatible to Quintus,
    avoiding the hacky redefinition in library(quintus.pl).  The difference
    is that now the argument will only be matched against the clause-head.
    on a match the clause will be removed, regardless of its body.  Makes
    no difference for retractall on facts, but does make a difference on
    clauses with a non-just-true body.  retractall/1 is now a deterministic
    foreign predicate that no longer decompiles the clause body, making
    it faster too.

  * FIXED: made .qlf files independent of the directory they where compiled.

  * FIXED: Path canonisation problem

  * FIXED: loading .qlf files holding already-defined modules

  * ADDED: file_search_path file-location system

  * ADDED: access_file(File, exists) to check for bare existence.

  * FIXED: Another clear_uninitialised() problem related to if-then-else
    causing garbage collector and possibly stack-shift errors.  As the
    implementation is now changed radically, this problem should be gone
    forever ...

  * FIXED: copy_term/2.  Now creates more efficient terms (less references)
    and no longer creates bad references.

Version 2.0.5
=============

  * MODIFIED: Replaced libc based stream IO with more general IOSTREAM
    package.  Deleted folding capabilities as just about any IO device
    has these built-in these days.  These changes are to facilate embedding
    in window-based environments that do not support stdio.  See pl-stream.c

  * FIX: dwim_match/2 for single character mismatch.

  * ADDED: atom_chars/2, number_chars/2, atom_char/2, various new
    unix/1 arguments.

Version 2.0.4
=============

  * MODIFIED: Consult and friends (ensure_loaded, use_module, etc.)
    no longer change directory to the directory in which the file
    lives.  As a consequence, directives have to use prolog_load_context/2
    or source_location/2 to find the context directory of the directive.

    consult and related directives still load relative to the directory
    in which the currently loading file lives.

  * Added prolog_load_context/2 to provide context for directives.
    Actually moved from library(quintus) to the boot image as the
    predicate is now necessary.

  * Added -DO_RUNTIME support to make a version	that is more suitable
    for distribution of products: no profiling, no tracer, no readline
    and no interrupt handling.  Setup using configure --enable-runtime

Version 2.0.3
=============

  * Fixed: loading qlf files now push the source context while running
    a directive, so source_location/2 should work while executing a
    directive from a .qlf file.
  * Fixed: recognise MAP_ANONYMOUS for configuring mmap() based stacks.
  * Added feature(dynamic_stacks, Bool) for detection of virtual memory
    based stack management.
  * Fixed feature(open_shared_object, Bool) (Michael Kauschke)

Version 2.0.2
=============

  * Fixed pl [options] -c file ...
  * Improved VMI implementation for (if -> then ; else), \+ and (a;b).
    Reduces overhead of these to about 1/3th.
  * Added VMI support for fast calling of foreign system predicates that
    are called with only variable arguments (i.e. `test(X) :- integer(X)'
    is optimised; `test(X) :- integer(3)' is not).  Provides big speedup
    for fail, true, integer/1 (etc.), and many other commonly called
    foreign predicates.
  * Support for mmap() using MAP_ANON.  Avoids a file-descriptor and hopefully
    improves portability of dynamic stacks.
  * Fix for Solaris 2.4 mmap() detection.
  * Fix: added autoconf test for using asm("nop") in pl-wam.c or use slower
    but more portable C alternative (fixes RS/6000 version)

Version 2.0.1
=============

  * FIX in garbage collector of 2.0.0 was only half the story.  Should
    be ok now.  Thanks to Thomas Hoppe for supplying me with the error
    report.
  * FIX & performance: current_functor/2 with the first argument is
    instantiated.
  * Installation: the libraries are now installed as
    $(prefix)/lib/$(PL)-$(PLVERSION).  A possibly existing executable is moved
    from $(prefix)/bin/$(PL) to $(prefix)/bin/$(PL).old


Version 2.0.0
=============

  * Added `Quick Load File' compilation support.  See qcompile/1 and
    qload/1.  Alpha stage.
  * FIXED infrequent segmentation violation occurring on machines with
    dynamic stack management, but whose signal handler is not provided
    the address of the fault (Linux and Solaris 2 for example).  The
    crash can be in various foreign predicates that use the local stack
    as scratch area.
  * Important FIX to the garbage collector.  This bug may happen iff
    a garbage collection is invoked while clauses are active that have
    \+ or (a -> b ; c) constructs that are not yet active.  Generally
    the problem is reported as an inconsistency in the relocation count.
  * Fix to virtual machine encoding that applies to versions compiled
    with gcc 2.x and whose text-space starts at a high address.
  * Modified absolute_file_name/2 to take specifications of the
    form absolute_file_name(library('shell.pl'), X).
  * Various fixes to the new .qlf format and support for compiliation 
    of individual or combined sources into .qlf files.  .qlf files may
    now be loaded as normal sourcefiles instead of only as `boot' file.


Version 1.9.6:
==============

  * Fixed for BIG_ENDIAN machines (Intel, VAX, ...)
  * Windows version: added dde_execute/2
  * Added Quintus compatible foreign-language (C) interface.
  * Changed .qlf (former .wic) format drastically.  The current
    format gives about 30% shorter files and loads twice as fast.
  * Changed basic clause representation.  VM op-codes are now
    full machine words, avoiding the need for the `XR' table
    management and related indirections.  Simplifies the instruction set,
    speedup for compiler, decompiler (retract, clause) and execution
    (about 10%).  Enlarges program-size with about 10%.


Version 1.9.5:
==============

alpha-2

  * Fixed prolog_frame_attribute/3 for key=parent.
  * Added at_initialisation(+Goal) for initialisation hooks
  * Fixed tracer problems introduced in 1.9.5-alpla-1.


alpha-1

  * Moved sourcecode administration from predicate to individual
    clauses.  Purpose: better source-level debugger support, better
    handling of multifile predicates.

  * Recompiling files holding clauses for multifile predicates now
    works properly. The clauses of the latest loaded file will
    always be the last.

  * Removing a predicate from a file and recompiling the file
    now actually removes the definition from the Prolog database,
    even if you are not using modules.

  * Added prolog_frame_attribute(Frame, clause, ClauseRef) to get a
    reference to the currently running clause.

  * Added clause_property/2 to get the source information from a 
    specific clause.

  * Compiled state (-c compilation) has changed a little.  The system
    does not load old states.


Version 1.9.4.  Redefining system-predicates is no longer allowed.  This
may be overruled using  :-   redefine_system_predicate(+Head).   Fix  in
Makefile (from Kayvan Sylvan): fixes shell   syntax  error make install.
Give warning on user-files trying  to   load  module  `user' or `system'
(this is why library(system) could not   be loaded).  Fixed whereis/1 to
find locations of predicates.   Fixed   trace/[1,2]  to  avoid low-level
errors on bad specifications.  Specification now   also  accept the much
more natural ?- trace(append, fail).  as a shorthand for [+fail].  Added
autoloader handling to ed/1, listing/1, spy/1 and trace/2.  Manipulating
not-yet-loaded autoload predicates will trap the autoloader.  Added hook
for help-system, so we provide a   decent help-window when running under
the XPCE graphical environment.  The   hook  is called show_help_file/2.
Fixed  rename_file/2  (bug  introduced  in  pl-1.9.2).   Fixed  versions
Windows-specific problems.  Added  prolog_to_os_filename/2   to  convert
between internal and external names (DOS/Windows).  Integrated the 1.9.4
patches for the Windows  version.   Fixed   to  compile  on  AIX.  Fixed
compilation on some Solaris version.

Version  1.9.3.   Fix  index/1  problem    introduced   in  1.9.2.   Fix
stack-expansion problem in all versions that   lack hardware support for
stack-expansion.  Some cleanup in pl-gc.c to make clean compilation with
-Wall  and  -DO_DEBUG  possible.   Regenerated   common  prototype  file
pl-funcs.h using mkproto tool (and some editing).

Version 1.9.2.  Configuration is  now  based   on  GNU's  autoconf.  All
md-*.h files have been removed from  the distribution.  $arch/2, $home/1
and $version/1 have been replaced by feature/2.  A predicate read_link/3
has been added to read symbolic links.   Installation is tested on SunOs
4.1.3, Solaris 2.3 and Linux 1.0.9 with readline 2.0.3.

Version 1.9.1.  Added: Windows DDE   interface,  Added Unix/System-V (?)
interface to dlopen() and friends to access shared objects dynamically.

Version 1.9.0.  Incorporation of various  ports: md-netbsd.h, md-mswin.h
and  md-msdos.h.   There  is  a  binary   distribution  for  Windows  in
win-pl.tgz of the main ftp server (swi.psy.uva.nl).  The DOS and Windows
versions are created using the WATCOM-C/32 toolkit.


=======================================================================
Version 1.8.12.  Fixed tracer option `f' (fail) used on the exit port of
a goal.  Thanks to Thomas Hoppe.

Version 1.8.8.  Fix  in  the  parser   to  avoid  some  bad syntax-error
messages.  Also fixed spurious crashes   trying to read bad-syntax-terms
of the form ?- atom,.

New in the quintus.pl library:  initialization/1, random/3, numbervars/3
and absolute_file_name/3.

Version  1.8.7  includes   the    catch/throw-like   control  structures
block(+Label,  +Goal,  -Rval),  fail(+Label),  exit(+Label,  +Rval)  and
!(+Label).  Also new is explain(+Anything) which will  try to tell you a
lot of what the system knows about  the term you entered.  Additions and
suggesions are welcome.  Also new: library(bim): A partial Prolog-by-BIM
(tm) compatibility package by Henk Vandecasteele.  Thanks.

Further fixes:

	* Bug in detecting stack-overflow for the PC/linux version.
	* Handling of SWI_HOME_DIR (fixes installation problem for
 	  XPCE/SWI-Prolog).
	* atom_length/2: give warning (instead of crash) on invalid
	  data-type (e.g. unbound, term).
	* nth_clause/3: Removed errornous warning when cut-off and
	  fixed returning 0-reference for defined predicates without
	  clauses.

Version 1.8.6 defines phrase/[2,3] for accessing grammar rules and fixes
name/2 for numbers outside the  integer   range  (yielding  a float).  A
predicate nth_clause/3 is added to provide access to specific clauses of
predicates.  xmalloc(), xrealloc() are added to   fix some problems when
linking with gnu-libraries.

Version 1.8.5 contains a few fixes  for the SunOs-4/gcc-2.5 combination.
DONOT USE GCC-2.5.[123] as the optimiser   appears broken.  gcc-2.5.4 is
ok again.

Version 1.8.4 fixes =@=/2, contains a more  logical form of arg/3, fixes
passing empty-string arguments from the   Prolog  command-line and fixes
some things for old non-ansi compilers.    There  are some extensions to
the quintus.pl compatibility library.

Version 1.8.3 Fixes some  more  readline   problems  having  to  do with
running SWI-Prolog as an inferior process under EMACS.

Version 1.8.2 fixes some serious  problems   in  the tracer intoduced by
more global changes in 1.8.0.

Version 1.8.1 fixes load_foreign for  both   SunOs  4.1.3  and PC/Linux.
Extensive use of the stat(2) system call is reduced with some changes to
the file administration.  This speeds up loading  many small files by an
incredible amount, notably when reading over a (slow) network.

The manual is  regenerated.   There  are   not  many  changes,  but  the
PostScript files in these archives are  totally different as we upgrated
LaTeX and dvips.  Therefore  the   patch  file **diff-1.8.0-1.8.1** does
*not* include the patches to the PostScript manual.

Version 1.8.0 includes a stack  shifter,   enabling  dynamic  stacks for
machines that do not offer hardware support by providing suitable access
to  the  virtual  memory  management.    Fixed    a   bug  in  concat/3.
expand_file/2 is now sensitive to fileerrors/2   while expanding $var or
~user.   More  bugfixes  to  the    readline   interface.   Manual  page
contributed by Dave Sherrat.   RS6000  port   no  longer  uses -lbsd and
compiles on gcc.

================================================================
Version 1.7.2 should compile on Solaris 2.2   using gcc 2.4.5.  It fixes
the usual couple of portability problems,   the  terminal interface when
connected  to  the  XPCE  graphics  library.     It  ads  line_count  to
predicate_property to support a future graphical debugging tool.

Version 1.7.1 fixes a very serious   memory  allocation violation in the
connection to the readline library.  Make sure to update from 1.7.0!

Version 1.7.0 contains a version linked   with  the GNU readline library
for  bash/tcsh  compatible  line  editing.    The  library  readline  is
distributed separately and must be   installed before installing prolog.
The  file  readline-1.1.tar.gz  contains  the  unmodified  GNU  sources.
librl-1.1.tar.z contains the binaries for PC/Linux.

================================================================
Version 1.6.18 contains a fix to load_foreign/[2,5] for PC/Linux.

[Version 1.6.17 has been reinstalled at Jun  1 23:16 with two prototype
fixes and a fix to save_program/1 necessary for the RS6000.]

Version 1.6.17 fixes  some  minor   installation  problems  reported for
1.6.16.  The online manual has been   updated for trace/[1,2].  Callback
of undefined Prolog-predicates from C now correctly trap the autoloader.
Analysis of the PATH variable to  find   the  Prolog executable has been
fixed.  Nothing serious if you have a running system!

Version 1.6.16 integrates port to 386  System-V   Unix  made  by Eric S.
Raymond (esr@snark.thyrsus.com), who also ported   the  shell scripts to
use sh rather than csh.  The new   predicates  trace/1 and trace/2 allow
for tracing individual predicates non-interactively.

Version 1.6.15  eliminates  some  compiler  limits,   fixes  a  bug  in
trail-stacks management and provides a much   better  port for PC/Linux.
Requires Linux kernel 99pl7 or later.

Version 1.6.14 provides 8 bit character  support.  All characters in the
range 128 ...  255 are treated as   lowercase letters.  op/3 is fixed to
actually delete operators when priority 0 is specified.

Version 1.6.13 implements  standard  order   compatible  to  Quintus and
contains  a  fix  of  the  module  system  which  broke  the  Quintus.pl
replacement of retractall/1.

Version 1.6.12 is te result of  integrating   ports  to  LINUX, OS/2 and
HP/UX with the main-stream (SunOs).

